﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.IO;
using System.Threading;
using System.Runtime.InteropServices;
using Microsoft.Win32.SafeHandles; 

using EcatLib;
using EcatDef;
using EcatError;

namespace ECAT_M801_DEMO_MOTION_GROUP
{    
    public partial class Form1 : Form
    {
        [DllImport("kernel32.dll",
            EntryPoint = "GetStdHandle",
            SetLastError = true,
            CharSet = CharSet.Auto,
            CallingConvention = CallingConvention.StdCall)]
        private static extern IntPtr GetStdHandle(int nStdHandle);
        [DllImport("kernel32.dll",
            EntryPoint = "AllocConsole",
            SetLastError = true,
            CharSet = CharSet.Auto,
            CallingConvention = CallingConvention.StdCall)]
        private static extern int AllocConsole();
        private const int STD_OUTPUT_HANDLE = -11;
        private const int MY_CODE_PAGE = 437;

        public Variable Variables = new Variable();

        public Form1()
        {
            InitializeComponent();

            InitConsole();

            lstV_SlaveList.View = View.Details;
            lstV_SlaveList.Columns.Add("NO.");
            lstV_SlaveList.Columns.Add("Slave Name.");            
            lstV_SlaveList.Columns[0].Width = (int)((double)lstV_SlaveList.Width * 0.2);
            lstV_SlaveList.Columns[1].Width = (int)((double)lstV_SlaveList.Width * 0.8);
            lstV_SlaveList.BeginUpdate();

            lstV_AxesInfo.View = View.Details;
            lstV_AxesInfo.Columns.Add("Axis NO.");
            lstV_AxesInfo.Columns.Add("CmdPosition");
            lstV_AxesInfo.Columns.Add("Position");
            lstV_AxesInfo.Columns.Add("Velocity");
            lstV_AxesInfo.Columns.Add("Axis State");
            lstV_AxesInfo.Columns.Add("Axis Error");
            lstV_AxesInfo.Columns.Add("Drive Error");
            lstV_AxesInfo.Columns.Add("NOT");
            lstV_AxesInfo.Columns.Add("POT");
            lstV_AxesInfo.Columns.Add("ORG");
            lstV_AxesInfo.Columns.Add("ALM");
            lstV_AxesInfo.Columns.Add("WAN");
            lstV_AxesInfo.Columns.Add("SVN");
            lstV_AxesInfo.Columns.Add("VIR");
            lstV_AxesInfo.Columns[0].Width = (int)((double)lstV_AxesInfo.Width * 0.074);
            lstV_AxesInfo.Columns[1].Width = (int)((double)lstV_AxesInfo.Width * 0.1);
            lstV_AxesInfo.Columns[2].Width = (int)((double)lstV_AxesInfo.Width * 0.095);
            lstV_AxesInfo.Columns[3].Width = (int)((double)lstV_AxesInfo.Width * 0.095);
            lstV_AxesInfo.Columns[4].Width = (int)((double)lstV_AxesInfo.Width * 0.095);
            lstV_AxesInfo.Columns[5].Width = (int)((double)lstV_AxesInfo.Width * 0.095);
            lstV_AxesInfo.Columns[6].Width = (int)((double)lstV_AxesInfo.Width * 0.095);
            lstV_AxesInfo.Columns[7].Width = (int)((double)lstV_AxesInfo.Width * 0.05);
            lstV_AxesInfo.Columns[8].Width = (int)((double)lstV_AxesInfo.Width * 0.05);
            lstV_AxesInfo.Columns[9].Width = (int)((double)lstV_AxesInfo.Width * 0.05);
            lstV_AxesInfo.Columns[10].Width = (int)((double)lstV_AxesInfo.Width * 0.05);
            lstV_AxesInfo.Columns[11].Width = (int)((double)lstV_AxesInfo.Width * 0.05);
            lstV_AxesInfo.Columns[12].Width = (int)((double)lstV_AxesInfo.Width * 0.05);
            lstV_AxesInfo.Columns[13].Width = (int)((double)lstV_AxesInfo.Width * 0.05);
            lstV_AxesInfo.BeginUpdate();

            lstV_GroupInfo.View = View.Details;
            lstV_GroupInfo.Columns.Add("GroupNo");
            lstV_GroupInfo.Columns.Add("GroupState");
            lstV_GroupInfo.Columns.Add("CmdBuffer");
            lstV_GroupInfo.Columns.Add("AxisNo");
            lstV_GroupInfo.Columns[0].Width = (int)((double)lstV_GroupInfo.Width * 0.2);
            lstV_GroupInfo.Columns[1].Width = (int)((double)lstV_GroupInfo.Width * 0.25);
            lstV_GroupInfo.Columns[2].Width = (int)((double)lstV_GroupInfo.Width * 0.25);
            lstV_GroupInfo.Columns[3].Width = (int)((double)lstV_GroupInfo.Width * 0.3);
            lstV_GroupInfo.BeginUpdate();
           
            text_LineMoveVel.Text = "10000";
            text_LineMovePos.Text = "10000, 10000";
            
            cbx_GpCmdMode.Items.Clear();
            cbx_GpCmdMode.Items.Add("Aborting");
            cbx_GpCmdMode.Items.Add("Buffered");
            cbx_GpCmdMode.Items.Add("Blending");
            cbx_GpCmdMode.SelectedIndex = 1;

            text_GroupMovePosCt.Text = "10000, 0";            
            text_GroupMoveVel.Text = "10000";            
            text_GroupMoveAngle.Text = "360";            
            text_GroupMovePitch.Text = "10000";

            Variables.state = 0;
            Variables.isOP = false;
            int ret = 0;

            ret = InitDevice();
            if (ret < 0) return;
            ret = Opendevice();
            if (ret < 0) return;
            ret = Startoptask();
            if (ret < 0) return;
            ret = Initmotion();
            if (ret < 0) return;
            ret = SetAxisParam();
            if (ret < 0) return;
            ret = SetGroupParam();
            if (ret < 0) return;
        }

        private void InitConsole()
        {
            AllocConsole();
            IntPtr stdHandle = GetStdHandle(STD_OUTPUT_HANDLE);
            SafeFileHandle safeFileHandle = new SafeFileHandle(stdHandle, true);
            FileStream fileStream = new FileStream(safeFileHandle, FileAccess.Write);
            Encoding encoding = System.Text.Encoding.GetEncoding(MY_CODE_PAGE);
            StreamWriter standardOutput = new StreamWriter(fileStream, encoding);
            standardOutput.AutoFlush = true;
            Console.SetOut(standardOutput);
            Console.WriteLine("This text you can see in console window.");
        }

        public bool timeoutfunc(DateTime startTime)
        {
            DateTime currTime = DateTime.Now;
            TimeSpan diff_st = new TimeSpan(currTime.Ticks - startTime.Ticks);

            if (diff_st.TotalMilliseconds > Constants.TIME_OUT)
            {
                return true;
            }
            else return false;
        }

        public int InitDevice()
        {
            int ret;
            ushort DeviceCnt = 0;
            byte[] CardId = new byte[CEcatDef.CARD_DEVICE_NO_MAX];
            for (int i = 0; i < CardId.Count(); i++)
            {
                CardId[i] = 0;
            }
            ret = CEcatLib.ECAT_GetDeviceCnt(ref DeviceCnt, CardId);

            if (ret < 0)
            {
                text_state.Text = "InitDevice Failed";
                return -1;
            }
            else
            {
                if (DeviceCnt == 0)
                {
                    text_state.Text = "InitDevice Failed";
                    return -1;
                }
                text_state.Text = "InitDevice";
                Variables.DeviceNo = CardId[0];	//Get card id of first ECAT-M801 //there is a switch on ECAT-M801 can change card id
                return 0;
            }
        }

        private int Opendevice()
        {
            int ret = 0;
            string str1;

            ushort Alias = 0;
            uint ProductCode = 0, VendorID = 0, RevisionNo = 0, SerialNo = 0, SlaveType = 0;
            byte AlState = 0;

            ret = CEcatLib.ECAT_OpenDevice(Variables.DeviceNo);//Open first ECAT-M801 via card id

            if (ret < 0)
            {
                str1 = "Open Device failed, DeviceNo:" + Variables.DeviceNo.ToString() + ", ret:" + ret.ToString();
                text_state.Text = str1;
                return -1;
            }
            else
            {
                Console.WriteLine("Opendevice");
                uint LinkUp = 0, SlavesResp = 0, AlStates = 0, Wc = 0;
                CEcatLib.ECAT_StopDeviceOpTask(Variables.DeviceNo);
                for (ushort i = 0; i < 10; i++)
                {
                    ret = CEcatLib.ECAT_GetDeviceStateEx(Variables.DeviceNo, ref LinkUp, ref SlavesResp, ref AlStates, ref Wc);
                    if (ret == 0 && AlStates == CEcatDef.ECAT_AS_PREOP)
                        break;
                    Thread.Sleep(1000);
                }
                if (ret != 0 || AlStates != CEcatDef.ECAT_AS_PREOP)
                {
                    str1 = "ECAT_GetDeviceStateEx failed, State:" + SlavesResp.ToString() + ", ret:" + ret.ToString();
                    text_state.Text = str1;
                    return -1;
                }

                timer1.Interval = Constants.DEV_TIMER_CYCLE_TIME;
                timer1.Enabled = true;

                StringBuilder slvName = new StringBuilder("", CEcatDef.MAX_SLAVE_NAME_LENGTH);

                ret = CEcatLib.ECAT_SetSlaveNoType(Variables.DeviceNo, CEcatDef.SLAVE_NO_TYPE_POSITION);
                if (ret != 0)
                {
                    str1 = "SetSlaveNoType failed, DeviceNo:" + Variables.DeviceNo.ToString() + ", ret:" + ret.ToString();
                    text_state.Text = str1;
                    return -1;
                }
                
                //Get status of ECAT-M801 
                ret = CEcatLib.ECAT_GetDeviceState(Variables.DeviceNo, ref LinkUp, ref SlavesResp, ref AlStates, ref Wc);

                if (ret == 0)
                {
                    lstV_SlaveList.Items.Clear();

                    for (ushort i = 0; i < SlavesResp; i++)
                    {
                        //Get Slave information via the position of the module in the ethercat network
                        ret = CEcatLib.ECAT_GetSlaveInfo(Variables.DeviceNo, i, ref Alias, ref ProductCode,
                                ref VendorID, ref RevisionNo, ref SerialNo, ref AlState, ref SlaveType, slvName);

                        lstV_SlaveList.Items.Add(i.ToString("D"), i.ToString("D"), 0);
                        if (ret == 0)
                            lstV_SlaveList.Items[i.ToString("D")].SubItems.Add(slvName.ToString());
                    }
                }

                ret = CEcatLib.ECAT_SetSlaveNoType(Variables.DeviceNo, CEcatDef.SLAVE_NO_TYPE_ALIAS_ID);
                if (ret != 0)
                {
                    str1 = "SetSlaveNoType failed, DeviceNo:" + Variables.DeviceNo.ToString() + ", ret:" + ret.ToString();
                    text_state.Text = str1;
                    return -1;
                }
                return 0;
            }
        }        

        private int Startoptask()
        {
            Console.WriteLine("Startoptask");
            int ret = 0;
            ushort NetworkInfoNo = 0;
            byte EnumCycleTime = 0;//1ms
            uint WcErrCnt = 3;//Tolerance of Ethercat communication Error 


            for (ushort i = 0; i < 10; i++)
            {
                ret = CEcatLib.ECAT_StartDeviceOpTask(Variables.DeviceNo, NetworkInfoNo, EnumCycleTime, WcErrCnt);
                if (ret == 0)
                    break;
                Thread.Sleep(1000);
            }

            if (ret < 0)
            {
                text_state.Text = "Op Failed";
                return -1;
            }
            else
            {
                uint LinkUp = 0, SlavesResp = 0, AlStates = 0, Wc = 0;
                text_state.Text = "Oping...";
                for (ushort i = 0; i < 30; i++)
                {
                    ret = CEcatLib.ECAT_GetDeviceStateEx(Variables.DeviceNo, ref LinkUp, ref SlavesResp, ref AlStates, ref Wc);
                    if (ret == 0 && AlStates == CEcatDef.ECAT_AS_OP)
                        break;
                    Thread.Sleep(1000);
                }
                if (ret != 0 || AlStates != CEcatDef.ECAT_AS_OP)
                {
                    text_state.Text = "Op Failed";
                    return -1;
                }
                else
                {
                    text_state.Text = "OP";
                    return 0;
                }
            }
        }
        private void CheckMotionDone()
        {
            if (!Variables.checkMotionDone)
                return;
            int ret;
            uint u32Value = 0;
            int lastError = 0;//from master
            ushort DriveError = 0;//from motor driver
            double actual_Pos = 0;
            string str1 = "";
            ret = CEcatLib.ECAT_McGetGroupState(Variables.DeviceNo, Variables.GroupNo, ref u32Value);
            if (ret == 0)
            {
                if (u32Value == CEcatDef.MC_GS_ERRORSTOP)
                {
                    ret = CEcatLib.ECAT_McGetAxisLastError_Ex(Variables.DeviceNo, Variables.AxisNo, ref lastError);
                    str1 = "LastError: " + lastError.ToString("D") + "ret:" + ret.ToString("D");
                    Console.WriteLine(str1);
                    ret = CEcatLib.ECAT_McGetAxisDriveError_Ex(Variables.DeviceNo, Variables.AxisNo, ref DriveError);
                    str1 = "DriveError: " + DriveError.ToString("D") + "ret:" + ret.ToString("D");
                    Console.WriteLine(str1);
                    text_state.Text = "Error occurred";
                    Variables.checkMotionDone = false;
                }
                else if (u32Value == CEcatDef.MC_GS_STANDBY)
                {
                    text_state.Text = "Move Done";
                    Variables.checkMotionDone = false;
                }
            }
        }
        private void UpdateDeviceState(uint LinkUp, uint SlavesResp, uint AlStates, uint Wc)
        {
            string strAlState;
                text_SlavesResp.Text = "Slave(s):" + SlavesResp.ToString();

                if (AlStates == 0)
                {
                    strAlState = "INIT";
                    Variables.isOP = false;
                }
                else if (AlStates == 0x02)
                {
                    strAlState = "PREOP";
                    Variables.isOP = false;
                }
                else if (AlStates == 0x04)
                {
                    strAlState = "SAFEOP";
                    Variables.isOP = false;
                }
                else if (AlStates == 0x08)
                {
                    if (Variables.isOP == false)
                    {
                        text_AlStates.Text = "Op";
                    }
                    strAlState = "OP";
                    Variables.isOP = true;
                }
                else
                {
                    strAlState = "Unknown";
                    Variables.isOP = false;
                }

                text_AlStates.Text = strAlState;
                text_Wc.Text = "WC:" + Wc.ToString();

                if (LinkUp != 0)
                {
                    text_LinkUp.Text = "Up";
                }
                else
                {
                    text_LinkUp.Text = "Down";
                }
            }
        private void timer1_Tick(object sender, EventArgs e)
        {
            int ret;
            string strAlState;
            uint LinkUp = 0, SlavesResp = 0, AlStates = 0, Wc = 0;

            ret = CEcatLib.ECAT_GetDeviceStateEx(Variables.DeviceNo, ref LinkUp, ref SlavesResp, ref AlStates, ref Wc);
            if (ret == 0)
            {
                UpdateDeviceState(LinkUp, SlavesResp, AlStates, Wc);
            }
            if (Variables.isOP)
            {
                ModuleProcess();
                CheckMotionDone();
            }
        }

        private int Initmotion()
        {
	        int ret = 0;
            string str1 = "";
            ushort[] McSlaveNo = new ushort[CEcatDef.MC_AXIS_NO_MAX];
            ushort[] McSubAxisNo = new ushort[CEcatDef.MC_AXIS_NO_MAX];

            Variables.startTime = DateTime.Now;
            //Please use ECAT_Utility.exe to create  Motion Control Parameter File(.motcfg)
            ret = CEcatLib.ECAT_McInit_Ex(Variables.DeviceNo, "Auto.motcfg", McSlaveNo, McSubAxisNo, ref Variables.AxisCnt);

	        if(ret < 0)
	        {
                if (ret == -1027)
                {
                    Console.WriteLine("Please use ECAT_Utility.exe to create Motion Control Parameter File(.motcfg)");
                }
                else
                {
                str1 = "Failed to initialize axes: " + ret.ToString("D");
		        Console.WriteLine(str1);
                }
		        return -1;
	        }

	        text_state.Text = "InitMotion";

	        for(int i=0;i<Variables.AxisCnt;i++)
	        {
                lstV_AxesInfo.Items.Add(i.ToString("D"), i.ToString("D"), 0);  // AxisNo
                lstV_AxesInfo.Items[i.ToString("D")].SubItems.Add("");         // AxisNo
                lstV_AxesInfo.Items[i.ToString("D")].SubItems.Add("");         // CmdPosition
                lstV_AxesInfo.Items[i.ToString("D")].SubItems.Add("");         // Position
                lstV_AxesInfo.Items[i.ToString("D")].SubItems.Add("");         // Velocity
                lstV_AxesInfo.Items[i.ToString("D")].SubItems.Add("");         // AxisState
                lstV_AxesInfo.Items[i.ToString("D")].SubItems.Add("");         // AxisError
                lstV_AxesInfo.Items[i.ToString("D")].SubItems.Add("");         // DriverError
                lstV_AxesInfo.Items[i.ToString("D")].SubItems.Add("");         // NOT
                lstV_AxesInfo.Items[i.ToString("D")].SubItems.Add("");         // POT
                lstV_AxesInfo.Items[i.ToString("D")].SubItems.Add("");         // ORG
                lstV_AxesInfo.Items[i.ToString("D")].SubItems.Add("");         // ALM
                lstV_AxesInfo.Items[i.ToString("D")].SubItems.Add("");         // WAN
                lstV_AxesInfo.Items[i.ToString("D")].SubItems.Add("");         // SVN
                lstV_AxesInfo.Items[i.ToString("D")].SubItems.Add("");         // VIR

	        }
	        Variables.AxisNo = 0;// First Axis
	        Variables.state++;
	        return 0;
        }

        private int SetAxisParam()
        {
	        string str1 = "";
	        int ret = 0;
	        text_state.Text = "SetAxisParam";

	        for(ushort AxisNo=0;AxisNo<Variables.AxisCnt;AxisNo++)
	        {
                /*
		        //These parameters have been set in ECAT_McInit_Ex
		        ret = CEcatLib.ECAT_McSetAxisPPU(Variables.DeviceNo, AxisNo, 1);
		        if(ret < 0)
		        {
                    str1 = "AxisNo[" + AxisNo.ToString("D") + "]:Failed to set axis PPU:" + ret.ToString("D");
		            Console.WriteLine(str1);			        
			        return ret;
		        }

		        ret = CEcatLib.ECAT_McSetAxisHomeMethod(Variables.DeviceNo, AxisNo, 37);
		        if(ret < 0)
		        {
                    str1 = "AxisNo[" + AxisNo.ToString("D") + "]:Failed to set axis home method:" + ret.ToString("D");
		            Console.WriteLine(str1);	
			        return ret;
		        }

		        ret = CEcatLib.ECAT_McSetAxisHomeSpeed(Variables.DeviceNo,AxisNo, 10000, 1000);
		        if(ret < 0)
		        {
                    str1 = "AxisNo[" + AxisNo.ToString("D") + "]:Failed to set axis home speed:" + ret.ToString("D");
		            Console.WriteLine(str1);			        
			        return ret;
		        }

		        ret = CEcatLib.ECAT_McSetAxisHomeAcc(Variables.DeviceNo,AxisNo, 100000);
		        if(ret < 0)
		        {
                    str1 = "AxisNo[" + AxisNo.ToString("D") + "]:Failed to set axis home acc:" + ret.ToString("D");
		            Console.WriteLine(str1);			        
			        return ret;
		        }
                */
                ret = CEcatLib.ECAT_McSetAxisAccTime(Variables.DeviceNo, AxisNo, 100);//ms
                if (ret < 0)
                {
                    str1 = "AxisNo[" + AxisNo.ToString("D") + "]:Failed to set axis acc time:" + ret.ToString("D");
                    Console.WriteLine(str1);
                    return ret;
                }

                do
                {
                    /*
                    when error occurred on master or motor driver
                    it will take few ms to process error
                    in the meantime, ServoOn or ErrorReset will return -1137

                    P.S. ServoOn also has the function of clearing errors
                    */
                    ret = CEcatLib.ECAT_McSetAxisServoOn(Variables.DeviceNo, AxisNo, 1);
                } while (ret == -1137);
                uint u32Value = 0;
                for (ushort i = 0; i < 10; i++)
                {
                    /*
                    it will take few ms to process ServoOn
                    when motor driver is ready, axis state should be standstill
                    */
                    ret = CEcatLib.ECAT_McGetAxisState_Ex(Variables.DeviceNo, AxisNo, ref u32Value);
                    if (ret == 0 && u32Value == CEcatDef.MC_AS_STANDSTILL)
                        break;
                    Thread.Sleep(100);
                }
                if (ret != 0 || u32Value != CEcatDef.MC_AS_STANDSTILL)
                {
                    str1 = "Failed to Servo On:ret: " + ret.ToString("D") + "dState:" + u32Value.ToString("D");
                    Console.WriteLine(str1);
                    return -1;
                }
            }

            Variables.state++;
            text_state.Text = "-------";	        
	        return 0;
        }

        private int SetGroupParam()
        {
            string str1 = "", str2 = "";
            int ret = 0;
            text_state.Text = "SetGroupParam";
            
            ushort AddCnt = 0;
            Variables.GroupNo = 0;

            Variables.GroupCnt = 0;
            for (ushort i = 0; i < Variables.AxisCnt; i++)
            {
                ret = CEcatLib.ECAT_McAddAxisToGroup_Ex(Variables.DeviceNo, Variables.GroupNo, i);

                if (ret < 0)
                {
                    str1 = "Failed to add axis [" + i.ToString() + "] to group [" + Variables.GroupNo.ToString() + "]: " + ret.ToString();
                    Console.WriteLine(str1);
                    return ret;
                }
                else
                {
                    if (AddCnt == 0) str1 = i.ToString();
                    else str1 = ", " + i.ToString();
                    str2 += str1;
                    AddCnt++;
                }
            }
            ret = CEcatLib.ECAT_McSetGroupAccTimeEx(Variables.DeviceNo, Variables.GroupNo, 100);//ms
            if (ret < 0)
            {
                str1 = "Failed to Set group acc time: " + ret.ToString();
                Console.WriteLine(str1);
                return ret;
            }

            Variables.GroupCnt++;

            lstV_GroupInfo.Items.Add(Variables.GroupNo.ToString("D"), Variables.GroupNo.ToString("D"), 0);  // GroupNo
            lstV_GroupInfo.Items[Variables.GroupNo.ToString("D")].SubItems.Add("");         // GroupNo
            lstV_GroupInfo.Items[Variables.GroupNo.ToString("D")].SubItems.Add("");         // GroupState
            lstV_GroupInfo.Items[Variables.GroupNo.ToString("D")].SubItems.Add("");         // CmdBuffer
            lstV_GroupInfo.Items[Variables.GroupNo.ToString("D")].SubItems.Add("");         // AxisNo

            lstV_GroupInfo.Items[Variables.GroupNo].SubItems[3].Text = str2;

            Variables.state++;
            text_state.Text = "-------";	 
            return 0;
        }

        private int ModuleProcess()
        {
	        double dValue = 0;
            uint u32Value = 0;
            int i32Value = 0;
            ushort u16Value = 0;
            uint AxisDI = 0;
            uint BitDI = 0;
            int ColIndex = 0;

	        int ret;
            string str1 = "";

            for (ushort AxisNo = 0; AxisNo < Variables.AxisCnt; AxisNo++)
            {
                ColIndex = 1;
                ret = CEcatLib.ECAT_McGetAxisCommandPos_Ex(Variables.DeviceNo, AxisNo, ref dValue);
                if (ret == 0)
                {
                    str1 = dValue.ToString("#0.000");
                    lstV_AxesInfo.Items[AxisNo].SubItems[ColIndex].Text = str1;                  
                }

                ColIndex++;
                ret = CEcatLib.ECAT_McGetAxisActualPos_Ex(Variables.DeviceNo, AxisNo, ref dValue);
                if (ret == 0)
                {  
                    str1 = dValue.ToString("#0.000");
                    lstV_AxesInfo.Items[AxisNo].SubItems[ColIndex].Text = str1;                
                }

                ColIndex++;
                ret = CEcatLib.ECAT_McGetAxisActualVel_Ex(Variables.DeviceNo, AxisNo, ref dValue);
                if (ret == 0)
                {
                    str1 = dValue.ToString("#0.0");
                    lstV_AxesInfo.Items[AxisNo].SubItems[ColIndex].Text = str1;
                }

                ColIndex++;
                ret = CEcatLib.ECAT_McGetAxisState_Ex(Variables.DeviceNo, AxisNo, ref u32Value);
                if (ret == 0)
                {
                    lstV_AxesInfo.Items[AxisNo].SubItems[ColIndex].Text = GetAxisStateStr(u32Value);                
                }

                ColIndex++;
                ret = CEcatLib.ECAT_McGetAxisLastError_Ex(Variables.DeviceNo, AxisNo, ref i32Value);
                if (ret == 0)
                {
                    str1 = i32Value.ToString();
                    lstV_AxesInfo.Items[AxisNo].SubItems[ColIndex].Text = str1;
                }

                ColIndex++;
                ret = CEcatLib.ECAT_McGetAxisDriveError_Ex(Variables.DeviceNo, AxisNo, ref u16Value);
                if (ret == 0)
                {                
                    str1 = u16Value.ToString();
                    lstV_AxesInfo.Items[AxisNo].SubItems[ColIndex].Text = str1;                
                }

                ret = CEcatLib.ECAT_McGetAxisDI_Ex(Variables.DeviceNo, AxisNo, ref AxisDI);
	            if(ret == 0)
	            {
		            ColIndex++;
                
		            BitDI = 1;
                    for (int j = ColIndex; j < lstV_AxesInfo.Columns.Count; j++)
		            {
                        if ((AxisDI & BitDI) != 0)
                            lstV_AxesInfo.Items[AxisNo].SubItems[j].Text = "1";
                        else
                            lstV_AxesInfo.Items[AxisNo].SubItems[j].Text = "0";
			            BitDI = BitDI << 1;
		            }		
	            }
            }

            for (ushort i = 0; i < Variables.GroupCnt; i++)
            {
                ret = CEcatLib.ECAT_McGetGroupState(Variables.DeviceNo, i, ref u32Value);
                if (ret == 0)
                {
                    lstV_GroupInfo.Items[i].SubItems[1].Text = GetGrpStateStr(u32Value);
                }

                ret = CEcatLib.ECAT_McGetGroupCmdBuffer(Variables.DeviceNo, i, ref u16Value);
                if (ret == 0)
                {
                    str1 = u16Value.ToString();
                    lstV_GroupInfo.Items[i].SubItems[2].Text = str1;
                }
            }

            return 0;
        }

        string GetAxisStateStr(uint state)
        {
            switch (state)
            {
                case CEcatDef.MC_AS_DISABLED:
                    return "Disabled";
                case CEcatDef.MC_AS_STANDSTILL:
                    return "StandStill";
                case CEcatDef.MC_AS_ERRORSTOP:
                    return "ErrorStop";
                case CEcatDef.MC_AS_STOPPING:
                    return "Stopping";
                case CEcatDef.MC_AS_HOMING:
                    return "Homing";
                case CEcatDef.MC_AS_DISCRETEMOTION:
                    return "DiscMotion";
                case CEcatDef.MC_AS_CONTINUOUSMOTION:
                    return "ContMotion";
                case CEcatDef.MC_AS_SYNCHRONIZEDMOTION:
                    return "SyncMotion";
                default:
                    return "Invalid";
            }
        }

        public string GetGrpStateStr(uint state)
        {
            switch (state)
            {
                case CEcatDef.MC_GS_DISABLED:
                    return "Disabled";
                case CEcatDef.MC_GS_STANDBY:
                    return "Standby";
                case CEcatDef.MC_GS_ERRORSTOP:
                    return "ErrorStop";
                case CEcatDef.MC_GS_STOPPING:
                    return "Stopping";
                case CEcatDef.MC_GS_HOMING:
                    return "Homing";
                case CEcatDef.MC_GS_MOVING:
                    return "Moving";
                default:
                    return "Invalid";
            }
        }                        
               
        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            for (ushort i = 0; i < Variables.AxisCnt; i++)
            {
                CEcatLib.ECAT_McSetAxisServoOn(Variables.DeviceNo, i, 0);
                Thread.Sleep(100);
            }
            CEcatLib.ECAT_StopDeviceOpTask(Variables.DeviceNo);
            CEcatLib.ECAT_CloseDevice(Variables.DeviceNo);
        }        

        private void btn_SetGpCmdMode_Click(object sender, EventArgs e)
        {
            int ret = 0;
            string str1 = "";
            ushort GpCmdMode = (ushort)cbx_GpCmdMode.SelectedIndex;

            ret = CEcatLib.ECAT_McSetGroupCmdMode_Ex(Variables.DeviceNo, Variables.GroupNo, GpCmdMode);
            if (ret < 0)
            {
                str1 = "Failed to set group cmd mode: " + ret.ToString("D");
                Console.WriteLine(str1);
            }
        }

        private void btn_GpLineMoveAbs_Click(object sender, EventArgs e)
        {
            int ret = 0;
            double[] Pos = new double[CEcatDef.MC_AXIS_NO_MAX];
            double Vel = 0;
            string str1;

            int nPos = 0;    // number of position cmd to axes
            string[] strPosData;

            str1 = text_LineMovePos.Text;
            if (str1 != "")
            {
                strPosData = str1.Split(',');
                foreach (string tmp in strPosData)
                {
                    Pos[nPos] = Convert.ToDouble(tmp);
                    nPos++;
                }
            }
            else
            {
                Console.WriteLine("group line move error: position cmd empty");
                return;
            }

            str1 = text_LineMoveVel.Text;
            Vel = Convert.ToDouble(str1);

            ret = CEcatLib.ECAT_McGroupMoveLineAbs_Ex(Variables.DeviceNo, Variables.GroupNo, Pos, Vel);
            if (ret < 0)
            {
                str1 = "Group 0 MoveLineAbs failed: " + ret.ToString();
                Console.WriteLine(str1);
            }
            else
            {
                text_state.Text = "Moving";
                Variables.checkMotionDone = true;
            }
        }

        private void btn_GpLineMoveRel_Click(object sender, EventArgs e)
        {
            int ret = 0;
            double[] Pos = new double[CEcatDef.MC_AXIS_NO_MAX];
            double Vel = 0;
            string str1;

            int nPos = 0;    // number of position cmd to axes
            string[] strPosData;

            str1 = text_LineMovePos.Text;
            if (str1 != "")
            {
                strPosData = str1.Split(',');
                foreach (string tmp in strPosData)
                {
                    Pos[nPos] = Convert.ToDouble(tmp);
                    nPos++;
                }
            }
            else
            {
                Console.WriteLine("group line move error: position cmd empty");
                return;
            }

            str1 = text_LineMoveVel.Text;
            Vel = Convert.ToDouble(str1);

            ret = CEcatLib.ECAT_McGroupMoveLineRel_Ex(Variables.DeviceNo, Variables.GroupNo, Pos, Vel);

            if (ret < 0)
            {
                str1 = "Group 0 MoveLineRel failed: " + ret.ToString();
                Console.WriteLine(str1);
            }
            else
            {
                text_state.Text = "Moving";
                Variables.checkMotionDone = true;
            }
        }

        private void btn_GroupStop_Click(object sender, EventArgs e)
        {
            int ret = 0;
            string str1;            

            ret = CEcatLib.ECAT_McGroupStop(Variables.DeviceNo, Variables.GroupNo);

            if (ret < 0)
            {
                str1 = "Group 0 Stop failed: " + ret.ToString();
                Console.WriteLine(str1);
            }
        }

        private void btn_GroupQuickStop_Click(object sender, EventArgs e)
        {
            int ret = 0;
            string str1;

            ret = CEcatLib.ECAT_McGroupQuickStop(Variables.DeviceNo, Variables.GroupNo);

            if (ret < 0)
            {
                str1 = "Group 0 QuickStop failed: " + ret.ToString();
                Console.WriteLine(str1);
            }
        }

        private void btn_AxesErrorReset_Click(object sender, EventArgs e)
        {
            int ret = 0;
            string str1 = "";

            for (ushort i = 0; i < Variables.AxisCnt; i++)
            {
                do
                {
                    /*
                    when error occurred on master or motor driver
                    it will take few ms to process error
                    in the meantime, ServoOn or ErrorReset will return -1137

                    P.S. ServoOn also has the function of clearing errors
                    */
                    ret = CEcatLib.ECAT_McAxisErrorReset(Variables.DeviceNo, i);
                } while (ret == -1137);
                if (ret < 0)
                {
                    str1 = "Axis[" + i.ToString() + "] ResetError failed: " + ret.ToString();
                    Console.WriteLine(str1);
                }
                else
                {
                    /*
                    it will take few ms to process Error Reset
                    when motor driver is ready, axis state should be standstill
                    */
                    uint u32Value = 0;
                    for (ushort j = 0; j < 10; j++)
                    {
                        ret = CEcatLib.ECAT_McGetAxisState_Ex(Variables.DeviceNo, i, ref u32Value);
                        if (ret == 0 && (u32Value == CEcatDef.MC_AS_STANDSTILL || u32Value == CEcatDef.MC_AS_DISABLED))
                            break;
                        Thread.Sleep(100);
                    }
                    if (ret != 0 || (u32Value != CEcatDef.MC_AS_STANDSTILL && u32Value != CEcatDef.MC_AS_DISABLED))
                    {
                        str1 = "Axis[" + i.ToString() + "] ResetError failed: " + ret.ToString();
                        Console.WriteLine(str1);
                    }
                }
            }
        }

        private void btn_GpCircularAbs_Click(object sender, EventArgs e)
        {
            int ret = 0;
            string str1 = "";

            double[] Pos_Ct = new double[CEcatDef.MC_AXIS_NO_MAX];
            double Vel = 0, Ang = 0;

            int nPos = 0;    // number of position cmd to axes
            string[] strPosData;

            str1 = text_GroupMovePosCt.Text;
            if (str1 != "")
            {
                strPosData = str1.Split(',');
                foreach (string tmp in strPosData)
                {
                    Pos_Ct[nPos] = Convert.ToDouble(tmp);
                    nPos++;
                }
            }
            else
            {
                Console.WriteLine("group circluar move error: position cmd empty");
                return;
            }

            str1 = text_GroupMoveVel.Text;
            Vel = Convert.ToDouble(str1);

            str1 = text_GroupMoveAngle.Text;
            Ang = Convert.ToDouble(str1);

            ret = CEcatLib.ECAT_McGroupMoveCircularAbs_CP_Angle_Ex(Variables.DeviceNo, Variables.GroupNo, Vel, Ang, Pos_Ct);

            if (ret < 0)
            {
                str1 = "Group 0 Move CircularAbs failed: " + ret.ToString();
                Console.WriteLine(str1);
            }
            else
            {
                text_state.Text = "Moving";
                Variables.checkMotionDone = true;
            }
        }

        private void btn_GpCircularRel_Click(object sender, EventArgs e)
        {
            int ret = 0;
            string str1 = "";

            double[] Pos_Ct = new double[CEcatDef.MC_AXIS_NO_MAX];
            double Vel = 0, Ang = 0;

            int nPos = 0;    // number of position cmd to axes
            string[] strPosData;

            str1 = text_GroupMovePosCt.Text;
            if (str1 != "")
            {
                strPosData = str1.Split(',');
                foreach (string tmp in strPosData)
                {
                    Pos_Ct[nPos] = Convert.ToDouble(tmp);
                    nPos++;
                }
            }
            else
            {
                Console.WriteLine("group circluar move error: position cmd empty");
                return;
            }

            str1 = text_GroupMoveVel.Text;
            Vel = Convert.ToDouble(str1);

            str1 = text_GroupMoveAngle.Text;
            Ang = Convert.ToDouble(str1);

            ret = CEcatLib.ECAT_McGroupMoveCircularRel_CP_Angle_Ex(Variables.DeviceNo, Variables.GroupNo, Vel, Ang, Pos_Ct);

            if (ret < 0)
            {
                str1 = "Group 0 Move CircularRel failed: " + ret.ToString();
                Console.WriteLine(str1);
            }
            else
            {
                text_state.Text = "Moving";
                Variables.checkMotionDone = true;
            }
        }

        private void btn_GpHelicalAbs_Click(object sender, EventArgs e)
        {
            int ret = 0;
            string str1 = "";

            double[] Pos_Ct = new double[CEcatDef.MC_AXIS_NO_MAX];
            double Vel = 0, Ang = 0, Pitch = 0;

            int nPos = 0;    // number of position cmd to axes
            string[] strPosData;

            str1 = text_GroupMovePosCt.Text;
            if (str1 != "")
            {
                strPosData = str1.Split(',');
                foreach (string tmp in strPosData)
                {
                    Pos_Ct[nPos] = Convert.ToDouble(tmp);
                    nPos++;
                }
            }
            else
            {
                Console.WriteLine("group circluar move error: position cmd empty");
                return;
            }

            str1 = text_GroupMoveVel.Text;
            Vel = Convert.ToDouble(str1);

            str1 = text_GroupMoveAngle.Text;
            Ang = Convert.ToDouble(str1);

            str1 = text_GroupMovePitch.Text;
            Pitch = Convert.ToDouble(str1);

            ret = CEcatLib.ECAT_McGroupMoveHelicalAbs_Ex(Variables.DeviceNo, Variables.GroupNo, Ang, Pos_Ct, Pitch, Vel);

            if (ret < 0)
            {
                str1 = "Group 0 Move HelicalAbs failed: " + ret.ToString();
                Console.WriteLine(str1);
            }
            else
            {
                text_state.Text = "Moving";
                Variables.checkMotionDone = true;
            }
        }

        private void btn_GpHelicalRel_Click(object sender, EventArgs e)
        {
            int ret = 0;
            string str1 = "";

            double[] Pos_Ct = new double[CEcatDef.MC_AXIS_NO_MAX];
            double Vel = 0, Ang = 0, Pitch = 0;

            int nPos = 0;    // number of position cmd to axes
            string[] strPosData;

            str1 = text_GroupMovePosCt.Text;
            if (str1 != "")
            {
                strPosData = str1.Split(',');
                foreach (string tmp in strPosData)
                {
                    Pos_Ct[nPos] = Convert.ToDouble(tmp);
                    nPos++;
                }
            }
            else
            {
                Console.WriteLine("group circluar move error: position cmd empty");
                return;
            }

            str1 = text_GroupMoveVel.Text;
            Vel = Convert.ToDouble(str1);

            str1 = text_GroupMoveAngle.Text;
            Ang = Convert.ToDouble(str1);

            str1 = text_GroupMovePitch.Text;
            Pitch = Convert.ToDouble(str1);

            ret = CEcatLib.ECAT_McGroupMoveHelicalRel_Ex(Variables.DeviceNo, Variables.GroupNo, Ang, Pos_Ct, Pitch, Vel);
            if (ret < 0)
            {
                str1 = "Group 0 Move HelicalRel failed: " + ret.ToString();
                Console.WriteLine(str1);
            }
            else
            {
                text_state.Text = "Moving";
                Variables.checkMotionDone = true;
            }
        }
    }

    static class Constants
    {
        public const int TIME_OUT = 3;
        public const int DEV_TIMER_CYCLE_TIME = 30; //ms
    }
    public class Variable
    {
        public ushort DeviceNo;
        public bool isOP;
        public int state;
        public ushort AxisCnt;
        public ushort AxisNo;
        public ushort GroupCnt;
        public ushort GroupNo;
        public DateTime startTime;
        public bool checkMotionDone;
        public double TargetPos;
    }
}
