﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.IO;
using System.Threading;
using System.Runtime.InteropServices;
using Microsoft.Win32.SafeHandles; 

using EcatLib;
using EcatDef;
using EcatError;

namespace ECAT_M801_DEMO_MOTION_SINGLE_AXIS
{
    public partial class Form1 : Form
    {
        [DllImport("kernel32.dll",
            EntryPoint = "GetStdHandle",
            SetLastError = true,
            CharSet = CharSet.Auto,
            CallingConvention = CallingConvention.StdCall)]
        private static extern IntPtr GetStdHandle(int nStdHandle);
        [DllImport("kernel32.dll",
            EntryPoint = "AllocConsole",
            SetLastError = true,
            CharSet = CharSet.Auto,
            CallingConvention = CallingConvention.StdCall)]
        private static extern int AllocConsole();
        private const int STD_OUTPUT_HANDLE = -11;
        private const int MY_CODE_PAGE = 437;


        public Form1()
        {
            InitializeComponent();

            InitConsole();

            lstV_SlaveList.View = View.Details;
            lstV_SlaveList.Columns.Add("NO.");
            lstV_SlaveList.Columns.Add("Slave Name.");            
            lstV_SlaveList.Columns[0].Width = (int)((double)lstV_SlaveList.Width * 0.2);
            lstV_SlaveList.Columns[1].Width = (int)((double)lstV_SlaveList.Width * 0.8);
            lstV_SlaveList.BeginUpdate();

            lstV_AxesInfo.View = View.Details;
            lstV_AxesInfo.Columns.Add("Axis NO.");
            lstV_AxesInfo.Columns.Add("CmdPosition");
            lstV_AxesInfo.Columns.Add("Position");
            lstV_AxesInfo.Columns.Add("Velocity");
            lstV_AxesInfo.Columns.Add("Axis State");
            lstV_AxesInfo.Columns.Add("Axis Error");
            lstV_AxesInfo.Columns.Add("Drive Error");
            lstV_AxesInfo.Columns.Add("NOT");
            lstV_AxesInfo.Columns.Add("POT");
            lstV_AxesInfo.Columns.Add("ORG");
            lstV_AxesInfo.Columns.Add("ALM");
            lstV_AxesInfo.Columns.Add("WAN");
            lstV_AxesInfo.Columns.Add("SVN");
            lstV_AxesInfo.Columns.Add("VIR");
            lstV_AxesInfo.Columns[0].Width = (int)((double)lstV_AxesInfo.Width * 0.075);
            lstV_AxesInfo.Columns[1].Width = (int)((double)lstV_AxesInfo.Width * 0.1);
            lstV_AxesInfo.Columns[2].Width = (int)((double)lstV_AxesInfo.Width * 0.095);
            lstV_AxesInfo.Columns[3].Width = (int)((double)lstV_AxesInfo.Width * 0.095);
            lstV_AxesInfo.Columns[4].Width = (int)((double)lstV_AxesInfo.Width * 0.095);
            lstV_AxesInfo.Columns[5].Width = (int)((double)lstV_AxesInfo.Width * 0.095);
            lstV_AxesInfo.Columns[6].Width = (int)((double)lstV_AxesInfo.Width * 0.095);
            lstV_AxesInfo.Columns[7].Width = (int)((double)lstV_AxesInfo.Width * 0.05);
            lstV_AxesInfo.Columns[8].Width = (int)((double)lstV_AxesInfo.Width * 0.05);
            lstV_AxesInfo.Columns[9].Width = (int)((double)lstV_AxesInfo.Width * 0.05);
            lstV_AxesInfo.Columns[10].Width = (int)((double)lstV_AxesInfo.Width * 0.05);
            lstV_AxesInfo.Columns[11].Width = (int)((double)lstV_AxesInfo.Width * 0.05);
            lstV_AxesInfo.Columns[12].Width = (int)((double)lstV_AxesInfo.Width * 0.05);
            lstV_AxesInfo.Columns[13].Width = (int)((double)lstV_AxesInfo.Width * 0.05);
            lstV_AxesInfo.BeginUpdate();
           
            text_AxisVel.Text = "10000";
            text_AxisPos.Text = "10000";
            Variables.checkMotionDone = false;
            Variables.isOP = false;
            int ret = 0;

            ret = InitDevice();
            if (ret < 0) return;
            ret = Opendevice();
            if (ret < 0) return;
            ret = Startoptask();
            if (ret < 0) return;
            ret = Initmotion();
            if (ret < 0) return;
            ret = SetAxisParam();
            if (ret < 0) return;
        }

        private void InitConsole()
        {
            AllocConsole();
            IntPtr stdHandle = GetStdHandle(STD_OUTPUT_HANDLE);
            SafeFileHandle safeFileHandle = new SafeFileHandle(stdHandle, true);
            FileStream fileStream = new FileStream(safeFileHandle, FileAccess.Write);
            Encoding encoding = System.Text.Encoding.GetEncoding(MY_CODE_PAGE);
            StreamWriter standardOutput = new StreamWriter(fileStream, encoding);
            standardOutput.AutoFlush = true;
            Console.SetOut(standardOutput);
            Console.WriteLine("This text you can see in console window.");
        }

        public bool timeoutfunc(DateTime startTime)
        {
            DateTime currTime = DateTime.Now;
            TimeSpan diff_st = new TimeSpan(currTime.Ticks - startTime.Ticks);

            if (diff_st.TotalMilliseconds > Constants.TIME_OUT)
            {
                return true;
            }
            else return false;
        }

        public int InitDevice()
        {
            Console.WriteLine("InitDevice");
            int ret;
            ushort DeviceCnt = 0;
            byte[] CardId = new byte[CEcatDef.CARD_DEVICE_NO_MAX];
            for (int i = 0; i < CardId.Count(); i++)
            {
                CardId[i] = 0;
            }
            ret = CEcatLib.ECAT_GetDeviceCnt(ref DeviceCnt, CardId);

            if (ret < 0)
            {
                text_state.Text = "InitDevice Failed";
                return -1;
            }
            else
            {
                if (DeviceCnt == 0)
                {
                    text_state.Text = "InitDevice Failed";
                    return -1;
                }
                text_state.Text = "InitDevice";
                Variables.DeviceNo = CardId[0];	//Get card id of first ECAT-M801 //there is a switch on ECAT-M801 can change card id
                return 0;
            }
        }

        private int Opendevice()
        {
            Console.WriteLine("Opendevice");
            int ret = 0;
            string str1;

            ushort Alias = 0;
            uint ProductCode = 0, VendorID = 0, RevisionNo = 0, SerialNo = 0, SlaveType = 0;
            byte AlState = 0;

            ret = CEcatLib.ECAT_OpenDevice(Variables.DeviceNo);//Open first ECAT-M801 via card id

            if (ret < 0)
            {
                str1 = "Open Device failed, DeviceNo:" + Variables.DeviceNo.ToString() + ", ret:" + ret.ToString();
                text_state.Text = str1;
                return -1;
            }
            else
            {
                uint LinkUp = 0, SlavesResp = 0, AlStates = 0, Wc = 0;
                CEcatLib.ECAT_StopDeviceOpTask(Variables.DeviceNo);
                for (ushort i = 0; i < 10; i++)
                {
                    ret = CEcatLib.ECAT_GetDeviceStateEx(Variables.DeviceNo, ref LinkUp, ref SlavesResp, ref AlStates, ref Wc);
                    if (ret == 0 && AlStates == CEcatDef.ECAT_AS_PREOP)
                        break;
                    Thread.Sleep(1000);
                }
                if (ret != 0 || AlStates != CEcatDef.ECAT_AS_PREOP)
                {
                    str1 = "ECAT_GetDeviceStateEx failed, State:" + SlavesResp.ToString() + ", ret:" + ret.ToString();
                    text_state.Text = str1;
                    return -1;
                }

                timer1.Interval = Constants.DEV_TIMER_CYCLE_TIME;
                timer1.Enabled = true;

                ret = CEcatLib.ECAT_SetSlaveNoType(Variables.DeviceNo, CEcatDef.SLAVE_NO_TYPE_POSITION);
                if (ret != 0)
                {
                    str1 = "SetSlaveNoType failed, DeviceNo:" + Variables.DeviceNo.ToString() + ", ret:" + ret.ToString();
                    text_state.Text = str1;
                    return -1;
                }

                StringBuilder slvName = new StringBuilder("", CEcatDef.MAX_SLAVE_NAME_LENGTH);

                //Get status of ECAT-M801 

                if (ret == 0)
                {
                    lstV_SlaveList.Items.Clear();

                    for (ushort i = 0; i < SlavesResp; i++)
                    {
                        //Get Slave information via the position of the module in the ethercat network
                        ret = CEcatLib.ECAT_GetSlaveInfo(Variables.DeviceNo, i, ref Alias, ref ProductCode,
                                ref VendorID, ref RevisionNo, ref SerialNo, ref AlState, ref SlaveType, slvName);

                        lstV_SlaveList.Items.Add(i.ToString("D"), Alias.ToString("D"), 0);
                        if (ret == 0)
                            lstV_SlaveList.Items[i.ToString("D")].SubItems.Add(slvName.ToString());
                    }
                }
                ret = CEcatLib.ECAT_SetSlaveNoType(Variables.DeviceNo, CEcatDef.SLAVE_NO_TYPE_ALIAS_ID);
                if (ret != 0)
                {
                    str1 = "SetSlaveNoType failed, DeviceNo:" + Variables.DeviceNo.ToString() + ", ret:" + ret.ToString();
                    text_state.Text = str1;
                    return -1;
                }
                return 0;
            }
        }        

        private int Startoptask()
        {
            Console.WriteLine("Startoptask");
            int ret = 0;
            ushort NetworkInfoNo = 0;
            byte EnumCycleTime = 0;//1ms
            uint WcErrCnt = 3;//Tolerance of Ethercat communication Error 

            for (ushort i = 0; i < 10; i++)
            {
                ret = CEcatLib.ECAT_StartDeviceOpTask(Variables.DeviceNo, NetworkInfoNo, EnumCycleTime, WcErrCnt);
                if (ret == 0)
                    break;
                Thread.Sleep(1000);
            }

            if (ret < 0)
            {
                if (ret == -1009)
                    text_state.Text = "Op Failed, please use Utility.exe to build Network Information";
                else
                    text_state.Text = "Op Failed";
                return -1;
            }
            else
            {
                uint LinkUp = 0, SlavesResp = 0, AlStates = 0, Wc = 0;
                text_state.Text = "Oping...";
                for (ushort i = 0; i < 30; i++)
                {
                    ret = CEcatLib.ECAT_GetDeviceStateEx(Variables.DeviceNo, ref LinkUp, ref SlavesResp, ref AlStates, ref Wc);
                    if (ret == 0 && AlStates == CEcatDef.ECAT_AS_OP)
                        break;
                    Thread.Sleep(1000);
                }
                if (ret != 0 || AlStates != CEcatDef.ECAT_AS_OP)
                {
                    text_state.Text = "Op Failed";
                    return -1;
                }
                else
                {
                    text_state.Text = "OP";
                    return 0;
                }
            }
        }
        private void CheckMotionDone()
        {
            if (!Variables.checkMotionDone)
                return;
            int ret;
            uint u32Value = 0;
            int lastError = 0;//from master
            ushort DriveError = 0;//from motor driver
            double actual_Pos = 0;
            string str1 = "";
            ret = CEcatLib.ECAT_McGetAxisState_Ex(Variables.DeviceNo, Variables.AxisNo, ref u32Value);
            if (ret == 0)
            {
                if (u32Value == CEcatDef.MC_AS_ERRORSTOP)
                {
                    Variables.check_In_potision = 0;
                    ret = CEcatLib.ECAT_McGetAxisLastError_Ex(Variables.DeviceNo, Variables.AxisNo, ref lastError);
                    str1 = "LastError: " + lastError.ToString("D") + "ret:" + ret.ToString("D");
                    Console.WriteLine(str1);
                    ret = CEcatLib.ECAT_McGetAxisDriveError_Ex(Variables.DeviceNo, Variables.AxisNo, ref DriveError);
                    str1 = "DriveError: " + DriveError.ToString("D") + "ret:" + ret.ToString("D");
                    Console.WriteLine(str1);
                    text_state.Text = "Error occurred";
                    Variables.checkMotionDone = false;
                }
                else if (u32Value == CEcatDef.MC_AS_STANDSTILL)
                {
                    if (Variables.check_In_potision != 0)
                    {
                        ret = CEcatLib.ECAT_McGetAxisActualPos_Ex(Variables.DeviceNo, Variables.AxisNo, ref actual_Pos);
                        if (System.Math.Abs(Variables.TargetPos - actual_Pos) < 100)//Be considered true within a range
                        {
                            text_state.Text = "Move Done, In-Position";
                            Variables.checkMotionDone = false;
                        }
                    }
                    else
                    {
                        text_state.Text = "Move Done";
                         Variables.checkMotionDone = false;
                   }
                }
            }
        }
        private void UpdateDeviceState(uint LinkUp, uint SlavesResp, uint AlStates, uint Wc)
        {
            string strAlState;
                text_SlavesResp.Text = "Slave(s):" + SlavesResp.ToString();

                if (AlStates == 0)
                {
                    strAlState = "INIT";
                    Variables.isOP = false;
                }
                else if (AlStates == 0x02)
                {
                    strAlState = "PREOP";
                    Variables.isOP = false;
                }
                else if (AlStates == 0x04)
                {
                    strAlState = "SAFEOP";
                    Variables.isOP = false;
                }
                else if (AlStates == 0x08)
                {
                    if (Variables.isOP == false)
                    {
                        text_AlStates.Text = "Op";
                    }
                    strAlState = "OP";
                    Variables.isOP = true;
                }
                else
                {
                    strAlState = "Unknown";
                    Variables.isOP = false;
                }

                text_AlStates.Text = strAlState;
                text_Wc.Text = "WC:" + Wc.ToString();

                if (LinkUp != 0)
                {
                    text_LinkUp.Text = "Up";
                }
                else
                {
                    text_LinkUp.Text = "Down";
                }
            }
        private void timer1_Tick(object sender, EventArgs e)
        {
            int ret;
            uint LinkUp = 0, SlavesResp = 0, AlStates = 0, Wc = 0;

            ret = CEcatLib.ECAT_GetDeviceStateEx(Variables.DeviceNo, ref LinkUp, ref SlavesResp, ref AlStates, ref Wc);
            if (ret == 0)
            {
                UpdateDeviceState(LinkUp, SlavesResp, AlStates, Wc);
            }
            if (Variables.isOP)
            {
                ModuleProcess();
                CheckMotionDone();
            }
        }

        private int Initmotion()
        {
            Console.WriteLine("Initmotion");
            int ret = 0;
            string str1 = "";
            ushort[] McSlaveNo = new ushort[CEcatDef.MC_AXIS_NO_MAX];
            ushort[] McSubAxisNo = new ushort[CEcatDef.MC_AXIS_NO_MAX];

            //Please use ECAT_Utility.exe to create  Motion Control Parameter File(.motcfg)
            ret = CEcatLib.ECAT_McInit_Ex(Variables.DeviceNo, "Auto.motcfg", McSlaveNo, McSubAxisNo, ref Variables.AxisCnt);
	        if(ret < 0)
	        {
                if (ret == -1027)
                {
                    Console.WriteLine("Please use ECAT_Utility.exe to create Motion Control Parameter File(.motcfg)");
                }
                else
                {
                str1 = "Failed to initialize axes: " + ret.ToString("D");
		        Console.WriteLine(str1);
                }
		        return -1;
	        }

	        text_state.Text = "InitMotion";

	        for(int i=0;i<Variables.AxisCnt;i++)
	        {
                lstV_AxesInfo.Items.Add(i.ToString("D"), i.ToString("D"), 0);  // AxisNo
                lstV_AxesInfo.Items[i.ToString("D")].SubItems.Add("");         // AxisNo
                lstV_AxesInfo.Items[i.ToString("D")].SubItems.Add("");         // CmdPosition
                lstV_AxesInfo.Items[i.ToString("D")].SubItems.Add("");         // Position
                lstV_AxesInfo.Items[i.ToString("D")].SubItems.Add("");         // Velocity
                lstV_AxesInfo.Items[i.ToString("D")].SubItems.Add("");         // AxisState
                lstV_AxesInfo.Items[i.ToString("D")].SubItems.Add("");         // AxisError
                lstV_AxesInfo.Items[i.ToString("D")].SubItems.Add("");         // DriverError
                lstV_AxesInfo.Items[i.ToString("D")].SubItems.Add("");         // NOT
                lstV_AxesInfo.Items[i.ToString("D")].SubItems.Add("");         // POT
                lstV_AxesInfo.Items[i.ToString("D")].SubItems.Add("");         // ORG
                lstV_AxesInfo.Items[i.ToString("D")].SubItems.Add("");         // ALM
                lstV_AxesInfo.Items[i.ToString("D")].SubItems.Add("");         // WAN
                lstV_AxesInfo.Items[i.ToString("D")].SubItems.Add("");         // SVN
                lstV_AxesInfo.Items[i.ToString("D")].SubItems.Add("");         // VIR

	        }
	        Variables.AxisNo = 0;// First Axis
	        return 0;
        }

        private int SetAxisParam()
        {
            Console.WriteLine("SetAxisParam");
            string str1;
	        int ret = 0;
	        text_state.Text = "SetAxisParam";

            for (ushort AxisNo=0;AxisNo<Variables.AxisCnt;AxisNo++)
	        {
                /*
		        //These parameters have been set in ECAT_McInit_Ex
		        ret = CEcatLib.ECAT_McSetAxisPPU(Variables.DeviceNo, AxisNo, 1);
		        if(ret < 0)
		        {
                    str1 = "AxisNo[" + AxisNo.ToString("D") + "]:Failed to set axis PPU:" + ret.ToString("D");
		            Console.WriteLine(str1);			        
			        return ret;
		        }

                ret = CEcatLib.ECAT_McSetAxisHomeMethod(Variables.DeviceNo, AxisNo, 37);
                if (ret < 0)
                {
                    str1 = "AxisNo[" + AxisNo.ToString("D") + "]:Failed to set axis home method:" + ret.ToString("D");
                    Console.WriteLine(str1);
                    return ret;
                }

		        ret = CEcatLib.ECAT_McSetAxisHomeSpeed(Variables.DeviceNo,AxisNo, 10000, 1000);//user unit/s
		        if(ret < 0)
		        {
                    str1 = "AxisNo[" + AxisNo.ToString("D") + "]:Failed to set axis home speed:" + ret.ToString("D");
		            Console.WriteLine(str1);	
			        return ret;
		        }

		        ret = CEcatLib.ECAT_McSetAxisHomeAcc(Variables.DeviceNo,AxisNo, 100000);//user unit/s^2
		        if(ret < 0)
		        {
                    str1 = "AxisNo[" + AxisNo.ToString("D") + "]:Failed to set axis home acc:" + ret.ToString("D");
		            Console.WriteLine(str1);			        
			        return ret;
		        }
                */

                ret = CEcatLib.ECAT_McSetAxisAccDecUnit(Variables.DeviceNo, AxisNo, CEcatDef.MC_ACC_DEC_MODE_TIME);//ms
		        if(ret < 0)
		        {
                    str1 = "AxisNo[" + AxisNo.ToString("D") + "]:Failed to set axis acc unit:" + ret.ToString("D");
                    Console.WriteLine(str1);
                    return ret;
                }
                ret = CEcatLib.ECAT_McSetAxisAccTime(Variables.DeviceNo, AxisNo, 100);//ms
                if (ret < 0)
                {
                    str1 = "AxisNo[" + AxisNo.ToString("D") + "]:Failed to set axis acc time:" + ret.ToString("D");
                    Console.WriteLine(str1);
                    return ret;
                }
                /*
                 * the other method to set acc
                ret = CEcatLib.ECAT_McSetAxisAccDecUnit(Variables.DeviceNo, AxisNo, CEcatDef.MC_ACC_DEC_MODE_RATE);//rate
                if (ret < 0)
                {
                    str1 = "AxisNo[" + AxisNo.ToString("D") + "]:Failed to set axis acc unit:" + ret.ToString("D");
                    Console.WriteLine(str1);
                    return ret;
                }
                ret = CEcatLib.ECAT_McSetAxisAccDecRate(Variables.DeviceNo, AxisNo, 100000);//user unit/s^2
                if (ret < 0)
                {
                    str1 = "AxisNo[" + AxisNo.ToString("D") + "]:Failed to set axis acc time:" + ret.ToString("D");
		            Console.WriteLine(str1);			        
			        return ret;
		        }
                */
                do
                {
                    /*
                    when error occurred on master or motor driver
                    it will take few ms to process error
                    in the meantime, ServoOn or ErrorReset will return -1137

                    P.S. ServoOn also has the function of clearing errors
                    */
                    ret = CEcatLib.ECAT_McSetAxisServoOn(Variables.DeviceNo, AxisNo, 1);
                } while (ret == -1137);
                uint u32Value = 0;
                for (ushort i = 0; i < 10; i++)
                {
                    /*
                    it will take few ms to process ServoOn
                    when motor driver is ready, axis state should be standstill
                    */
                    ret = CEcatLib.ECAT_McGetAxisState_Ex(Variables.DeviceNo, AxisNo, ref u32Value);
                    if (ret == 0 && u32Value == CEcatDef.MC_AS_STANDSTILL)
                        break;
                    Thread.Sleep(100);
                }
                if (ret != 0 || u32Value != CEcatDef.MC_AS_STANDSTILL)
                {
                    str1 = "Failed to Servo On:ret: " + ret.ToString("D") + "dState:" + u32Value.ToString("D");
                    Console.WriteLine(str1);
                    return -1;
                }
            }

            text_state.Text = "-------";	        
	        return 0;
        }

        private int ModuleProcess()
        {
	        double dValue = 0;
            uint u32Value = 0;
            int i32Value = 0;
            ushort u16Value = 0;
            uint AxisDI = 0;
            uint BitDI = 0;

	        int ret;
            string str1 = "";
            for (ushort AxisNo = 0; AxisNo < Variables.AxisCnt; AxisNo++)
            {
                int ColIndex = 1;
                ret = CEcatLib.ECAT_McGetAxisCommandPos_Ex(Variables.DeviceNo, AxisNo, ref dValue);
                if (ret == 0)
                {
                    str1 = dValue.ToString("#0.000");
                    lstV_AxesInfo.Items[AxisNo].SubItems[ColIndex].Text = str1;
                }

                ColIndex++;
                ret = CEcatLib.ECAT_McGetAxisActualPos_Ex(Variables.DeviceNo, AxisNo, ref dValue);
                if (ret == 0)
                {
                    str1 = dValue.ToString("#0.000");
                    lstV_AxesInfo.Items[AxisNo].SubItems[ColIndex].Text = str1;
                }

                ColIndex++;
                ret = CEcatLib.ECAT_McGetAxisActualVel_Ex(Variables.DeviceNo, AxisNo, ref dValue);
                if (ret == 0)
                {
                    str1 = dValue.ToString("#0.0");
                    lstV_AxesInfo.Items[AxisNo].SubItems[ColIndex].Text = str1;
                }

                ColIndex++;
                ret = CEcatLib.ECAT_McGetAxisState_Ex(Variables.DeviceNo, AxisNo, ref u32Value);
                if (ret == 0)
                {
                    lstV_AxesInfo.Items[AxisNo].SubItems[ColIndex].Text = GetAxisStateStr(u32Value);
                }

                ColIndex++;
                ret = CEcatLib.ECAT_McGetAxisLastError_Ex(Variables.DeviceNo, AxisNo, ref i32Value);
                if (ret == 0)
                {
                    str1 = i32Value.ToString();
                    lstV_AxesInfo.Items[AxisNo].SubItems[ColIndex].Text = str1;
                }

                ColIndex++;
                ret = CEcatLib.ECAT_McGetAxisDriveError_Ex(Variables.DeviceNo, AxisNo, ref u16Value);
                if (ret == 0)
                {
                    str1 = u16Value.ToString();
                    lstV_AxesInfo.Items[AxisNo].SubItems[ColIndex].Text = str1;
                }

                ret = CEcatLib.ECAT_McGetAxisDI_Ex(Variables.DeviceNo, AxisNo, ref AxisDI);
                if (ret == 0)
                {
                    ColIndex++;

                    BitDI = 1;
                    for (int j = ColIndex; j < lstV_AxesInfo.Columns.Count; j++)
                    {
                        if ((AxisDI & BitDI) != 0)
                            lstV_AxesInfo.Items[AxisNo].SubItems[j].Text = "1";
                        else
                            lstV_AxesInfo.Items[AxisNo].SubItems[j].Text = "0";
                        BitDI = BitDI << 1;
                    }
                }
            }
	        return 0;
        }

        string GetAxisStateStr(uint state)
        {
            switch (state)
            {
                case CEcatDef.MC_AS_DISABLED:
                    return "Disabled";
                case CEcatDef.MC_AS_STANDSTILL:
                    return "StandStill";
                case CEcatDef.MC_AS_ERRORSTOP:
                    return "ErrorStop";
                case CEcatDef.MC_AS_STOPPING:
                    return "Stopping";
                case CEcatDef.MC_AS_HOMING:
                    return "Homing";
                case CEcatDef.MC_AS_DISCRETEMOTION:
                    return "DiscMotion";
                case CEcatDef.MC_AS_CONTINUOUSMOTION:
                    return "ContMotion";
                case CEcatDef.MC_AS_SYNCHRONIZEDMOTION:
                    return "SyncMotion";
                default:
                    return "Invalid";
            }
        }
        private int CheckAxisStateBeforeMove()
        {
            int ret;
            int lastError = 0;//from master
            ushort DriveError = 0;//from motor driver
            uint u32Value = 0;
            string str1;
            ret = CEcatLib.ECAT_McGetAxisState_Ex(Variables.DeviceNo, Variables.AxisNo, ref u32Value);
            if (ret == 0 && u32Value == CEcatDef.MC_AS_STANDSTILL)
            {
                return 0;
            }
            else
            {
                str1 = "Failed to move: ret:" + ret.ToString("D") + ":state:" + u32Value.ToString("D");
                Console.WriteLine(str1);
                if (u32Value == CEcatDef.MC_AS_ERRORSTOP)
                {
                    ret = CEcatLib.ECAT_McGetAxisLastError_Ex(Variables.DeviceNo, Variables.AxisNo, ref lastError);
                    str1 = "LastError: " + lastError.ToString("D") + ":ret:" + ret.ToString("D");
                    Console.WriteLine(str1);
                    ret = CEcatLib.ECAT_McGetAxisDriveError_Ex(Variables.DeviceNo, Variables.AxisNo, ref DriveError);
                    str1 = "DriveError: " + DriveError.ToString("D") + ":ret:" + ret.ToString("D");
                    Console.WriteLine(str1);
                }
                return -1;
            }
        }
        private int CheckAxisStateBeforeJog()
        {
            int ret;
            int lastError = 0;//from master
            ushort DriveError = 0;//from motor driver
            uint u32Value = 0;
            string str1;
            ret = CEcatLib.ECAT_McGetAxisState_Ex(Variables.DeviceNo, Variables.AxisNo, ref u32Value);
            if (ret == 0 && (u32Value == CEcatDef.MC_AS_STANDSTILL || u32Value == CEcatDef.MC_AS_CONTINUOUSMOTION))
            {
                return 0;
            }
            else
            {
                str1 = "Failed to move: ret:" + ret.ToString("D") + ":state:" + u32Value.ToString("D");
                Console.WriteLine(str1);
                if (u32Value == CEcatDef.MC_AS_ERRORSTOP)
                {
                    ret = CEcatLib.ECAT_McGetAxisLastError_Ex(Variables.DeviceNo, Variables.AxisNo, ref lastError);
                    str1 = "LastError: " + lastError.ToString("D") + ":ret:" + ret.ToString("D");
                    Console.WriteLine(str1);
                    ret = CEcatLib.ECAT_McGetAxisDriveError_Ex(Variables.DeviceNo, Variables.AxisNo, ref DriveError);
                    str1 = "DriveError: " + DriveError.ToString("D") + ":ret:" + ret.ToString("D");
                    Console.WriteLine(str1);
                }
                return -1;
            }
        }

        private void btn_AxisServoOn_Click(object sender, EventArgs e)
        {
            int ret = 0;
            string str1;
            do
            {
                /*
                when error occurred on master or motor driver
                it will take few ms to process error
                in the meantime, ServoOn or ErrorReset will return -1137

                P.S. ServoOn also has the function of clearing errors
                */
                ret = CEcatLib.ECAT_McSetAxisServoOn(Variables.DeviceNo, Variables.AxisNo, 1);
            } while (ret == -1137);

            if (ret < 0)
            {
                str1 = "Failed to set axis servo on: " + ret.ToString("D");
                Console.WriteLine(str1);
            }
            else
            {
                uint u32Value = 0;
                for (ushort i = 0; i < 10; i++)
                {
                    ret = CEcatLib.ECAT_McGetAxisState_Ex(Variables.DeviceNo, Variables.AxisNo, ref u32Value);
                    if (ret == 0 && u32Value == CEcatDef.MC_AS_STANDSTILL)
                        break;
                    Thread.Sleep(100);
                }
                if (ret != 0 || u32Value != CEcatDef.MC_AS_STANDSTILL)
                {
                    str1 = "Failed to set axis servo on: " + ret.ToString("D");
                    Console.WriteLine(str1);
                }
            }
        }

        private void btn_AxisServoOff_Click(object sender, EventArgs e)
        {
            int ret = 0;
            string str1;

            ret = CEcatLib.ECAT_McSetAxisServoOn(Variables.DeviceNo, Variables.AxisNo, 0);

            if (ret < 0)
            {
                str1 = "Failed to set axis servo off: " + ret.ToString("D");
                Console.WriteLine(str1);
            }
        }

        private void btn_AxisMoveAbs_Click(object sender, EventArgs e)
        {
            int ret = 0;
            string str1;
            double Pos;
            double Vel;

            Pos = Convert.ToDouble(text_AxisPos.Text);            
            Vel = Convert.ToDouble(text_AxisVel.Text);
            if (CheckAxisStateBeforeMove() < 0)
                return;

            ret = CEcatLib.ECAT_McAxisMoveAbs(Variables.DeviceNo, Variables.AxisNo, Pos, Vel);

            if (ret < 0)
            {                
                str1 = "Axis MoveAbs failed: " + ret.ToString("D");
                Console.WriteLine(str1);
            }
            else
            {
                text_state.Text = "Moving";
                Variables.checkMotionDone = true;
                Variables.check_In_potision = 1;
                Variables.TargetPos = Pos;
            }
        }

        private void btn_AxisMoveRel_Click(object sender, EventArgs e)
        {
            int ret = 0;
            string str1;
            double Pos;
            double Vel;

            Pos = Convert.ToDouble(text_AxisPos.Text);
            Vel = Convert.ToDouble(text_AxisVel.Text);
            if (CheckAxisStateBeforeMove() < 0)
                return;
            ret = CEcatLib.ECAT_McAxisMoveRel(Variables.DeviceNo, Variables.AxisNo, Pos, Vel);

            if (ret < 0)
            {
                str1 = "Axis MoveAbs failed: " + ret.ToString("D");
                Console.WriteLine(str1);
            }
            else
            {
                text_state.Text = "Moving";
                Variables.checkMotionDone = true;
                Variables.check_In_potision = 0;
            }
        }

        private void btn_AxisStop_Click(object sender, EventArgs e)
        {
            int ret = 0;
            string str1;

            ret = CEcatLib.ECAT_McAxisStop(Variables.DeviceNo, Variables.AxisNo);

            if (ret < 0)
            {
                str1 = "Axis Stop failed: " + ret.ToString("D");
                Console.WriteLine(str1);
            }
            else
                Variables.check_In_potision = 0;
        }

        private void btn_AxisQuickStop_Click(object sender, EventArgs e)
        {
            int ret = 0;
            string str1;

            ret = CEcatLib.ECAT_McAxisQuickStop(Variables.DeviceNo, Variables.AxisNo);

            if (ret < 0)
            {
                str1 = "Axis QuickStop failed: " + ret.ToString("D");
                Console.WriteLine(str1);
            }
            else
                Variables.check_In_potision = 0;
        }

        private void btn_AxisMoveJogP_Click(object sender, EventArgs e)
        {
            int ret = 0;
            string str1;
            double Vel;
            if (CheckAxisStateBeforeJog() < 0)
                return;

            Vel = Convert.ToDouble(text_AxisVel.Text);

            ret = CEcatLib.ECAT_McAxisMoveVel(Variables.DeviceNo, Variables.AxisNo, Vel);

            if (ret < 0)
            {
                str1 = "Axis Move Vel+ failed: " + ret.ToString("D");
                Console.WriteLine(str1);
            }
            else
            {
                text_state.Text = "Moving";
                Variables.checkMotionDone = true;
                Variables.check_In_potision = 0;
            }
        }

        private void btn_AxisMoveJogN_Click(object sender, EventArgs e)
        {
            int ret = 0;
            string str1;
            double Vel;

            if (CheckAxisStateBeforeJog() < 0)
                return;
            Vel = Convert.ToDouble(text_AxisVel.Text) * -1;

            ret = CEcatLib.ECAT_McAxisMoveVel(Variables.DeviceNo, Variables.AxisNo, Vel);

            if (ret < 0)
            {
                str1 = "Axis Move Vel- failed: " + ret.ToString("D");
                Console.WriteLine(str1);
            }
            else
            {
                text_state.Text = "Moving";
                Variables.checkMotionDone = true;
                Variables.check_In_potision = 0;
            }
        }

        private void btn_AxisErrorReset_Click(object sender, EventArgs e)
        {
            int ret = 0;
            string str1;

            do
            {
                /*
                when error occurred on master or motor driver
                it will take few ms to process error
                in the meantime, ServoOn or ErrorReset will return -1137

                P.S. ServoOn also has the function of clearing errors
                */
                ret = CEcatLib.ECAT_McAxisErrorReset(Variables.DeviceNo, Variables.AxisNo);
            } while (ret == -1137);
            if (ret < 0)
            {
                str1 = "Axis Error Reset failed: " + ret.ToString("D");
                Console.WriteLine(str1);
            }
            else
            {
                /*
                it will take few ms to process Error Reset
                when motor driver is ready, axis state should be standstill
                */
                uint u32Value = 0;
                for (ushort i = 0; i < 10; i++)
                {
                    ret = CEcatLib.ECAT_McGetAxisState_Ex(Variables.DeviceNo, Variables.AxisNo, ref u32Value);
                    if (ret == 0 && (u32Value == CEcatDef.MC_AS_STANDSTILL || u32Value == CEcatDef.MC_AS_DISABLED))
                        break;
                    Thread.Sleep(100);
                }
                if (ret != 0 || (u32Value != CEcatDef.MC_AS_STANDSTILL && u32Value != CEcatDef.MC_AS_DISABLED))
                {
                    str1 = "Axis Error Reset failed:ret: " + ret.ToString("D") + ":State:" + u32Value.ToString("D");
                    Console.WriteLine(str1);
                }
            }
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            for (ushort AxisNo = 0; AxisNo < Variables.AxisCnt; AxisNo++)
            {
                CEcatLib.ECAT_McSetAxisServoOn(Variables.DeviceNo, AxisNo, 0);
                Thread.Sleep(100);
            }
            CEcatLib.ECAT_StopDeviceOpTask(Variables.DeviceNo);
            CEcatLib.ECAT_CloseDevice(Variables.DeviceNo);
        }

        static class Constants
        {            
            public const int DEV_RM_IS_CLOSE = 0;
            public const int DEV_RM_IS_OPEN = 1;
            public const int DEV_RM_IS_OP_TASK = 2;
            
            public const int TIME_OUT = 1000;
            public const int DEV_TIMER_CYCLE_TIME = 30; //ms                  
        }
        public class Variables
        {
            public static ushort DeviceNo;
            public static bool isOP;
            public static int state;
            public static bool bDevOpen;
            public static bool bStateOP;
            public static bool bInitMotion;           
            public static ushort SlaveCnt;
            public static ushort AxisCnt;            
            public static ushort AxisNo;            
            public static DateTime startTime;
            public static bool checkMotionDone;
            public static ushort check_In_potision;
            public static double TargetPos;
        }                

        private void Btn_home_Click(object sender, EventArgs e)
        {
            /*
            //These parameters have been set in ECAT_McInit_Ex
            ret = CEcatLib.ECAT_McSetAxisHomeMethod(Variables.DeviceNo, AxisNo, 37);
            if(ret < 0)
            {
                str1 = "AxisNo[" + AxisNo.ToString("D") + "]:Failed to set axis home method:" + ret.ToString("D");
                Console.WriteLine(str1);	
                return ret;
            }

            ret = CEcatLib.ECAT_McSetAxisHomeSpeed(Variables.DeviceNo,AxisNo, 10000, 1000);//pulse/s
            if(ret < 0)
            {
                str1 = "AxisNo[" + AxisNo.ToString("D") + "]:Failed to set axis home speed:" + ret.ToString("D");
                Console.WriteLine(str1);			        
                return ret;
            }

            ret = CEcatLib.ECAT_McSetAxisHomeAcc(Variables.DeviceNo,AxisNo, 100000);//pulse/s^2
            if(ret < 0)
            {
                str1 = "AxisNo[" + AxisNo.ToString("D") + "]:Failed to set axis home acc:" + ret.ToString("D");
                Console.WriteLine(str1);			        
                return ret;
            }
            */
            int ret = 0;
            string str1;

            if (CheckAxisStateBeforeMove() < 0)
                return;

            ret = CEcatLib.ECAT_McAxisHome(Variables.DeviceNo, Variables.AxisNo);

            if (ret < 0)
            {
                str1 = "Axis Home failed: " + ret.ToString("D");
                Console.WriteLine(str1);
            }
            else
            {
                /*
                After Homing is completed,
                actual position is not necessarily zero according to the different practices of various manufacturers.
                actual position will approach to 0
                If necessary, please use ECAT_McAxisMoveAbs to go to the 0 position.
                Please note that at the 0 position, the Home switch may be unstable because of various reasons.
                */
                text_state.Text = "Moving";
                Variables.checkMotionDone = true;
                Variables.check_In_potision = 0;
            }
        }

        private void Btn_clrenc_Click(object sender, EventArgs e)
        {
            int ret = 0;
            string str1;

            if (CheckAxisStateBeforeMove() < 0)
                return;

            //The execution of this function will switch the state to MC_AS_HOMING
            //it is necessary to check that the state is MC_AS_STANDSTILL to be completed.
            //ECAT_McSetAxisActualPosition already contains ECAT_McSetAxisCommandPosition command
            ret = CEcatLib.ECAT_McSetAxisActualPosition(Variables.DeviceNo, Variables.AxisNo, 0);

            if (ret < 0)
            {
                str1 = "Axis Clear Position failed: " + ret.ToString("D");
                Console.WriteLine(str1);
            }
            else
            {
                text_state.Text = "Moving";
                Variables.checkMotionDone = true;
                Variables.check_In_potision = 0;
            }
        }
    }
}
