﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Threading;

using EcatLib;
using EcatDef;
using EcatError;

namespace EventTest
{
    public partial class Form1 : Form
    {
        Thread thread1;

        public Form1()
        {
            InitializeComponent();

            Variables.AxisInitParam.SlaveNo = new ushort[CEcatDef.MC_AXIS_NO_MAX];
            Variables.AxisInitParam.SubAxisNo = new ushort[CEcatDef.MC_AXIS_NO_MAX];
            Variables.AxisInitParam.PPU = new double[CEcatDef.MC_AXIS_NO_MAX];
            Variables.AxisInitParam.HomeMethod = new int[CEcatDef.MC_AXIS_NO_MAX];
            Variables.AxisInitParam.HomeSpeedSeachSw = new double[CEcatDef.MC_AXIS_NO_MAX];
            Variables.AxisInitParam.HomeSpeedSeachZr = new double[CEcatDef.MC_AXIS_NO_MAX];
            Variables.AxisInitParam.HomeAcc = new double[CEcatDef.MC_AXIS_NO_MAX];
            Variables.AxisInitParam.EncoderPPR = new uint[CEcatDef.MC_AXIS_NO_MAX];
            Variables.AxisInitParam.MotorPPR = new uint[CEcatDef.MC_AXIS_NO_MAX];
            Variables.AxisInitParam.AxisAccTime = new ushort[CEcatDef.MC_AXIS_NO_MAX];
            Variables.AxisInitParam.AxisAccDecType = new ushort[CEcatDef.MC_AXIS_NO_MAX];

            Variables.EventID = new ushort[4];
            for (ushort i = 0; i < 4; i++)
                Variables.EventID[i] = i;
            Variables.bEvStart = false;
            Variables.bEvEnable = false;
            
            Variables.bScanCard = false;
            Variables.bDevOpen = false;
            Variables.bStateOP = false;
            Variables.bInitMotion = false;
            Variables.AxisCnt = 0;
            Variables.SlaveCnt = 0;

            lstV_AxisInfo.View = View.Details;
            lstV_AxisInfo.Columns.Add("AxisNo");
            lstV_AxisInfo.Columns.Add("CmdPos");
            lstV_AxisInfo.Columns.Add("Position");
            lstV_AxisInfo.Columns.Add("Velocity");
            lstV_AxisInfo.Columns.Add("AxisState");
            lstV_AxisInfo.Columns.Add("AxisErr");
            lstV_AxisInfo.Columns.Add("DrvErr");
            lstV_AxisInfo.Columns[0].Width = (int)((double)lstV_AxisInfo.Width * 0.13);
            lstV_AxisInfo.Columns[1].Width = (int)((double)lstV_AxisInfo.Width * 0.15);
            lstV_AxisInfo.Columns[2].Width = (int)((double)lstV_AxisInfo.Width * 0.15);
            lstV_AxisInfo.Columns[3].Width = (int)((double)lstV_AxisInfo.Width * 0.15);
            lstV_AxisInfo.Columns[4].Width = (int)((double)lstV_AxisInfo.Width * 0.15);
            lstV_AxisInfo.Columns[5].Width = (int)((double)lstV_AxisInfo.Width * 0.14);
            lstV_AxisInfo.Columns[6].Width = (int)((double)lstV_AxisInfo.Width * 0.13);
            lstV_AxisInfo.BeginUpdate();

            textAxisVel.Text = "5";

            cmbEv0Op.Items.Add(">");
            cmbEv0Op.Items.Add(">=");
            cmbEv0Op.Items.Add("<");
            cmbEv0Op.Items.Add("<=");
            cmbEv0Op.SelectedIndex = 0;
            textEv0Pos.Text = "50";

            cmbEv1Op.Items.Add(">");
            cmbEv1Op.Items.Add(">=");
            cmbEv1Op.Items.Add("<");
            cmbEv1Op.Items.Add("<=");
            cmbEv1Op.SelectedIndex = 0;
            textEv1Pos.Text = "50";


            cmbEv2State.Items.Add("Disable");
            cmbEv2State.Items.Add("Standstill");
            cmbEv2State.Items.Add("ErrorStop");
            cmbEv2State.Items.Add("Stopping");
            cmbEv2State.Items.Add("Homing");
            cmbEv2State.Items.Add("Discrete-Motion");
            cmbEv2State.Items.Add("Continuous-Motion");
            cmbEv2State.Items.Add("Synchronized-Motion");
            cmbEv2State.SelectedIndex = 0;


            cmbEv3State.Items.Add("Constant_Vel");
            cmbEv3State.Items.Add("Acc");
            cmbEv3State.Items.Add("Dec");
            cmbEv3State.SelectedIndex = 0;            

            WidgetEnabledByRunMode(Constants.DEV_RM_IS_CLOSE);

            thread1 = new Thread(EvTest1);
            Variables.bEvStart = true;
            Variables.bEvEnable = false;
            thread1.IsBackground = true;
            thread1.Start();
        }

        static class Constants
        {            
            public const int TIME_OUT = 100; // ms
            public const int DEV_RM_IS_CLOSE = 0;
            public const int DEV_RM_IS_OPEN = 1;
            public const int DEV_RM_IS_OP_TASK = 2;            
        }
        public class Variables
        {
            public static ushort DeviceNo;
            public static bool emergencystop;
            public static bool bScanCard;
            public static bool bDevOpen;
            public static bool bStateOP;
            public static bool bInitMotion;

            public static ushort[] EventID;
            public static bool bEvStart;
            public static bool bEvEnable;

            public static ushort SlaveCnt;
            public static ushort AxisCnt;
            public static DateTime startTime;

            public static bool bRecordStart;
            public static uint nRcdCnt;

            public static byte[] DoData;
            public static byte[] DiData;
            public static ushort DoBitSize, DoByteSize;
            public static ushort DiBitSize, DiByteSize;

            public static bool[] rxbitstate;
            public static bool[] enablerx;
            public static bool[] txbitstate;
            public static bool[] enabletx;

            public static int DevRunMode;

            public static ushort TrigEvId;            

            public struct _AxisInitParam_
            {
                public ushort[] SlaveNo;
                public ushort[] SubAxisNo;
                public double[] PPU;
                public int[] HomeMethod;
                public double[] HomeSpeedSeachSw;
                public double[] HomeSpeedSeachZr;
                public double[] HomeAcc;
                public uint[] EncoderPPR;
                public uint[] MotorPPR;
                public ushort[] AxisAccTime;
                public ushort[] AxisAccDecType;
            }
            public static _AxisInitParam_ AxisInitParam;

        }

        public bool timeoutfunc(DateTime startTime, string strMsg)
        {
            string str1;
            if (Variables.emergencystop)
            {
                str1 = strMsg + " stopped: Emergency  Stop";
                LogMessage(str1);
                return true;
            }
            DateTime currTime = DateTime.Now;
            //float timediff_sec = (float)(currTime - startTime);
            TimeSpan diff_st = new TimeSpan(currTime.Ticks - startTime.Ticks);

            if (diff_st.TotalMilliseconds > Constants.TIME_OUT)
            {
                str1 = strMsg + ": User timeout";
                LogMessage(str1);
                return true;
            }
            else return false;
        }

        public void LogMessage(string strMsg)
        {
            DateTime currTime = DateTime.Now;
            string str1;
            str1 = currTime.ToString("yyyy/MM/dd tt hh:mm:ss:  ") + strMsg;
            lsbLogMsg.Items.Add(str1);
            lsbLogMsg.SelectedIndex = lsbLogMsg.Items.Count - 1;
        }

        public int SetAxisParam(ushort AxisNo)
        {
            string str1;
            int ret = 0;
            /*
	        //These parameters have been set in ECAT_McInit_Ex
            ret = CEcatLib.ECAT_McSetAxisPPU(Variables.DeviceNo, AxisNo, Variables.AxisInitParam.PPU[AxisNo]);
            if (ret < 0)
            {
                str1 = "AxisNo[" + AxisNo.ToString("D") + "]:Failed to set axis PPU: " + ret.ToString("D");
                LogMessage(str1);
                return ret;
            }

            ret = CEcatLib.ECAT_McSetAxisHomeMethod(Variables.DeviceNo, AxisNo, Variables.AxisInitParam.HomeMethod[AxisNo]);
            if (ret < 0)
            {
                //str1.sprintf("AxisNo[%d]:Failed to set axis home method:%d",AxisNo,ret);
                str1 = "AxisNo[" + AxisNo.ToString("D") + "]:Failed to set axis home method: " + ret.ToString("D");
                LogMessage(str1);
                return ret;
            }

            ret = CEcatLib.ECAT_McSetAxisHomeSpeed(Variables.DeviceNo, AxisNo, Variables.AxisInitParam.HomeSpeedSeachSw[AxisNo], Variables.AxisInitParam.HomeSpeedSeachZr[AxisNo]);
            if (ret < 0)
            {
                //str1.sprintf("AxisNo[%d]:Failed to set axis home speed:%d",AxisNo,ret);
                str1 = "AxisNo[" + AxisNo.ToString("D") + "]:Failed to set axis home speed: " + ret.ToString("D");
                return ret;
            }

            ret = CEcatLib.ECAT_McSetAxisHomeAcc(Variables.DeviceNo, AxisNo, Variables.AxisInitParam.HomeAcc[AxisNo]);
            if (ret < 0)
            {
                //str1.sprintf("AxisNo[%d]:Failed to set axis home acc:%d",AxisNo,ret);
                str1 = "AxisNo[" + AxisNo.ToString("D") + "]:Failed to set axis home acc: " + ret.ToString("D");
                LogMessage(str1);
                return ret;
            }

            */
            ret = CEcatLib.ECAT_McSetAxisAccTime(Variables.DeviceNo, AxisNo, 100);//ms
            if (ret < 0)
            {
                str1 = "AxisNo[" + AxisNo.ToString("D") + "]:Failed to set axis acc time:" + ret.ToString("D");
                Console.WriteLine(str1);
                return ret;
            }
            return 0;
        }

        string GetAxisStateStr(uint state)
        {
            switch (state)
            {
                case CEcatDef.MC_AS_DISABLED:
                    return "Disabled";
                case CEcatDef.MC_AS_STANDSTILL:
                    return "StandStill";
                case CEcatDef.MC_AS_ERRORSTOP:
                    return "ErrorStop";
                case CEcatDef.MC_AS_STOPPING:
                    return "Stopping";
                case CEcatDef.MC_AS_HOMING:
                    return "Homing";
                case CEcatDef.MC_AS_DISCRETEMOTION:
                    return "DiscMotion";
                case CEcatDef.MC_AS_CONTINUOUSMOTION:
                    return "ContMotion";
                case CEcatDef.MC_AS_SYNCHRONIZEDMOTION:
                    return "SyncMotion";
                default:
                    return "Invalid";
            }
        }

        public void WidgetEnabledByRunMode(int RunMode)
        {
            Variables.DevRunMode = RunMode;

            switch (RunMode)
            {
                case Constants.DEV_RM_IS_CLOSE:     //Device is close
                    btnAxisServoOn.Enabled = true;
                    btnAxisServoOff.Enabled = true;
                    btnStart.Text = "Start";
                    btnAxisMoveJogP.Enabled = false;
                    btnAxisMoveJogN.Enabled = false;
                    btnAxisStop.Enabled = false;
                    btnEv0Enable.Enabled = false;
                    btnEv1Enable.Enabled = false;
                    btnEv2Enable.Enabled = false;
                    btnEv3Enable.Enabled = false;
                    
                    textSlaveResp.Text = "";
                    textAlState.Text = "";
                    textWC.Text = "";
                    Variables.SlaveCnt = 0;
                    Variables.bDevOpen = false;
                    Variables.bStateOP = false;
                    timer1.Enabled = false;
                    break;
                case Constants.DEV_RM_IS_OPEN: //Device is open
                    btnAxisServoOn.Enabled = false;
                    btnAxisServoOff.Enabled = false;
                    btnStart.Text = "Stop";
                    btnAxisMoveJogP.Enabled = false;
                    btnAxisMoveJogN.Enabled = false;
                    btnAxisStop.Enabled = false;
                    btnEv0Enable.Enabled = false;
                    btnEv1Enable.Enabled = false;
                    btnEv2Enable.Enabled = false;
                    btnEv3Enable.Enabled = false;                    
                    Variables.bDevOpen = true;
                    Variables.bStateOP = false;
                    Variables.bInitMotion = false;
                    timer1.Enabled = true;                    
                    break;
                case Constants.DEV_RM_IS_OP_TASK: //Start op task
                    btnAxisServoOn.Enabled = true;
                    btnAxisServoOff.Enabled = true;
                    btnStart.Text = "Stop";
                    btnAxisMoveJogP.Enabled = true;
                    btnAxisMoveJogN.Enabled = true;
                    btnAxisStop.Enabled = true;
                    btnEv0Enable.Enabled = true;
                    btnEv1Enable.Enabled = true;
                    btnEv2Enable.Enabled = true;
                    btnEv3Enable.Enabled = true;                    
                    Variables.bStateOP = true;                    
                    break;
            }
        }

        private void btnStart_Click(object sender, EventArgs e)
        {
            int ret = 0;
            ushort DeviceCnt = 0;

            string str1 = "";

            ushort NetworkInfoNo = 0;     // set 0 as default in this demo
            uint LinkUp = 0, SlavesResp = 0, AlStates = 0, Wc = 0;

            //StringBuilder slvName = new StringBuilder("", CEcatDef.MAX_SLAVE_NAME_LENGTH);

            if (!Variables.bScanCard)
            {
                byte[] CardId = new byte[CEcatDef.CARD_DEVICE_NO_MAX];
                for (int i = 0; i < CardId.Count(); i++)
                {
                    CardId[i] = 0;
                }

                ret = CEcatLib.ECAT_GetDeviceCnt(ref DeviceCnt, CardId);
                if (ret < 0)
                {
                    str1 = "Failed to get device cnt:" + ret.ToString("D");
                    LogMessage(str1);
                }
                else
                {
                    Variables.DeviceNo = CardId[0];
                    Variables.bScanCard = true;
                }
                Variables.bScanCard = true;
            }

            if (!Variables.bDevOpen)
            {
                //============ Step1: Open device =============//                
                ret = CEcatLib.ECAT_OpenDevice(Variables.DeviceNo);

                if (ret < 0)
                {                   
                    str1 = "Failed to open EcatDevice: " + ret.ToString();                    
                    LogMessage(str1);                   
                    return;
                }
                else
                {
                    WidgetEnabledByRunMode(Constants.DEV_RM_IS_OPEN);
                    CEcatLib.ECAT_StopDeviceOpTask(Variables.DeviceNo);
                    for (ushort i = 0; i < 10; i++)
                    {
                        ret = CEcatLib.ECAT_GetDeviceStateEx(Variables.DeviceNo, ref LinkUp, ref SlavesResp, ref AlStates, ref Wc);
                        if (ret == 0 && AlStates == CEcatDef.ECAT_AS_PREOP)
                            break;
                        Thread.Sleep(1000);
                    }
                    if (ret != 0 || AlStates != CEcatDef.ECAT_AS_PREOP)
                    {
                        str1 = "ECAT_GetDeviceStateEx failed, State:" + SlavesResp.ToString() + ", ret:" + ret.ToString();
                        LogMessage(str1);
                    }
                    ret = CEcatLib.ECAT_SetSlaveNoType(Variables.DeviceNo, CEcatDef.SLAVE_NO_TYPE_ALIAS_ID);
                    if (ret != 0)
                    {
                        str1 = "SetSlaveNoType failed, DeviceNo:" + Variables.DeviceNo.ToString() + ", ret:" + ret.ToString();
                        LogMessage(str1);
                    }
                }

                //============ Step3: Set state to OP=============//
                if (!Variables.bStateOP)
                {
                    byte EnumCycleTime = CEcatDef.DEV_OP_CYCLE_TIME_1MS;
                    uint WcErrCnt = 3;

                    ret = CEcatLib.ECAT_StartDeviceOpTask(Variables.DeviceNo, NetworkInfoNo, EnumCycleTime, WcErrCnt);


                    if (ret < 0)
                    {                        
                        str1 = "Failed to start device op task: " + ret.ToString("D");
                        LogMessage(str1);
                        
                        str1 = "DeviceNo(" + Variables.DeviceNo.ToString("D") + "), NetworkInfoNo("
                            + NetworkInfoNo.ToString("D") + "), EnumCycleTime(" + EnumCycleTime.ToString("D")
                            + "), WcErrCnt(" + WcErrCnt.ToString("D");
                        LogMessage(str1);
                        WidgetEnabledByRunMode(Constants.DEV_RM_IS_OPEN);
                        return;
                    }
                    else
                    {
                        WidgetEnabledByRunMode(Constants.DEV_RM_IS_OP_TASK);

                        ret = CEcatLib.ECAT_GetDeviceStateEx(Variables.DeviceNo, ref LinkUp, ref SlavesResp, ref AlStates, ref Wc);
                        Variables.SlaveCnt = (ushort)SlavesResp;                        
                    }
                    //========= 確認狀態進入OP後才進入下一階段: 設置軸參數 ========//                               
                    Variables.startTime = DateTime.Now;
                    TimeSpan diff_st;
                    do
                    {
                        ret = CEcatLib.ECAT_GetDeviceStateEx(Variables.DeviceNo, ref LinkUp, ref SlavesResp, ref AlStates, ref Wc);

                        DateTime currTime = DateTime.Now;
                        diff_st = new TimeSpan(currTime.Ticks - Variables.startTime.Ticks);
                        if (diff_st.TotalMilliseconds > 30000)  // 30秒內未切換到OP就停止
                        {
                            CEcatLib.ECAT_StopDeviceOpTask(Variables.DeviceNo);
                            WidgetEnabledByRunMode(Constants.DEV_RM_IS_OPEN);
                           
                            btnStart.Text = "Start";
                            Variables.bStateOP = false;
                            return;
                        }
                        SpinWait.SpinUntil(() => false, 100);
                    } while (AlStates != 0x08);
                    str1 = "Set state to OP take " + diff_st.TotalSeconds.ToString("#0.00") + " second!";
                    LogMessage(str1);
                }
                else
                {
                    ret = CEcatLib.ECAT_StopDeviceOpTask(Variables.DeviceNo);

                    if (ret < 0)
                    {
                        str1 = "Failed to stop device op task: " + ret.ToString("D");
                        LogMessage(str1);
                        WidgetEnabledByRunMode(Constants.DEV_RM_IS_OP_TASK);
                    }
                    else
                    {
                        WidgetEnabledByRunMode(Constants.DEV_RM_IS_OPEN);
                    }
                }

                //============ Step4: Config Motion =============//
                if (!Variables.bInitMotion)
                {
                    ushort[] McSlaveNo = new ushort[CEcatDef.MC_AXIS_NO_MAX];
                    ushort[] McSubAxisNo = new ushort[CEcatDef.MC_AXIS_NO_MAX];
                    //================= init motion parameters to card ====================//                    
                    ret = CEcatLib.ECAT_McInit_Ex(Variables.DeviceNo, "Auto.motcfg", McSlaveNo, McSubAxisNo, ref Variables.AxisCnt);
                    if (ret < 0)
                    {
                        str1 = "Failed to initialize axes: " + ret.ToString("D");
                        LogMessage(str1);
                        return;
                    }
                    lstV_AxisInfo.Items.Clear();

                        for (ushort i = 0; i < Variables.AxisCnt; i++)
                        {
                            lstV_AxisInfo.Items.Add(i.ToString("D"), i.ToString("D"), 0);  // AxisNo
                            lstV_AxisInfo.Items[i.ToString("D")].SubItems.Add("");         // AxisNo
                            lstV_AxisInfo.Items[i.ToString("D")].SubItems.Add("");         // CmdPosition
                            lstV_AxisInfo.Items[i.ToString("D")].SubItems.Add("");         // Position
                            lstV_AxisInfo.Items[i.ToString("D")].SubItems.Add("");         // Velocity
                            lstV_AxisInfo.Items[i.ToString("D")].SubItems.Add("");         // AxisState
                            lstV_AxisInfo.Items[i.ToString("D")].SubItems.Add("");         // AxisError
                            lstV_AxisInfo.Items[i.ToString("D")].SubItems.Add("");         // DriverError
                        ret = SetAxisParam(i);
                        if (ret < 0)
                        {
                            return;
                        }
                    }

                    Variables.bInitMotion = true;
                }
                else
                {
                    Variables.bInitMotion = false;
                }
            }
            else
            {
                for (ushort i = 0; i < 4; i++)
                {
                    ret = CEcatLib.ECAT_EvDisableEvent(Variables.DeviceNo, Variables.EventID[i]);
                    if (ret < 0)
                    {
                        str1 = "Axis[" + i.ToString() + "] EvDisableEvent failed: " + ret.ToString();
                        LogMessage(str1);
                        return;
                    }
                }
                Variables.bEvEnable = false;

                ret = CEcatLib.ECAT_StopDeviceOpTask(Variables.DeviceNo);

                if (ret < 0)
                {
                    str1 = "Failed to stop device op task: " + ret.ToString("D");
                    LogMessage(str1);
                    WidgetEnabledByRunMode(Constants.DEV_RM_IS_OP_TASK);
                }
                else
                {
                    str1 = "Set stop device op task: " + ret.ToString("D");
                    LogMessage(str1);
                    WidgetEnabledByRunMode(Constants.DEV_RM_IS_OPEN);
                }


                ret = CEcatLib.ECAT_CloseDevice(Variables.DeviceNo);
                if (ret < 0)
                {
                    str1 = "Failed to close EcatDevice: " + ret.ToString("D");
                    LogMessage(str1);
                    WidgetEnabledByRunMode(Constants.DEV_RM_IS_OPEN);
                }
                else
                {
                    str1 = "Set close EcatDevice: " + ret.ToString("D");
                    LogMessage(str1);
                    WidgetEnabledByRunMode(Constants.DEV_RM_IS_CLOSE);
                }                     
            }
        }

        private void EvTest1(object url)
        {
            int ret = 0;
            uint Value = 0;
            string str1;

            while (Variables.bEvStart)
            {
                if (Variables.bEvEnable)
                {
                    ret = CEcatLib.ECAT_WaitforEvent(Variables.DeviceNo, 65535/*Infinite*/, ref Value); // blocks until event triggered or failed or timeout.
                    if(ret != 0) 
                    {                        
                        Variables.TrigEvId = 65535;
                        MethodInvoker mi = new MethodInvoker(this.EvTriggered);
                        this.BeginInvoke(mi, null);

                        str1 = "ECAT_WaitforEvent failed: " + ret.ToString("D");
                        LogMessage(str1);
                    } 
                    else 
                    { 
                        if(((Value>>(Variables.EventID[0])) & (0x01)) == 1) 
                        {
                            Variables.TrigEvId = Variables.EventID[0];
                            MethodInvoker mi = new MethodInvoker(this.EvTriggered);
                            this.BeginInvoke(mi, null);                            
                            //Variables.bEvEnable = false;

                            if (Value == 0x01 << (Variables.EventID[0]))
                                Variables.bEvEnable = false;
                            else
                                Value -= (uint)0x01 << (Variables.EventID[0]);
                        }
                        if (((Value >> (Variables.EventID[1])) & (0x01)) == 1)
                        {
                            Variables.TrigEvId = Variables.EventID[1];
                            MethodInvoker mi = new MethodInvoker(this.EvTriggered);
                            this.BeginInvoke(mi, null);
                            //Variables.bEvEnable = false;
                            if (Value == 0x01 << (Variables.EventID[1]))
                                Variables.bEvEnable = false;
                            else
                                Value -= (uint)0x01 << (Variables.EventID[1]);
                        }
                        if (((Value >> (Variables.EventID[2])) & (0x01)) == 1)
                        {
                            Variables.TrigEvId = Variables.EventID[2];
                            MethodInvoker mi = new MethodInvoker(this.EvTriggered);
                            this.BeginInvoke(mi, null);
                            //Variables.bEvEnable = false;
                            if (Value == 0x01 << (Variables.EventID[2]))
                                Variables.bEvEnable = false;
                            else
                                Value -= (uint)0x01 << (Variables.EventID[2]);
                        }
                        if (((Value >> (Variables.EventID[3])) & (0x01)) == 1)
                        {
                            Variables.TrigEvId = Variables.EventID[3];
                            MethodInvoker mi = new MethodInvoker(this.EvTriggered);
                            this.BeginInvoke(mi, null);
                            //Variables.bEvEnable = false;
                            if (Value == 0x01 << (Variables.EventID[3]))
                                Variables.bEvEnable = false;
                            else
                                Value -= (uint)0x01 << (Variables.EventID[3]);
                        }
                    }
                }
                SpinWait.SpinUntil(() => false, 100);
            }
        }       

        private void EvTriggered()
        {
            int ret = 0;
            string str1;
            ushort i;

            if (Variables.TrigEvId <= 3)
            {
                for (i = 0; i < Variables.AxisCnt; i++)
                {
                    if (lstV_AxisInfo.Items[i].Checked)
                    {
                        ret = CEcatLib.ECAT_McAxisStop(Variables.DeviceNo, i);
                        break;
                    }
                }
                str1 = "EventID [" + Variables.TrigEvId.ToString() + "]  triggered!";
                LogMessage(str1);
            }
            else
            {
                str1 = "EventID [" + Variables.EventID.ToString() + "]  WaitforEvent failed: " + ret.ToString();
                LogMessage(str1);
            }
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            int ret;
            ushort i;
            string StrAlState = "", str1;
            uint LinkUp = 0, SlavesResp = 0, AlStates = 0, Wc = 0;

            double[] dValue32 = new double[CEcatDef.MC_AXIS_NO_MAX];
            uint[] u32Value32 = new uint[CEcatDef.MC_AXIS_NO_MAX];
            int[] i32Value32 = new int[CEcatDef.MC_AXIS_NO_MAX];
            ushort[] u16Value32 = new ushort[CEcatDef.MC_AXIS_NO_MAX];
            //StringBuilder slvName = new StringBuilder("", CEcatDef.MAX_SLAVE_NAME_LENGTH);

            ret = CEcatLib.ECAT_GetDeviceStateEx(Variables.DeviceNo, ref LinkUp, ref SlavesResp, ref AlStates, ref Wc);

            if (ret == 0)
            {
                str1 = "Slave(s):" + SlavesResp.ToString("D");
                textSlaveResp.Text = str1;
                if (AlStates == 0)
                    StrAlState = "INIT";
                else if (AlStates == 0x02)
                    StrAlState = "PREOP";
                else if (AlStates == 0x04)
                    StrAlState = "SAFEOP";
                else if (AlStates == 0x08)
                    StrAlState = "OP";
                else
                {
                    StrAlState = "Unknown";
                    str1 = "Unknown  WC: " + Wc.ToString("D");
                    LogMessage(str1);
                }

                textAlState.Text = StrAlState;
                str1 = "WC:" + Wc.ToString("D");
                textWC.Text = str1;
            }

            if ((Variables.bInitMotion) && (Variables.DevRunMode == Constants.DEV_RM_IS_OP_TASK))
            {
                ret = CEcatLib.ECAT_McGetAxisCommandPos_Ex(Variables.DeviceNo, 65535, ref dValue32[0]);
                if (ret == 0)
                {
                    for (i = 0; i < Variables.AxisCnt; i++)
                    {
                        str1 = dValue32[i].ToString("#0.000");
                        lstV_AxisInfo.Items[i].SubItems[1].Text = str1;
                    }
                }

                ret = CEcatLib.ECAT_McGetAxisActualPos_Ex(Variables.DeviceNo, 65535, ref dValue32[0]);
                if (ret == 0)
                {
                    for (i = 0; i < Variables.AxisCnt; i++)
                    {
                        str1 = dValue32[i].ToString("#0.000");
                        lstV_AxisInfo.Items[i].SubItems[2].Text = str1;
                    }
                }

                ret = CEcatLib.ECAT_McGetAxisActualVel_Ex(Variables.DeviceNo, 65535, ref dValue32[0]);
                if (ret == 0)
                {
                    for (i = 0; i < Variables.AxisCnt; i++)
                    {
                        str1 = dValue32[i].ToString("#0.0");
                        lstV_AxisInfo.Items[i].SubItems[3].Text = str1;
                    }
                }

                ret = CEcatLib.ECAT_McGetAxisState_Ex(Variables.DeviceNo, 65535, ref u32Value32[0]);
                if (ret == 0)
                {
                    for (i = 0; i < Variables.AxisCnt; i++)
                    {
                        lstV_AxisInfo.Items[i].SubItems[4].Text = GetAxisStateStr(u32Value32[i]);
                    }
                }

                ret = CEcatLib.ECAT_McGetAxisLastError_Ex(Variables.DeviceNo, 65535, ref i32Value32[0]);
                if (ret == 0)
                {
                    for (i = 0; i < Variables.AxisCnt; i++)
                    {
                        str1 = i32Value32[i].ToString();
                        lstV_AxisInfo.Items[i].SubItems[5].Text = str1;
                    }
                }

                ret = CEcatLib.ECAT_McGetAxisDriveError_Ex(Variables.DeviceNo, 65535, ref u16Value32[0]);
                if (ret == 0)
                {
                    for (i = 0; i < Variables.AxisCnt; i++)
                    {
                        str1 = u16Value32[i].ToString();
                        lstV_AxisInfo.Items[i].SubItems[6].Text = str1;
                    }
                }                
            }            
        }

        public void SetAxisServo(ushort AxisNo, ushort OnOff)
        {
            int ret = 0;
            string str1;

            if (AxisNo > CEcatDef.MC_AXIS_NO_MAX)
            {
                str1 = "Axis number (" + AxisNo.ToString() + ")  exceed MC_AXIS_NO_MAX (" + CEcatDef.MC_AXIS_NO_MAX.ToString() + ")";
                LogMessage(str1);
                return;
            }

            do
            {
                /*
                when error occurred on master or motor driver
                it will take few ms to process error
                in the meantime, ServoOn or ErrorReset will return -1137

                P.S. ServoOn also has the function of clearing errors
                */
                ret = CEcatLib.ECAT_McSetAxisServoOn(Variables.DeviceNo, AxisNo, OnOff);
            } while (ret == -1137);
            if (ret < 0)
            {
                if (OnOff > 0)
                    str1 = "Failed to set axis " + AxisNo.ToString() + " servo on: " + ret.ToString();
                else
                    str1 = "Failed to set axis " + AxisNo.ToString() + " servo off: " + ret.ToString();
                LogMessage(str1);
            }
            else
            {
                uint u32Value = 0;
                uint reqState;
                if (OnOff > 0)
                    reqState = CEcatDef.MC_AS_STANDSTILL;
                else
                    reqState = CEcatDef.MC_AS_DISABLED;
                for (ushort i = 0; i < 10; i++)
                {
                    ret = CEcatLib.ECAT_McGetAxisState_Ex(Variables.DeviceNo, AxisNo, ref u32Value);
                    if (ret == 0 && u32Value == reqState)
                        break;
                    Thread.Sleep(100);
                }
                if (ret != 0 || u32Value != reqState)
                {
                    if (OnOff > 0)
                        str1 = "Failed to set axis " + AxisNo.ToString() + " servo on: " + ret.ToString();
                    else
                        str1 = "Failed to set axis " + AxisNo.ToString() + " servo off: " + ret.ToString();
                    LogMessage(str1);
                }
            }
        }

        private void btnAxisServoOn_Click(object sender, EventArgs e)
        {
            if (lstV_AxisInfo.CheckedItems.Count == 0)
                return;
            for (ushort i = 0; i < Variables.AxisCnt; i++)
                if (lstV_AxisInfo.Items[i].Checked) SetAxisServo(i, 1); 
        }

        private void btnAxisServoOff_Click(object sender, EventArgs e)
        {
            if (lstV_AxisInfo.CheckedItems.Count == 0)
                return;
            for (ushort i = 0; i < Variables.AxisCnt; i++)
                if (lstV_AxisInfo.Items[i].Checked) SetAxisServo(i, 0); 
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            int ret = 0;
            string str1;
            timer1.Enabled = false;
            //================= 關閉程式前的安全步驟 ================
            // 1: 停止馬達運行
            if (Variables.bInitMotion)
            {
                for (ushort i = 0; i < Variables.AxisCnt; i++)
                {
                    CEcatLib.ECAT_McSetAxisServoOn(Variables.DeviceNo, i, 0);
                    Thread.Sleep(100);
                }
            }
            // 2: 停止OP狀態
            if (Variables.bStateOP)
            {
                ret = CEcatLib.ECAT_StopDeviceOpTask(Variables.DeviceNo);

                if (ret < 0)
                {
                    str1 = "Failed to stop device op task: " + ret.ToString("D");
                    LogMessage(str1);
                }
                else
                {
                    WidgetEnabledByRunMode(Constants.DEV_RM_IS_OPEN);
                }
            }

            Variables.bEvStart = false;            
            thread1.Abort();

            // 3: 關閉通訊操作
            if (Variables.bDevOpen)
            {
                ret = CEcatLib.ECAT_CloseDevice(Variables.DeviceNo);
                if (ret < 0)
                {
                    str1 = "Failed to close EcatDevice: " + ret.ToString("D");
                    LogMessage(str1);
                }
                else
                {
                    WidgetEnabledByRunMode(Constants.DEV_RM_IS_CLOSE);
                }
            }
 
            Variables.bEvStart = false;            
        }

        public void SetAxisMoveJog(ushort AxisNo, bool Dir, double Vel)
        {
            int ret = 0;
            string str1;

            if (AxisNo > CEcatDef.MC_AXIS_NO_MAX)
            {
                str1 = "Axis number (" + AxisNo.ToString() + ")  exceed MC_AXIS_NO_MAX (" + CEcatDef.MC_AXIS_NO_MAX.ToString() + ")";
                LogMessage(str1);
                return;
            }

            if (Dir) ret = CEcatLib.ECAT_McAxisMoveVel(Variables.DeviceNo, AxisNo, Vel);
            else ret = CEcatLib.ECAT_McAxisMoveVel(Variables.DeviceNo, AxisNo, -Vel);

            if (ret < 0)
            {
                if (Dir) str1 = "Axis[" + AxisNo.ToString() + "] MoveJog+ failed: " + ret.ToString();
                else str1 = "Axis[" + AxisNo.ToString() + "] MoveJog- failed: " + ret.ToString();
                LogMessage(str1);
            }
        }

        private void btnAxisMoveJogP_Click(object sender, EventArgs e)
        {
            ushort i;
            string str1;
            double[] Vel = new double[CEcatDef.MC_AXIS_NO_MAX];

            int argc = 0;    // number of velocity cmd to axes
            str1 = textAxisVel.Text;
            if (str1 != "")
            {
                string[] strVelData = str1.Split(',');
                foreach (string tmp in strVelData)
                {
                    Vel[argc] = Convert.ToDouble(tmp);
                    argc++;
                }
            }
            else
            {
                LogMessage("Velocity list format error! ex:(1,1,1,1)");
                return;
            }
            
            if (lstV_AxisInfo.CheckedItems.Count == 0)
            {
                LogMessage("AxisStop: No Axis selected!");
                return;
            }

            int iCnt = 0;
            for (i = 0; i < Variables.AxisCnt; i++)
            {
                if (lstV_AxisInfo.Items[i].Checked)
                {
                    if (iCnt < argc)
                    {
                        SetAxisMoveJog(i, true, Vel[iCnt]);
                        iCnt++;
                    }
                    else
                        break;
                }
            }            
        }

        private void btnAxisMoveJogN_Click(object sender, EventArgs e)
        {
            ushort i;
            string str1;
            double[] Vel = new double[CEcatDef.MC_AXIS_NO_MAX];

            int argc = 0;    // number of velocity cmd to axes
            str1 = textAxisVel.Text;
            if (str1 != "")
            {
                string[] strVelData = str1.Split(',');
                foreach (string tmp in strVelData)
                {
                    Vel[argc] = Convert.ToDouble(tmp);
                    argc++;
                }
            }
            else
            {
                LogMessage("Velocity list format error! ex:(1,1,1,1)");
                return;
            }

            if (lstV_AxisInfo.CheckedItems.Count == 0)
            {
                LogMessage("AxisStop: No Axis selected!");
                return;
            }

            int iCnt = 0;
            for (i = 0; i < Variables.AxisCnt; i++)
            {
                if (lstV_AxisInfo.Items[i].Checked)
                {
                    if (iCnt < argc)
                    {
                        SetAxisMoveJog(i, false, Vel[iCnt]);
                        iCnt++;
                    }
                    else
                        break;
                }
            }
        }

        private void btnAxisStop_Click(object sender, EventArgs e)
        {
            int ret = 0;
            ushort i;
            string str1;
                        
            if (lstV_AxisInfo.CheckedItems.Count == 0)
            {
                LogMessage("AxisStop: No Axis selected!");
                return;
            }

            for (i = 0; i < Variables.AxisCnt; i++)
            {
                if (lstV_AxisInfo.Items[i].Checked)
                {
                    ret = CEcatLib.ECAT_McAxisStop(Variables.DeviceNo, i);

                    if (ret < 0)
                    {
                        str1 = "Axis[" + i.ToString() + "] stop failed: " + ret.ToString();
                        LogMessage(str1);
                    }
                }
            }
            
        }

        private void btnAxisReset_Click(object sender, EventArgs e)
        {
            int ret = 0;
            ushort i;
            string str1;

            if (lstV_AxisInfo.CheckedItems.Count == 0)
            {
                LogMessage("ResetError: No Axis selected!");
                return;
            }

            for (i = 0; i < Variables.AxisCnt; i++)
            {
                if (lstV_AxisInfo.Items[i].Checked)
                {
                    do
                    {
                        /*
                        when error occurred on master or motor driver
                        it will take few ms to process error
                        in the meantime, ServoOn or ErrorReset will return -1137

                        P.S. ServoOn also has the function of clearing errors
                        */
                        ret = CEcatLib.ECAT_McAxisErrorReset(Variables.DeviceNo, i);
                    } while (ret == -1137);
                    if (ret < 0)
                    {
                        str1 = "Axis[" + i.ToString() + "] ResetError failed: " + ret.ToString();
                        LogMessage(str1);
                    }
                    else
                    {
                        uint u32Value = 0;
                        for (ushort j = 0; j < 10; j++)
                        {
                            ret = CEcatLib.ECAT_McGetAxisState_Ex(Variables.DeviceNo, i, ref u32Value);
                            if (ret == 0 && (u32Value == CEcatDef.MC_AS_STANDSTILL || u32Value == CEcatDef.MC_AS_DISABLED))
                                break;
                            Thread.Sleep(100);
                        }
                        if (ret != 0 || (u32Value != CEcatDef.MC_AS_STANDSTILL && u32Value != CEcatDef.MC_AS_DISABLED))
                        {
                            str1 = "Axis Error Reset failed:ret: " + ret.ToString("D") + ":State:" + u32Value.ToString("D");
                            Console.WriteLine(str1);
                        }
                    }
                }
            }
        }

        private void btnEv0Enable_Click(object sender, EventArgs e)
        {
            int ret = 0;
            ushort i;
            string str1;
            ushort EventId = 0;
            double CmpPos = 0;
            ushort Operator = 0;

            str1 = textEv0Pos.Text;
            CmpPos = Convert.ToDouble(str1);
            Operator = (ushort)cmbEv0Op.SelectedIndex;

            for (i = 0; i < Variables.AxisCnt; i++)
            {
                if (lstV_AxisInfo.Items[i].Checked)
                {
                    ret = CEcatLib.ECAT_EvSetComparePositionParameters(Variables.DeviceNo, EventId, i, Operator, CmpPos);
                    if (ret < 0)
                    {
                        str1 = "Axis[" + i.ToString() + "] EvSetComparePositionParameters failed: " + ret.ToString();
                        LogMessage(str1);
                        return;
                    }

                    ret = CEcatLib.ECAT_EvEnableEvent(Variables.DeviceNo, EventId);
                    if (ret < 0)
                    {
                        str1 = "Axis[" + i.ToString() + "] EvEnableEvent failed: " + ret.ToString();
                        LogMessage(str1);
                        return;
                    }

                    str1 = "Axis[" + i.ToString() + "] EvComparePosition Start with pos: " + textEv0Pos.Text;
                    LogMessage(str1);

                    Variables.bEvEnable = true;
                    break;
                }
            }
        }

        private void btnEv1Enable_Click(object sender, EventArgs e)
        {
            int ret = 0;
            ushort i;
            string str1;
            ushort EventId = 1;
            double CmpPos = 0;
            ushort Operator = 0;

            str1 = textEv1Pos.Text;
            CmpPos = Convert.ToDouble(str1);
            Operator = (ushort)cmbEv1Op.SelectedIndex;

            for (i = 0; i < Variables.AxisCnt; i++)
            {
                if (lstV_AxisInfo.Items[i].Checked)
                {
                    ret = CEcatLib.ECAT_EvSetCompareCmdPositionParameters(Variables.DeviceNo, EventId, i, Operator, CmpPos);
                    if (ret < 0)
                    {
                        str1 = "Axis[" + i.ToString() + "] EvSetCompareCmdPositionParameters failed: " + ret.ToString();
                        LogMessage(str1);
                        return;
                    }

                    ret = CEcatLib.ECAT_EvEnableEvent(Variables.DeviceNo, EventId);
                    if (ret < 0)
                    {
                        str1 = "Axis[" + i.ToString() + "] EvEnableEvent failed: " + ret.ToString();
                        LogMessage(str1);
                        return;
                    }

                    str1 = "Axis[" + i.ToString() + "] EvCompareCmdPosition Start with pos: " + textEv1Pos.Text;
                    LogMessage(str1);

                    Variables.bEvEnable = true;
                    break;
                }
            }
        }

        private void btnEv2Enable_Click(object sender, EventArgs e)
        {
            int ret = 0;
            ushort i;
            string str1;
            ushort EventId = 2;
            ushort CmpState = 0;

            CmpState = (ushort)cmbEv2State.SelectedIndex;

            for (i = 0; i < Variables.AxisCnt; i++)
            {
                if (lstV_AxisInfo.Items[i].Checked)
                {
                    ret = CEcatLib.ECAT_EvSetCompareAxisStateParameters(Variables.DeviceNo, EventId, i, CmpState);
                    if (ret < 0)
                    {
                        str1 = "Axis[" + i.ToString() + "] EvSetCompareAxisStateParameters failed: " + ret.ToString();
                        LogMessage(str1);
                        return;
                    }

                    ret = CEcatLib.ECAT_EvEnableEvent(Variables.DeviceNo, EventId);
                    if (ret < 0)
                    {
                        str1 = "Axis[" + i.ToString() + "] EvEnableEvent failed: " + ret.ToString();
                        LogMessage(str1);
                        return;
                    }

                    str1 = "Axis[" + i.ToString() + "] EvCompareAxisStateParameters Start with state: " + cmbEv2State.Text;
                    LogMessage(str1);

                    Variables.bEvEnable = true;
                    break;
                }
            }
        }

        private void btnEv3Enable_Click(object sender, EventArgs e)
        {
            int ret = 0;
            ushort i;
            string str1;
            ushort EventId = 3;
            ushort CmpState = 0;

            CmpState = (ushort)cmbEv3State.SelectedIndex;

            for (i = 0; i < Variables.AxisCnt; i++)
            {
                if (lstV_AxisInfo.Items[i].Checked)
                {
                    ret = CEcatLib.ECAT_EvSetCompareAxisVelStateParameters(Variables.DeviceNo, EventId, i, CmpState);
                    if (ret < 0)
                    {
                        str1 = "Axis[" + i.ToString() + "] EvSetCompareAxisVelStateParameters failed: " + ret.ToString();
                        LogMessage(str1);
                        return;
                    }

                    ret = CEcatLib.ECAT_EvEnableEvent(Variables.DeviceNo, EventId);
                    if (ret < 0)
                    {
                        str1 = "Axis[" + i.ToString() + "] EvEnableEvent failed: " + ret.ToString();
                        LogMessage(str1);
                        return;
                    }

                    str1 = "Axis[" + i.ToString() + "] EvCompareAxisVelStateParameters Start with state: " + cmbEv3State.Text;
                    LogMessage(str1);

                    Variables.bEvEnable = true;
                    break;
                }
            }
        }
    }
}
