﻿using System;
using System.Text;
using System.Runtime.InteropServices;


namespace EcatLib
{
    public class CEcatLib
    {
        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_GetDllVersion")]
        public static extern int ECAT_GetDllVersion(string Version, ref ushort Size);
        
        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_GetFirmwareVersion")]
        public static extern int ECAT_GetFirmwareVersion(ushort DeviceNo, StringBuilder Version, ref ushort Size);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_GetDeviceCnt")]
        public static extern int ECAT_GetDeviceCnt(ref ushort DeviceCnt, byte[] CardID);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_OpenDevice")]
        public static extern int ECAT_OpenDevice(ushort DeviceNo);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_CloseDevice")]
        public static extern int ECAT_CloseDevice(ushort DeviceNo);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_GetDeviceSerialNo")]
        public static extern int ECAT_GetDeviceSerialNo(ushort DeviceNo, ref byte SerialNo);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_GetDeviceDI")]
        public static extern int ECAT_GetDeviceDI(ushort DeviceNo, ref uint  Value);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_GetDeviceDIBit")]
        public static extern int ECAT_GetDeviceDIBit(ushort DeviceNo, ushort BitNo, ref uint  Value);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_GetDeviceDO")]
        public static extern int ECAT_GetDeviceDO(ushort DeviceNo, ref uint  Value);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_GetDeviceDOBit")]
        public static extern int ECAT_GetDeviceDOBit(ushort DeviceNo, ushort BitNo, ref uint  Value);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_SetDeviceDO")]
        public static extern int ECAT_SetDeviceDO(ushort DeviceNo, uint  Value);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_SetDeviceDOBit")]
        public static extern int ECAT_SetDeviceDOBit(ushort DeviceNo, ushort BitNo, uint  Value);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_GetDeviceState")]
        public static extern int ECAT_GetDeviceState(ushort DeviceNo, ref uint LinkUp, ref uint SlavesResp, ref uint AlStates, ref uint Wc);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_GetSlaveInfo")]        
        public static extern int ECAT_GetSlaveInfo(ushort DeviceNo, ushort SlaveNo, ref ushort Alias, ref uint  ProductCode, ref uint  VendorID,
        ref uint RevisionNo, ref uint SerialNo, ref byte AlState, ref uint SlaveType, StringBuilder SlaveName);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_UploadNetworkInfo")]
        public static extern int ECAT_UploadNetworkInfo(ushort DeviceNo, ushort NetworkInfoNo, uint Offset, string Data, uint DataSize, byte LastFlag);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_UploadFirmware")]
        public static extern int ECAT_UploadFirmware(ushort DeviceNo, uint Offset, string Data, uint DataSize, byte LastFlag);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_DownloadNetworkInfo")]
        public static extern int ECAT_DownloadNetworkInfo(ushort DeviceNo, ushort NetworkInfoNo, ref uint Offset, StringBuilder Data, ref uint DataSize, ref byte LastFlag);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_GetSlaveSdoObject")]
        public static extern int ECAT_GetSlaveSdoObject(ushort DeviceNo, ushort SlaveNo, ushort Index, byte SubIndex, ushort DataSize, ref uint  ObjectVal, ref uint  AbortCode);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_SetSlaveSdoObject")]
        public static extern int ECAT_SetSlaveSdoObject(ushort DeviceNo, ushort SlaveNo, ushort Index, byte SubIndex, ushort DataSize, uint  ObjectVal, ref uint  AbortCode);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_SlaveNonBlockSdoRequestRead")]
        public static extern int ECAT_SlaveNonBlockSdoRequestRead(ushort DeviceNo, ushort SlaveNo, ushort Index, byte SubIndex, uint Timeout_ms);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_SlaveNonBlockSdoRequestReadState")]
        public static extern int ECAT_SlaveNonBlockSdoRequestReadState(ushort DeviceNo, ushort SlaveNo, ushort DataSize, ref uint ObjectVal);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_SlaveNonBlockSdoRequestWrite")]
        public static extern int ECAT_SlaveNonBlockSdoRequestWrite(ushort DeviceNo, ushort SlaveNo, ushort Index, byte SubIndex, ushort DataSize, uint ObjectVal, uint Timeout_ms);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_SlaveNonBlockSdoRequestWriteState")]
        public static extern int ECAT_SlaveNonBlockSdoRequestWriteState(ushort DeviceNo, ushort SlaveNo, ushort DataSize);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_StartDeviceOpTask")]
        public static extern int ECAT_StartDeviceOpTask(ushort DeviceNo, ushort NetworkInfoNo, byte EnumCycleTime, uint  WcErrCnt);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_StopDeviceOpTask")]
        public static extern int ECAT_StopDeviceOpTask(ushort DeviceNo);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_SetSlaveRxPdoData")]
        public static extern int ECAT_SetSlaveRxPdoData(ushort DeviceNo, ushort SlaveNo, ushort OffsetByte, ushort DataSize, ref byte Data);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_SetSlaveRxPdoData")]
        public static extern int ECAT_SetSlaveRxPdoData(ushort DeviceNo, ushort SlaveNo, ushort OffsetByte, ushort DataSize, byte[] Data);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_GetSlaveRxPdoData")]
        public static extern int ECAT_GetSlaveRxPdoData(ushort DeviceNo, ushort SlaveNo, ushort OffsetByte, ushort DataSize, ref byte Data);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_GetSlaveRxPdoData")]
        public static extern int ECAT_GetSlaveRxPdoData(ushort DeviceNo, ushort SlaveNo, ushort OffsetByte, ushort DataSize, byte[] Data);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_GetSlaveRxPdoOffset")]
        public static extern int ECAT_GetSlaveRxPdoOffset(ushort DeviceNo, ushort SlaveNo, byte channel, ref ushort OffsetByte);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_GetSlaveRxPdoChannel")]
        public static extern int ECAT_GetSlaveRxPdoChannel(ushort DeviceNo, ushort SlaveNo, ref byte channel, ref byte bitsize);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_GetSlaveTxPdoData")]
        public static extern int ECAT_GetSlaveTxPdoData(ushort DeviceNo, ushort SlaveNo, ushort OffsetByte, ushort DataSize, ref byte Data);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_GetSlaveTxPdoData")]
        public static extern int ECAT_GetSlaveTxPdoData(ushort DeviceNo, ushort SlaveNo, ushort OffsetByte, ushort DataSize, byte[] Data);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_GetSlaveTxPdoOffset")]
        public static extern int ECAT_GetSlaveTxPdoOffset(ushort DeviceNo, ushort SlaveNo, byte channel, ref ushort OffsetByte);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_GetSlaveTxPdoChannel")]
        public static extern int ECAT_GetSlaveTxPdoChannel(ushort DeviceNo, ushort SlaveNo, ref byte channel, ref byte bitsize);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_GetSlaveDI")]
        public static extern int ECAT_GetSlaveDI(ushort DeviceNo, ushort SlaveNo, ref uint Value);
        
        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_GetSlaveDIBit")]
        public static extern int ECAT_GetSlaveDIBit(ushort DeviceNo, ushort SlaveNo, ushort BitNo, ref uint Value);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_GetSlaveDO")]
        public static extern int ECAT_GetSlaveDO(ushort DeviceNo, ushort SlaveNo, ref uint Value);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_GetSlaveDOBit")]
        public static extern int ECAT_GetSlaveDOBit(ushort DeviceNo, ushort SlaveNo, ushort BitNo, ref uint Value);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_SetSlaveDO")]
        public static extern int ECAT_SetSlaveDO(ushort DeviceNo, ushort SlaveNo, uint Value);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_SetSlaveDOBit")]
        public static extern int ECAT_SetSlaveDOBit(ushort DeviceNo, ushort SlaveNo, ushort BitNo, uint Value);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_SetSlaveAoProperty")]
        public static extern int ECAT_SetSlaveAoProperty(ushort DeviceNo, ushort SlaveNo, ushort ChannelNo, byte Range);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_GetSlaveAoProperty")]
        public static extern int ECAT_GetSlaveAoProperty(ushort DeviceNo, ushort SlaveNo, ushort ChannelNo, ref byte Range);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_SetSlaveAoRawData")]
        public static extern int ECAT_SetSlaveAoRawData(ushort DeviceNo, ushort SlaveNo, ushort ChannelNo, ushort Data);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_GetSlaveAoRawData")]
        public static extern int ECAT_GetSlaveAoRawData(ushort DeviceNo, ushort SlaveNo, ushort ChannelNo, ref ushort Data);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_SetSlaveAoVoltData")]
        public static extern int ECAT_SetSlaveAoVoltData(ushort DeviceNo, ushort SlaveNo, ushort ChannelNo, double Data);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_GetSlaveAoVoltData")]
        public static extern int ECAT_GetSlaveAoVoltData(ushort DeviceNo, ushort SlaveNo, ushort ChannelNo, ref double Data);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_SetSlaveEncProperty")]
        public static extern int ECAT_SetSlaveEncProperty(ushort DeviceNo, ushort SlaveNo, ushort EncNo, byte Mode, byte InvertCnt, byte LPF);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_GetSlaveEncProperty")]
        public static extern int ECAT_GetSlaveEncProperty(ushort DeviceNo, ushort SlaveNo, ushort EncNo, ref byte Mode, ref byte InvertCnt, ref byte LPF);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_GetSlaveEncCount")]
        public static extern int ECAT_GetSlaveEncCount(ushort DeviceNo, ushort SlaveNo, ushort EncNo, ref uint Cnt);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_ResetSlaveEncCount")]
        public static extern int ECAT_ResetSlaveEncCount(ushort DeviceNo, ushort SlaveNo, ushort EncNo);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_SetSlaveEncCount")]
        public static extern int ECAT_SetSlaveEncCount(ushort DeviceNo, ushort SlaveNo, ushort EncNo, int Value);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_SetSlaveEncIdxLatchProperty")]
        public static extern int ECAT_SetSlaveEncIdxLatchProperty(ushort DeviceNo, ushort SlaveNo, ushort EncNo, byte Enable);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_GetSlaveEncIdxLatchProperty")]
        public static extern int ECAT_GetSlaveEncIdxLatchProperty(ushort DeviceNo, ushort SlaveNo, ushort EncNo, ref byte Enable);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_GetSlaveEncIdxLatchCnt")]
        public static extern int ECAT_GetSlaveEncIdxLatchCnt(ushort DeviceNo, ushort SlaveNo, ushort EncNo, ref int Cnt);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_ResetSlaveEncIdxLatchCnt")]
        public static extern int ECAT_ResetSlaveEncIdxLatchCnt(ushort DeviceNo, ushort SlaveNo, ushort EncNo);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_SetSlaveEncExtLatchProperty")]
        public static extern int ECAT_SetSlaveEncExtLatchProperty(ushort DeviceNo, ushort SlaveNo, ushort EncNo, byte Enable, byte Mode, byte Logic);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_GetSlaveEncExtLatchProperty")]
        public static extern int ECAT_GetSlaveEncExtLatchProperty(ushort DeviceNo, ushort SlaveNo, ushort EncNo, ref byte Enable, ref byte Mode, ref byte Logic);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_GetSlaveEncExtLatchCnt")]
        public static extern int ECAT_GetSlaveEncExtLatchCnt(ushort DeviceNo, ushort SlaveNo, ushort EncNo, ref int Cnt_Rising, ref int Cnt_Falling);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_ResetSlaveEncExtLatchCnt")]
        public static extern int ECAT_ResetSlaveEncExtLatchCnt(ushort DeviceNo, ushort SlaveNo, ushort EncNo);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_SetSlaveCmpTrigProperty")]
        public static extern int ECAT_SetSlaveCmpTrigProperty(ushort DeviceNo, ushort SlaveNo, ushort EncNo, ushort PulseWidth);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_GetSlaveCmpTrigProperty")]
        public static extern int ECAT_GetSlaveCmpTrigProperty(ushort DeviceNo, ushort SlaveNo, ushort EncNo, ref ushort PulseWidth);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_SetSlaveCmpTrigData")]
        public static extern int ECAT_SetSlaveCmpTrigData(ushort DeviceNo, ushort SlaveNo, ushort EncNo, int CmpData);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_SetSlaveContCmpTrigData")]
        public static extern int ECAT_SetSlaveContCmpTrigData(ushort DeviceNo, ushort SlaveNo, ushort EncNo, int Start, uint Interval, byte Dir);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McInit")]
        public static extern int ECAT_McInit(ushort DeviceNo, ushort[] SlaveNo, ushort[] SubAxisNo, ushort AxisCount);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McSetAxisServoOn")]
        public static extern int ECAT_McSetAxisServoOn(ushort DeviceNo, ushort AxisNo, ushort State);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McSetAxisPPU")]
        public static extern int ECAT_McSetAxisPPU(ushort DeviceNo, ushort AxisNo, double PPU);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetAxisPPU")]
        public static extern int ECAT_McGetAxisPPU(ushort DeviceNo, ushort AxisNo, ref double PPU);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McSetAxisEncoderPPR")]
        public static extern int ECAT_McSetAxisEncoderPPR(ushort DeviceNo, ushort AxisNo, uint  PPR);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetAxisEncoderPPR")]
        public static extern int ECAT_McGetAxisEncoderPPR(ushort DeviceNo, ushort AxisNo, ref uint  PPR);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McSetAxisMotorPPR")]
        public static extern int ECAT_McSetAxisMotorPPR(ushort DeviceNo, ushort AxisNo, uint  PPR);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetAxisMotorPPR")]
        public static extern int ECAT_McGetAxisMotorPPR(ushort DeviceNo, ushort AxisNo, ref uint  PPR);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McSetAxisHomeMethod")]
        public static extern int ECAT_McSetAxisHomeMethod(ushort DeviceNo, ushort AxisNo, int Method);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetAxisHomeMethod")]
        public static extern int ECAT_McGetAxisHomeMethod(ushort DeviceNo, ushort AxisNo, ref int Method);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McSetAxisHomeSpeed")]
        public static extern int ECAT_McSetAxisHomeSpeed(ushort DeviceNo, ushort AxisNo, double SeachSw, double SeachZr);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetAxisHomeSpeed")]
        public static extern int ECAT_McGetAxisHomeSpeed(ushort DeviceNo, ushort AxisNo, ref double SeachSw, ref double SeachZr);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McSetAxisHomeAcc")]
        public static extern int ECAT_McSetAxisHomeAcc(ushort DeviceNo, ushort AxisNo, double Acc);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetAxisHomeAcc")]
        public static extern int ECAT_McGetAxisHomeAcc(ushort DeviceNo, ushort AxisNo, ref double Acc);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McSetAxisHomeOffset")]
        public static extern int ECAT_McSetAxisHomeOffset(ushort DeviceNo, ushort AxisNo, double Offset);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetAxisHomeOffset")]
        public static extern int ECAT_McGetAxisHomeOffset(ushort DeviceNo, ushort AxisNo, ref double Offset);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McSetAxisAccTime")]
        public static extern int ECAT_McSetAxisAccTime(ushort DeviceNo, ushort AxisNo, ushort Time_ms);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetAxisAccTime")]
        public static extern int ECAT_McGetAxisAccTime(ushort DeviceNo, ushort AxisNo, ref ushort Time_ms);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McSetAxisAccDecType")]
        public static extern int ECAT_McSetAxisAccDecType(ushort DeviceNo, ushort AxisNo, ushort Type);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetAxisAccDecType")]
        public static extern int ECAT_McGetAxisAccDecType(ushort DeviceNo, ushort AxisNo, ref ushort Type);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McSetVirtualAxisEncoder")]
        public static extern int ECAT_McSetVirtualAxisEncoder(ushort DeviceNo, ushort AxisNo, ushort SlaveNo, ushort EncNo, byte Enable);
        
        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetVirtualAxisEncoder")]
        public static extern int ECAT_McGetVirtualAxisEncoder(ushort DeviceNo, ushort AxisNo, ref ushort SlaveNo, ref ushort EncNo, ref byte Enable);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McSetAxisTouchProbeProperty")]
        public static extern int ECAT_McSetAxisTouchProbeProperty(ushort DeviceNo, ushort AxisNo, ushort ProbeNo, byte Enable, byte Logic);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetAxisTouchProbeProperty")]
        public static extern int ECAT_McGetAxisTouchProbeProperty(ushort DeviceNo, ushort AxisNo, ushort ProbeNo, ref byte Enable, ref byte Logic);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetAxisTouchProbeValue")]
        public static extern int ECAT_McGetAxisTouchProbeValue(ushort DeviceNo, ushort AxisNo, ushort ProbeNo, ref double Value);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetAxisState")]
        public static extern int ECAT_McGetAxisState(ushort DeviceNo, ushort AxisNo, ref uint State);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetAxisState")]
        public static extern int ECAT_McGetAxisState(ushort DeviceNo, ushort AxisNo, uint[] State);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetAxisMotionState")]
        public static extern int ECAT_McGetAxisMotionState(ushort DeviceNo, ushort AxisNo, ref uint State);        

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetAxisLastError")]
        public static extern int ECAT_McGetAxisLastError(ushort DeviceNo, ushort AxisNo, ref int  Error);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetAxisLastError")]
        public static extern int ECAT_McGetAxisLastError(ushort DeviceNo, ushort AxisNo, int[] Error);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetAxisDriveError")]
        public static extern int ECAT_McGetAxisDriveError(ushort DeviceNo, ushort AxisNo, ref ushort Error);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetAxisDriveError")]
        public static extern int ECAT_McGetAxisDriveError(ushort DeviceNo, ushort AxisNo, ushort[] Error);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetAxisCommandPos")]
        public static extern int ECAT_McGetAxisCommandPos(ushort DeviceNo, ushort AxisNo, ref double Pos);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetAxisCommandPos")]
        public static extern int ECAT_McGetAxisCommandPos(ushort DeviceNo, ushort AxisNo, double[] Pos);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetAxisActualPos")]
        public static extern int ECAT_McGetAxisActualPos(ushort DeviceNo, ushort AxisNo, ref double Pos);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetAxisActualPos")]
        public static extern int ECAT_McGetAxisActualPos(ushort DeviceNo, ushort AxisNo, double[] Pos);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetAxisActualVel")]
        public static extern int ECAT_McGetAxisActualVel(ushort DeviceNo, ushort AxisNo, ref double Vel);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetAxisActualVel")]
        public static extern int ECAT_McGetAxisActualVel(ushort DeviceNo, ushort AxisNo, double[] Vel);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetAxisDI")]
        public static extern int ECAT_McGetAxisDI(ushort DeviceNo, ushort AxisNo, ref uint  DI);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetAxisDI")]
        public static extern int ECAT_McGetAxisDI(ushort DeviceNo, ushort AxisNo, uint[] DI);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McSetProfileData")]
        public static extern int ECAT_McSetProfileData(ushort DeviceNo, ushort ProfileNo, ref double Data, ushort DataSize);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McSetProfileData")]
        public static extern int ECAT_McSetProfileData(ushort DeviceNo, ushort ProfileNo, double[] Data, ushort DataSize);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetProfileData")]
        public static extern int ECAT_McGetProfileData(ushort DeviceNo, ushort ProfileNo, ref double Data, ushort DataSize);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetProfileData")]
        public static extern int ECAT_McGetProfileData(ushort DeviceNo, ushort ProfileNo, double[] Data, ushort DataSize);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McSetProfileCSV")]
        public static extern int ECAT_McSetProfileCSV(ushort DeviceNo, ushort ProfileNo, uint Offset, string Data, uint DataSize, byte LastFlag);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetProfileCSV")]
        public static extern int ECAT_McGetProfileCSV(ushort DeviceNo, ushort ProfileNo, ref uint Offset, StringBuilder Data, ref uint DataSize, ref byte LastFlag);
        
        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McSetEcamTable")]
        public static extern int ECAT_McSetEcamTable(ushort DeviceNo, ushort TableNo, ref double Data, ushort DataSize);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McSetEcamTable")]
        public static extern int ECAT_McSetEcamTable(ushort DeviceNo, ushort TableNo, double[] Data, ushort DataSize);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetEcamTable")]
        public static extern int ECAT_McGetEcamTable(ushort DeviceNo, ushort TableNo, ref double Data, ushort DataSize);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetEcamTable")]
        public static extern int ECAT_McGetEcamTable(ushort DeviceNo, ushort TableNo, double[] Data, ushort DataSize);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McConfigEcamTable")]
        public static extern int ECAT_McConfigEcamTable(ushort DeviceNo, ushort TableNo, byte SlaveAbs);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McAxisHome")]
        public static extern int ECAT_McAxisHome(ushort DeviceNo, ushort AxisNo);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McAxisErrorReset")]
        public static extern int ECAT_McAxisErrorReset(ushort DeviceNo, ushort AxisNo);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McAxisStop")]
        public static extern int ECAT_McAxisStop(ushort DeviceNo, ushort AxisNo);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McAxisQuickStop")]
        public static extern int ECAT_McAxisQuickStop(ushort DeviceNo, ushort AxisNo);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McAxisMoveAbs")]
        public static extern int ECAT_McAxisMoveAbs(ushort DeviceNo, ushort AxisNo, double Pos, double Vel);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McAxisMoveRel")]
        public static extern int ECAT_McAxisMoveRel(ushort DeviceNo, ushort AxisNo, double Pos, double Vel);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McAxisChangePos")]
        public static extern int ECAT_McAxisChangePos(ushort DeviceNo, ushort AxisNo, double Pos);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McAxisChangeVel")]
        public static extern int ECAT_McAxisChangeVel(ushort DeviceNo, ushort AxisNo, double Vel);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McAxisMoveVel")]
        public static extern int ECAT_McAxisMoveVel(ushort DeviceNo, ushort AxisNo, double Vel);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McAxisMoveVelByPos")]
        public static extern int ECAT_McAxisMoveVelByPos(ushort DeviceNo, ushort AxisNo, double Vel);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McAxisGearIn")]
        public static extern int ECAT_McAxisGearIn(ushort DeviceNo, ushort MasterNo, ushort SlaveNo, int RatioNum, uint RationDen, ushort SyncSource);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McAxisGearOut")]
        public static extern int ECAT_McAxisGearOut(ushort DeviceNo, ushort SlaveNo, ushort Stop);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McAxisMoveProfile")]
        public static extern int ECAT_McAxisMoveProfile(ushort DeviceNo, ushort AxisNo, ushort ProfileNo, ushort TotalStep);
        
        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McAxisMoveProfileCSV")]
        public static extern int ECAT_McAxisMoveProfileCSV(ushort DeviceNo, ushort AxisNo, ushort ProfileNo);
        
        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McAxisCamIn")]
        public static extern int ECAT_McAxisCamIn(ushort DeviceNo, ushort MasterNo, ushort SlaveNo, ushort TableNo, ushort SyncSource, double MasterInterval, double SlaveScaling);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McAxisCamOut")]
        public static extern int ECAT_McAxisCamOut(ushort DeviceNo, ushort SlaveNo);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McAxisCamPhaseShift")]
        public static extern int ECAT_McAxisCamPhaseShift(ushort DeviceNo, ushort SlaveNo, double PhaseShift);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McAxisTangentInGroup")]
        public static extern int ECAT_McAxisTangentInGroup(ushort DeviceNo, ushort AxisNo, ushort GroupNo, double Angle, double Vel);        

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McAddAxisToGroup")]
        public static extern int ECAT_McAddAxisToGroup(ushort DeviceNo, ushort GroupNo, ushort AxisNo);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McRemoveAxisFromGroup")]
        public static extern int ECAT_McRemoveAxisFromGroup(ushort DeviceNo, ushort GroupNo, ushort AxisNo);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McUngroupAllAxes")]
        public static extern int ECAT_McUngroupAllAxes(ushort DeviceNo, ushort GroupNo);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McSetGroupCmdMode")]
        public static extern int ECAT_McSetGroupCmdMode(ushort DeviceNo, ushort GroupNo, ushort CmdMode);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetGroupCmdMode")]
        public static extern int ECAT_McGetGroupCmdMode(ushort DeviceNo, ushort GroupNo, ref ushort CmdMode);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetGroupState")]
        public static extern int ECAT_McGetGroupState(ushort DeviceNo, ushort GroupNo, ref uint  State);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetGroupCmdBuffer")]
        public static extern int ECAT_McGetGroupCmdBuffer(ushort DeviceNo, ushort GroupNo, ref ushort Buffer);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McSetGroupAccTime")]
        public static extern int ECAT_McSetGroupAccTime(ushort DeviceNo, ushort GroupNo, ushort Time_ms);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetGroupAccTime")]
        public static extern int ECAT_McGetGroupAccTime(ushort DeviceNo, ushort GroupNo, ref ushort Time_ms);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McSetGroupAccDecType")]
        public static extern int ECAT_McSetGroupAccDecType(ushort DeviceNo, ushort GroupNo, ushort Type);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetGroupAccDecType")]
        public static extern int ECAT_McGetGroupAccDecType(ushort DeviceNo, ushort GroupNo, ref ushort Type);
        
        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGroupStop")]
        public static extern int ECAT_McGroupStop(ushort DeviceNo, ushort GroupNo);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGroupQuickStop")]
        public static extern int ECAT_McGroupQuickStop(ushort DeviceNo, ushort GroupNo);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGroupMoveLineAbs")]
        public static extern int ECAT_McGroupMoveLineAbs(ushort DeviceNo, ushort GroupNo, double[] Pos, double Vel);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGroupMoveLineAbs_PT")]
        public static extern int ECAT_McGroupMoveLineAbs_PT(ushort DeviceNo, ushort GroupNo, double[] Pos, double Time);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGroupMoveLineAbs_PTexT")]
        public static extern int ECAT_McGroupMoveLineAbs_PTexT(ushort DeviceNo, ushort GroupNo, double[] Pos, double Time, double exTime);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGroupMoveLineAbs_PVT")]
        public static extern int ECAT_McGroupMoveLineAbs_PVT(ushort DeviceNo, ushort GroupNo, double[] Pos, double[] Vel, double Time);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGroupMoveLineAbs_PPT")]
        public static extern int ECAT_McGroupMoveLineAbs_PPT(ushort DeviceNo, ushort GroupNo, double[] Pos, double Time);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGroupMoveLineAbs_PT_A")]
        public static extern int ECAT_McGroupMoveLineAbs_PT_A(ushort DeviceNo, ushort GroupNo, double[] Pos, double Time);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGroupMoveLineRel")]
        public static extern int ECAT_McGroupMoveLineRel(ushort DeviceNo, ushort GroupNo, double[] Pos, double Vel);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGroupMoveLineRel_PT")]
        public static extern int ECAT_McGroupMoveLineRel_PT(ushort DeviceNo, ushort GroupNo, double[] Pos, double Time);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGroupMoveLineRel_PTexT")]
        public static extern int ECAT_McGroupMoveLineRel_PTexT(ushort DeviceNo, ushort GroupNo, double[] Pos, double Time, double exTime);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGroupMoveLineRel_PVT")]
        public static extern int ECAT_McGroupMoveLineRel_PVT(ushort DeviceNo, ushort GroupNo, double[] Pos, double[] Vel, double Time);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGroupMoveLineRel_PPT")]
        public static extern int ECAT_McGroupMoveLineRel_PPT(ushort DeviceNo, ushort GroupNo, double[] Pos, double Time);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGroupMoveLineRel_PT_A")]
        public static extern int ECAT_McGroupMoveLineRel_PT_A(ushort DeviceNo, ushort GroupNo, double[] Pos, double Time);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGroupMoveShaker")]
        public static extern int ECAT_McGroupMoveShaker(ushort DeviceNo, ushort GroupNo, double Amp, double[] phase, double Freq, double Time);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGroupMoveCircularAbs")]
        public static extern int ECAT_McGroupMoveCircularAbs(ushort DeviceNo, ushort GroupNo, double Angle, double[] AuxPos, double Vel);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGroupMoveCircularAbs_CP_Angle")]
        public static extern int ECAT_McGroupMoveCircularAbs_CP_Angle(ushort DeviceNo, ushort GroupNo, double Vel, double Angle, double[] AuxPos);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGroupMoveCircularAbs_CP_EP")]
        public static extern int ECAT_McGroupMoveCircularAbs_CP_EP(ushort DeviceNo, ushort GroupNo, double Vel, byte Dir, double[] AuxPos, double[] EndPos);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGroupMoveCircularAbs_BP_EP")]
        public static extern int ECAT_McGroupMoveCircularAbs_BP_EP(ushort DeviceNo, ushort GroupNo, double Vel, byte Dir, double[] AuxPos, double[] EndPos);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGroupMove3DCircularAbs_CP_Angle")]
        public static extern int ECAT_McGroupMove3DCircularAbs_CP_Angle(ushort DeviceNo, ushort GroupNo, double Vel, double Angle, double[] AuxPos, double[] NV);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGroupMove3DCircularAbs_CP_EP")]
        public static extern int ECAT_McGroupMove3DCircularAbs_CP_EP(ushort DeviceNo, ushort GroupNo, double Vel, byte Dir, double[] AuxPos, double[] EndPos);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGroupMove3DCircularAbs_BP_EP")]
        public static extern int ECAT_McGroupMove3DCircularAbs_BP_EP(ushort DeviceNo, ushort GroupNo, double Vel, byte Dir, double[] AuxPos, double[] EndPos);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGroupMoveCircularRel")]
        public static extern int ECAT_McGroupMoveCircularRel(ushort DeviceNo, ushort GroupNo, double Angle, double[] AuxPos, double Vel);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGroupMoveCircularRel_CP_Angle")]
        public static extern int ECAT_McGroupMoveCircularRel_CP_Angle(ushort DeviceNo, ushort GroupNo, double Vel, double Angle, double[] AuxPos);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGroupMoveCircularRel_CP_EP")]
        public static extern int ECAT_McGroupMoveCircularRel_CP_EP(ushort DeviceNo, ushort GroupNo, double Vel, byte Dir, double[] AuxPos, double[] EndPos);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGroupMoveCircularRel_BP_EP")]
        public static extern int ECAT_McGroupMoveCircularRel_BP_EP(ushort DeviceNo, ushort GroupNo, double Vel, byte Dir, double[] AuxPos, double[] EndPos);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGroupMove3DCircularRel_CP_Angle")]
        public static extern int ECAT_McGroupMove3DCircularRel_CP_Angle(ushort DeviceNo, ushort GroupNo, double Vel, double Angle, double[] AuxPos, double[] NV);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGroupMove3DCircularRel_CP_EP")]
        public static extern int ECAT_McGroupMove3DCircularRel_CP_EP(ushort DeviceNo, ushort GroupNo, double Vel, byte Dir, double[] AuxPos, double[] EndPos);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGroupMove3DCircularRel_BP_EP")]
        public static extern int ECAT_McGroupMove3DCircularRel_BP_EP(ushort DeviceNo, ushort GroupNo, double Vel, byte Dir, double[] AuxPos, double[] EndPos);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGroupMoveHelicalAbs")]
        public static extern int ECAT_McGroupMoveHelicalAbs(ushort DeviceNo, ushort GroupNo, double Angle, double[] AuxPos, double Pitch, double Vel);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGroupMove3DHelicalAbs_CP_Angle")]
        public static extern int ECAT_McGroupMove3DHelicalAbs_CP_Angle(ushort DeviceNo, ushort GroupNo, double Vel, double Angle, double Pitch, double[] AuxPos, double[] NV);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGroupMoveHelicalRel")]
        public static extern int ECAT_McGroupMoveHelicalRel(ushort DeviceNo, ushort GroupNo, double Angle, double[] AuxPos, double Pitch, double Vel);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGroupMove3DHelicalRel_CP_Angle")]
        public static extern int ECAT_McGroupMove3DHelicalRel_CP_Angle(ushort DeviceNo, ushort GroupNo, double Vel, double Angle, double Pitch, double[] AuxPos, double[] NV);
        
        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGroupMoveConicalHelixAbs")]
        public static extern int ECAT_McGroupMoveConicalHelixAbs(ushort DeviceNo, ushort GroupNo, double Angle, double[] AuxPos, double Pitch, double Vel, double EndRadius);
        
        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGroupMove3DConicalHelixAbs_CP_Angle")]
        public static extern int ECAT_McGroupMove3DConicalHelixAbs_CP_Angle(ushort DeviceNo, ushort GroupNo, double Vel, double Angle, double Pitch, double[] AuxPos, double[] NV, double EndRadius);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGroupMoveConicalHelixRel")]
        public static extern int ECAT_McGroupMoveConicalHelixRel(ushort DeviceNo, ushort GroupNo, double Angle, double[] AuxPos, double Pitch, double Vel, double EndRadius);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGroupMove3DConicalHelixRel_CP_Angle")]
        public static extern int ECAT_McGroupMove3DConicalHelixRel_CP_Angle(ushort DeviceNo, ushort GroupNo, double Vel, double Angle, double Pitch, double[] AuxPos, double[] NV, double EndRadius);
        
        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGroupMoveProfile")]
        public static extern int ECAT_McGroupMoveProfile(ushort DeviceNo, ushort GroupNo, ushort[] ProfileNo, ushort TotalStep);        
        
        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGroupMoveProfileCSV")]
        public static extern int ECAT_McGroupMoveProfileCSV(ushort DeviceNo, ushort GroupNo, ushort ProfileNo);
        
        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGroupMoveDwell")]
        public static extern int ECAT_McGroupMoveDwell(ushort DeviceNo, ushort GroupNo, uint Cnt);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGroupMoveDO")]
        public static extern int ECAT_McGroupMoveDO(ushort DeviceNo, ushort GroupNo, ushort SlaveNo, ushort BitNo, uint Value);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGroupMoveBlendingSync")]
        public static extern int ECAT_McGroupMoveBlendingSync(ushort DeviceNo, ushort GroupNo);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_SetDeviceEncProperty")]
        public static extern int ECAT_SetDeviceEncProperty(ushort DeviceNo, ushort EncNo, byte Mode, byte InvertCnt, byte LPF);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_GetDeviceEncProperty")]
        public static extern int ECAT_GetDeviceEncProperty(ushort DeviceNo, ushort EncNo, ref byte Mode, ref byte InvertCnt, ref byte LPF);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_GetDeviceEnCount")]
        public static extern int ECAT_GetDeviceEnCount(ushort DeviceNo, ushort EncNo, ref int Cnt);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_GetDeviceEncCount")]
        public static extern int ECAT_GetDeviceEncCount(ushort DeviceNo, ushort EncNo, ref int Cnt);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_ResetDeviceEncCount")]
        public static extern int ECAT_ResetDeviceEncCount(ushort DeviceNo, ushort EncNo);        
                
        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_SetDeviceCmpTrigProperty")]
        public static extern int ECAT_SetDeviceCmpTrigProperty(ushort DeviceNo, ushort CmpNo, uint PulseWidth, byte Source);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_GetDeviceCmpTrigProperty")]
        public static extern int ECAT_GetDeviceCmpTrigProperty(ushort DeviceNo, ushort CmpNo, ref uint PulseWidth, ref byte Source);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_SetDeviceCmpTrigData")]
        public static extern int ECAT_SetDeviceCmpTrigData(ushort DeviceNo, ushort CmpNo, int CmpData);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_SetDeviceContCmpTrigData")]
        public static extern int ECAT_SetDeviceContCmpTrigData(ushort DeviceNo, ushort CmpNo, int Start, uint Interval, uint Times, byte Dir);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_SetDeviceEmg")]
        public static extern int ECAT_SetDeviceEmg(ushort DeviceNo, byte Source, byte Enable, byte Logic, ushort SlaveNo, ushort BitNo, byte ServoOff);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_GetDeviceEmg")]
        public static extern int ECAT_GetDeviceEmg(ushort DeviceNo, ref byte Source, ref byte Enable, ref byte Logic, ref ushort SlaveNo, ref ushort BitNo, ref byte ServoOff);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_GetDeviceEmgStatus")]
        public static extern int ECAT_GetDeviceEmgStatus(ushort DeviceNo, ref byte Status);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_SetDeviceEmgSoftSig")]
        public static extern int ECAT_SetDeviceEmgSoftSig(ushort DeviceNo);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_SetDeviceMPG")]
        public static extern int ECAT_SetDeviceMPG(ushort DeviceNo, byte Enable, ref ushort AxisNo, ushort AxisCount);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_GetDeviceMPG")]
        public static extern int ECAT_GetDeviceMPG(ushort DeviceNo, ref byte Enable, ref ushort AxisNo, ref ushort AxisCount);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_OpenMotionConfig")]
        public static extern int ECAT_OpenMotionConfig(string bstrFileName, ref ushort AxisCnt, ushort[] SlaveNo, ushort[] SubAxisNo, double[] PPU, int[] HomeMethod, double[] HomeSpeedSeachSw, double[] HomeSpeedSeachZr, double[] HomeAcc, uint[] EncoderPPR, uint[] MotorPPR);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_GetSlaveRegister")]
        public static extern int ECAT_GetSlaveRegister(ushort DeviceNo, ushort SlaveNo, ushort Addr, ushort DataSize, ref uint  Val, ref byte state);
        
        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_SetSlaveRegister")]
        public static extern int ECAT_SetSlaveRegister(ushort DeviceNo, ushort SlaveNo, ushort Addr, ushort DataSize, uint  Val, ref byte state);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetMotionRecordState")]
        public static extern int ECAT_McGetMotionRecordState(ushort DeviceNo, ref ushort state, ref uint count);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McSetMotionRecord")]
        public static extern int ECAT_McSetMotionRecord(ushort DeviceNo, ushort state);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_DownloadMotionLog")]
        public static extern int ECAT_DownloadMotionLog(ushort DeviceNo, ref uint Offset, StringBuilder Data, ref uint DataSize, ref byte LastFlag);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_SetTimer")]        
        public static extern int ECAT_SetTimer(ushort DeviceNo, uint Interval);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_SetTimerStop")]
        public static extern int ECAT_SetTimerStop(ushort DeviceNo);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetPdo_Directly")]
        public static extern int ECAT_McGetPdo_Directly(ushort DeviceNo, ushort Size, StringBuilder Data);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McSetStewartPlatform_M1")]
        public static extern int ECAT_McSetStewartPlatform_M1(ushort DeviceNo, double radiusB, double angleB, double radiusP, double angleP, double RodLength, double Max_RodLength);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetAxisActualPosVel")]
        public static extern int ECAT_McGetAxisActualPosVel(ushort DeviceNo, ushort AxisNo, ref float Pos, ref float Vel);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetAxisActualPosVel")]
        public static extern int ECAT_McGetAxisActualPosVel(ushort DeviceNo, ushort AxisNo, float[] Pos, float[] Vel);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_PidSetSetPointValue")]
        public static extern int ECAT_PidSetSetPointValue(ushort DeviceNo, uint PidNo, double SetPointValue);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_PidGetControlOutputValue")]
        public static extern int ECAT_PidGetControlOutputValue(ushort DeviceNo, uint PidNo, ref double Output);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_PidSetParameter")]
        public static extern int ECAT_PidSetParameter(ushort DeviceN, uint PidNoo, double kp, double ki, double kd);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_PidSetStatus")]
        public static extern int ECAT_PidSetStatus(ushort DeviceN, uint PidNo, byte status);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_PidSetSimulateMode")]
        public static extern int ECAT_PidSetSimulateMode(ushort DeviceN, uint PidNo, byte status);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_PidSetSampleTime")]
        public static extern int ECAT_PidSetSampleTime(ushort DeviceN, uint PidNo, uint Interval);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_PidSetProcessVariableModule")]
        public static extern int ECAT_PidSetProcessVariableModule(ushort DeviceN, uint PidNo, ushort SlaveNo, ushort OffsetByte, ushort Bitlength, double ScaleGain, double ScaleOffset);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_PidSetControlOutputModule")]
        public static extern int ECAT_PidSetControlOutputModule(ushort DeviceN, uint PidNo, ushort SlaveNo, ushort OffsetByte, ushort Bitlength, double ScaleGain, double ScaleOffset, double Output_Max_Value, double Output_Min_Value);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_PidGetParameter")]
        public static extern int ECAT_PidGetParameter(ushort DeviceN, uint PidNoo, ref double kp, ref double ki, ref double kd);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_PidGetStatus")]
        public static extern int ECAT_PidGetStatus(ushort DeviceN, uint PidNo, ref byte status);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_PidGetSimulateMode")]
        public static extern int ECAT_PidGetSimulateMode(ushort DeviceN, uint PidNo, ref byte status);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_PidGetSampleTime")]
        public static extern int ECAT_PidGetSampleTime(ushort DeviceN, uint PidNo, ref uint Interval);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_PidGetProcessVariableModule")]
        public static extern int ECAT_PidGetProcessVariableModule(ushort DeviceN, uint PidNo, ref ushort SlaveNo, ref ushort OffsetByte, ref ushort Bitlength, ref double ScaleGain, ref double ScaleOffset);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_PidGetControlOutputModule")]
        public static extern int ECAT_PidGetControlOutputModule(ushort DeviceN, uint PidNo, ref ushort SlaveNo, ref ushort OffsetByte, ref ushort Bitlength, ref double ScaleGain, ref double ScaleOffset, ref int Output_Max_Value, ref int Output_Min_Value);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_PidGetProcessVariable")]
        public static extern int ECAT_PidGetProcessVariable(ushort DeviceN, uint PidNo, ref int Input);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_PidGetSimulateFeedback")]
        public static extern int ECAT_PidGetSimulateFeedback(ushort DeviceN, uint PidNo, ref double Feedback);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_WaitforTimer")]
        public static extern int ECAT_WaitforTimer(ushort DeviceNo);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_PidGetSetPointValue")]
        public static extern int ECAT_PidGetSetPointValue(ushort DeviceNo, uint PidNo, ref double SetPointValue);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_PidGet_Sp_Err_Op_Pv")]
        public static extern int ECAT_PidGet_Sp_Err_Op_Pv(ushort DeviceNo, uint PidNo, ref double SetPointValue, ref double Error, ref double OutputValue, ref double ProcessVariable);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McSetAxisVelocityFeedForwardGain")]
        public static extern int ECAT_McSetAxisVelocityFeedForwardGain(ushort DeviceNo, ushort AxisNo, double Gain);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetAxisVelocityFeedForwardGain")]
        public static extern int ECAT_McGetAxisVelocityFeedForwardGain(ushort DeviceNo, ushort AxisNo, ref double Gain);        

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McStewartPlatformMoveAbs_PT")]
        public static extern int ECAT_McStewartPlatformMoveAbs_PT(ushort DeviceNo, ushort GroupNo, double[] Pose, double[] Pos, double Time);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetStewartPlatform_M1")]
        public static extern int ECAT_McGetStewartPlatform_M1(ushort DeviceNo, ref double radiusB, ref double angleB, ref double radiusP, ref double angleP, ref double RodLength, ref double Max_RodLength);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McSetStewartPlatform_M2")]
        public static extern int ECAT_McSetStewartPlatform_M2(ushort DeviceNo, double[] Bx, double[] By, double[] Px, double[] Py, double Z0, double[] RodLength, double[] Max_RodLength);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McSetGroupVelLimitStatus")]
        public static extern int ECAT_McSetGroupVelLimitStatus(ushort DeviceNo, ushort GroupNo, ushort Status);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetGroupVelLimitStatus")]
        public static extern int ECAT_McGetGroupVelLimitStatus(ushort DeviceNo, ushort GroupNo, ref ushort Status);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McSetGroupVelLimitValue")]
        public static extern int ECAT_McSetGroupVelLimitValue(ushort DeviceNo, ushort GroupNo, double Value);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetGroupVelLimitValue")]
        public static extern int ECAT_McGetGroupVelLimitValue(ushort DeviceNo, ushort GroupNo, ref double Value);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McSetMotionRecordParam")]
        public static extern int ECAT_McSetMotionRecordParam(ushort DeviceNo, ushort Value1, ushort Value2);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetMotionRecordParam")]
        public static extern int ECAT_McGetMotionRecordParam(ushort DeviceNo, ref ushort Value1, ref ushort Value2);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetMotionRecordValue")]
        public static extern int ECAT_McGetMotionRecordValue(ushort DeviceNo, uint CountNo, ushort AxisNo, float[] Value1, float[] Value2);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetMotionRecordValue")]
        public static extern int ECAT_McGetMotionRecordValue(ushort DeviceNo, uint CountNo, ushort AxisNo, ref float Value1, ref float Value2);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McClearMotionRecord")]
        public static extern int ECAT_McClearMotionRecord(ushort DeviceNo);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McSetAxisPosSoftwareLimit")]
        public static extern int ECAT_McSetAxisPosSoftwareLimit(ushort DeviceNo, ushort AxisNo, double Maximum, double Minimum, ref uint AbortCode);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetAxisPosSoftwareLimit")]
        public static extern int ECAT_McGetAxisPosSoftwareLimit(ushort DeviceNo, ushort AxisNo, ref double Maximum, ref double Minimum, ref uint AbortCode);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_GetProcessTime")]
        public static extern int ECAT_GetProcessTime(ushort DeviceNo, ref double Time);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McSetGroupHold")]
        public static extern int ECAT_McSetGroupHold(ushort DeviceNo, ushort GroupNo, ushort Status);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McSetAxisPosSoftwareLimitStatus")]
        public static extern int ECAT_McSetAxisPosSoftwareLimitStatus(ushort DeviceNo, ushort AxisNo, ushort Status, ushort ErrorStop);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetAxisPosSoftwareLimitStatus")]
        public static extern int ECAT_McGetAxisPosSoftwareLimitStatus(ushort DeviceNo, ushort AxisNo, ref ushort Status, ref ushort ErrorStop);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetAxisHomeState")]
        public static extern int ECAT_McGetAxisHomeState(ushort DeviceNo, ushort AxisNo, ref ushort State);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McAxisGantryIn")]
        public static extern int ECAT_McAxisGantryIn(ushort DeviceNo, ushort MasterNo, ushort SlaveNo, int Direction);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McSetGroupCmdModeEx")]
        public static extern int ECAT_McSetGroupCmdModeEx(ushort DeviceNo, ushort GroupNo, ushort CmdMode);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McAxisGantryMaxPosDiff")]
        public static extern int ECAT_McAxisGantryMaxPosDiff(ushort DeviceNo, ushort SlaveNo, double Value);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McAxisGantryMaxPosDiffStatus")]
        public static extern int ECAT_McAxisGantryMaxPosDiffStatus(ushort DeviceNo, ushort SlaveNo, ushort Status);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_EvCreatEvent")]
        public static extern int ECAT_EvCreatEvent(ushort DeviceNo, ref ushort EventID);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_EvCloseEvent")]
        public static extern int ECAT_EvCloseEvent(ushort DeviceNo, ushort EventID);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_EvEnableEvent")]
        public static extern int ECAT_EvEnableEvent(ushort DeviceNo, ushort EventID);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_EvDisableEvent")]
        public static extern int ECAT_EvDisableEvent(ushort DeviceNo, ushort EventID);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_EvSetComparePositionParameters")]
        public static extern int ECAT_EvSetComparePositionParameters(ushort DeviceNo, ushort EventID, ushort AxisNo, ushort Operator, double ComparePosition);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_WaitforEvent")]
        public static extern int ECAT_WaitforEvent(ushort DeviceNo, uint TimeOut, ref uint TriggeredEvent);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_ECAT_EvSetCompareDIBitParameters")]
        public static extern int ECAT_ECAT_EvSetCompareDIBitParameters(ushort DeviceNo, ushort EventID, ushort SlaveNo, ushort BitNo, uint CompareValue);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_EvSetMotionCompleteParameters")]
        public static extern int ECAT_EvSetMotionCompleteParameters(ushort DeviceNo, ushort EventID, ushort AxisNo);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGroupMoveAO")]
        public static extern int ECAT_McGroupMoveAO(ushort DeviceNo, ushort GroupNo, ushort SlaveNo, uint RunMode, ushort ChannelNo, ushort RawData, double VoltData);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McSetGroupAccTimeEx")]
        public static extern int ECAT_McSetGroupAccTimeEx(ushort DeviceNo, ushort GroupNo, ushort Time_ms);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McSetGroupBlendingPercent")]
        public static extern int ECAT_McSetGroupBlendingPercent(ushort DeviceNo, ushort GroupNo, ushort Value);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McSetProfileInterval")]
        public static extern int ECAT_McSetProfileInterval(ushort DeviceNo, ushort ProfileNo, ushort Value);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McAxisMoveSuperimposed")]
        public static extern int ECAT_McAxisMoveSuperimposed(ushort DeviceNo, ushort AxisNo, double Pos, double Vel);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McAxisHaltSuperimposed")]
        public static extern int ECAT_McAxisHaltSuperimposed(ushort DeviceNo, ushort AxisNo);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetMotionRecordValueEx")]
        public static extern int ECAT_McGetMotionRecordValueEx(ushort DeviceNo, uint CountNo, ushort Count, ushort AxisNo, ref float Value1, ref float Value2, ref ushort ActualCount);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetMotionRecordValueEx")]
        public static extern int ECAT_McGetMotionRecordValueEx(ushort DeviceNo, uint CountNo, ushort Count, ushort AxisNo, float[] Value1, float[] Value2, ref ushort ActualCount);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_SetHeartBeat")]
        public static extern int ECAT_SetHeartBeat(ushort DeviceNo, uint Value);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_SetHeartBeatStatus")]
        public static extern int ECAT_SetHeartBeatStatus(ushort DeviceNo, uint Value);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McSetGroupBlendingPercentEx")]
        public static extern int ECAT_McSetGroupBlendingPercentEx(ushort DeviceNo, ushort GroupNo, ushort Value);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_EvSetCompareDIParameters")]
        public static extern int ECAT_EvSetCompareDIParameters(ushort DeviceNo, ushort EventID, ushort SlaveNo, ushort OffsetByte, uint CompareValue, uint Mask);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McSetGroupPause")]
        public static extern int ECAT_McSetGroupPause(ushort DeviceNo, ushort GroupNo, ushort Status);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_EvSetCompareAxisStateParameters")]
        public static extern int ECAT_EvSetCompareAxisStateParameters(ushort DeviceNo, ushort EventID, ushort AxisNo, uint CompareState);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_SetSlaveAiProperty")]
        public static extern int ECAT_SetSlaveAiProperty(ushort DeviceNo, ushort SlaveNo, ushort ChannelNo, byte Range);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_GetSlaveAiProperty")]
        public static extern int ECAT_GetSlaveAiProperty(ushort DeviceNo, ushort SlaveNo, ushort ChannelNo, ref byte Range);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_GetSlaveAiRawData")]
        public static extern int ECAT_GetSlaveAiRawData(ushort DeviceNo, ushort SlaveNo, ushort ChannelNo, ref short Data);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_GetSlaveAiVoltData")]
        public static extern int ECAT_GetSlaveAiVoltData(ushort DeviceNo, ushort SlaveNo, ushort ChannelNo, ref double Data);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_GetSlaveAimAData")]
        public static extern int ECAT_GetSlaveAimAData(ushort DeviceNo, ushort SlaveNo, ushort ChannelNo, ref double Data);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McAxisHomeEx")]
        public static extern int ECAT_McAxisHomeEx(ushort DeviceNo, ushort AxisNo, ushort Settings);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_EvSetCompareCmdPositionParameters")]
        public static extern int ECAT_EvSetCompareCmdPositionParameters(ushort DeviceNo, ushort EventID, ushort AxisNo, ushort Operator, double ComparePosition);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_EvSetCompareAxisVelStateParameters")]
        public static extern int ECAT_EvSetCompareAxisVelStateParameters(ushort DeviceNo, ushort EventID, ushort AxisNo, uint CompareState);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McSetAxisMaxVelocity")]
        public static extern int ECAT_McSetAxisMaxVelocity(ushort DeviceNo, ushort AxisNo, double MaxVelocity);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetAxisMaxVelocity")]
        public static extern int ECAT_McGetAxisMaxVelocity(ushort DeviceNo, ushort AxisNo, ref double MaxVelocity);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGroupMoveLineAbs_P2P")]
        public static extern int ECAT_McGroupMoveLineAbs_P2P(ushort DeviceNo, ushort GroupNo, double[] Pos);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGroupMoveLineRel_P2P")]
        public static extern int ECAT_McGroupMoveLineRel_P2P(ushort DeviceNo, ushort GroupNo, double[] Pos);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McAxisMoveAbs_P2P")]
        public static extern int ECAT_McAxisMoveAbs_P2P(ushort DeviceNo, ushort AxisNo, double Pos);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McAxisMoveRel_P2P")]
        public static extern int ECAT_McAxisMoveRel_P2P(ushort DeviceNo, ushort AxisNo, double Pos);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_Set_ECAT2016_AiProperty")]
        public static extern int ECAT_Set_ECAT2016_AiProperty(ushort DeviceNo, ushort SlaveNo, ushort ChannelNo, byte Range, ref uint AbortCode);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_Get_ECAT2016_AiProperty")]
        public static extern int ECAT_Get_ECAT2016_AiProperty(ushort DeviceNo, ushort SlaveNo, ushort ChannelNo, ref byte Range, ref uint AbortCode);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_Get_ECAT2016_AiRawData")]
        public static extern int ECAT_Get_ECAT2016_AiRawData(ushort DeviceNo, ushort SlaveNo, ushort ChannelNo, ref short Data);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_Get_ECAT2016_AiVoltData")]
        public static extern int ECAT_Get_ECAT2016_AiVoltData(ushort DeviceNo, ushort SlaveNo, ushort ChannelNo, ref double Data);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_EvSetCompareAiParameters")]
        public static extern int ECAT_EvSetCompareAiParameters(ushort DeviceNo, ushort EventID, ushort Operator, ushort SlaveNo, ushort OffsetByte, ushort DataSize, double ScaleGain, double ScaleOffset, double CompareValue);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McSetAxisTorqueGain")]
        public static extern int ECAT_McSetAxisTorqueGain(ushort DeviceNo, ushort AxisNo, double Gain, ref uint AbortCode);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetAxisTorqueGain")]
        public static extern int ECAT_McGetAxisTorqueGain(ushort DeviceNo, ushort AxisNo, ref double Gain);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetAxisRatedTorque")]
        public static extern int ECAT_McGetAxisRatedTorque(ushort DeviceNo, ushort AxisNo, ref double Torque, ref uint AbortCode);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McAxisMoveTor")]
        public static extern int ECAT_McAxisMoveTor(ushort DeviceNo, ushort AxisNo, double Torque);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetAxisActualTorque")]
        public static extern int ECAT_McGetAxisActualTorque(ushort DeviceNo, ushort AxisNo, ref double Torque);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetAxisActualTorque")]
        public static extern int ECAT_McGetAxisActualTorque(ushort DeviceNo, ushort AxisNo, double[] Torque);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McSetAxisMaxTorque")]
        public static extern int ECAT_McSetAxisMaxTorque(ushort DeviceNo, ushort AxisNo, double Torque, ref uint AbortCode);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetAxisMaxTorque")]
        public static extern int ECAT_McGetAxisMaxTorque(ushort DeviceNo, ushort AxisNo, ref double Torque, ref uint AbortCode);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetAxisCommandVel")]
        public static extern int ECAT_McGetAxisCommandVel(ushort DeviceNo, ushort AxisNo, ref double Pos);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetAxisCommandVel")]
        public static extern int ECAT_McGetAxisCommandVel(ushort DeviceNo, ushort AxisNo, double[] Pos);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGroupMovePath")]
        public static extern int ECAT_McGroupMovePath(ushort DeviceNo, ushort GroupNo, ushort PathDataNo, byte Restart, ushort DataIndex, byte Repeat);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McAddPathData")]
        public static extern int ECAT_McAddPathData(ushort DeviceNo, ushort PathDataNo, uint CmdType, byte AbsMove, double[] EndPos, double[] AuxPos, double[] Args);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McSetPathData")]
        public static extern int ECAT_McSetPathData(ushort DeviceNo, ushort PathDataNo, ushort DataIndex, uint CmdType, byte AbsMove, double[] EndPos, double[] AuxPos, double[] Args);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetPathData")]
        public static extern int ECAT_McGetPathData(ushort DeviceNo, ushort PathDataNo, ushort DataIndex, ref uint CmdType, ref byte AbsMove, double[] EndPos, double[] AuxPos, double[] Args);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McClearPathData")]
        public static extern int ECAT_McClearPathData(ushort DeviceNo, ushort PathDataNo);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetPathDataSize")]
        public static extern int ECAT_McGetPathDataSize(ushort DeviceNo, ushort PathDataNo, ref ushort Size);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McAxisMoveAbsAdv")]
        public static extern int ECAT_McAxisMoveAbsAdv(ushort DeviceNo, ushort AxisNo, double EndPos, double StartVel, double ReqVel, double FinalVel, double Accel, double Decel, byte AccDecMode);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McAxisMoveRelAdv")]
        public static extern int ECAT_McAxisMoveRelAdv(ushort DeviceNo, ushort AxisNo, double EndPos, double StartVel, double ReqVel, double FinalVel, double Accel, double Decel, byte AccDecMode);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGroupMoveLineAbsAdv")]
        public static extern int ECAT_McGroupMoveLineAbsAdv(ushort DeviceNo, ushort GroupNo, double[] EndPos, double StartVel, double ReqVel, double FinalVel, double Accel, double Decel, byte AccDecMode);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGroupMoveLineRelAdv")]
        public static extern int ECAT_McGroupMoveLineRelAdv(ushort DeviceNo, ushort GroupNo, double[] EndPos, double StartVel, double ReqVel, double FinalVel, double Accel, double Decel, byte AccDecMode);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McAxisMove_CiA402_PP")]
        public static extern int ECAT_McAxisMove_CiA402_PP(ushort DeviceNo, ushort AxisNo, byte Abort, byte AbsMove,  double EndPos, double Vel, double Accel, double Decel);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McAxisMove_CiA402_PV")]
        public static extern int ECAT_McAxisMove_CiA402_PV(ushort DeviceNo, ushort AxisNo, double Vel, double Accel, double Decel);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McAxisMove_CiA402_PT")]
        public static extern int ECAT_McAxisMove_CiA402_PT(ushort DeviceNo, ushort AxisNo, double Torque, double Slope);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_UpdateFirmware_")]
        public static extern int ECAT_UpdateFirmware_(ushort DeviceNo, uint Offset, string Data, uint DataSize, byte LastFlag);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_SetTxPdoBufParam")]
        public static extern int ECAT_SetTxPdoBufParam(ushort DeviceNo, ushort ChannelNo, ushort SlaveNo, ushort OffsetByte, ushort DataSize, ushort Enable);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_GetTxPdoBufParam")]
        public static extern int ECAT_GetTxPdoBufParam(ushort DeviceNo, ushort ChannelNo, ref ushort SlaveNo, ref ushort OffsetByte, ref ushort DataSize, ref ushort Enable);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_SetTxPdoBufEnable")]
        public static extern int ECAT_SetTxPdoBufEnable(ushort DeviceNo, ushort ChannelNo, ushort Enable);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_GetTxPdoBufEnable")]
        public static extern int ECAT_GetTxPdoBufEnable(ushort DeviceNo, ushort ChannelNo, ref ushort Enable);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_GetTxPdoBufValue")]
        public static extern int ECAT_GetTxPdoBufValue(ushort DeviceNo, ushort ChannelNo, ref float Data, ushort Size, ref ushort ActualGetSize);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McSetAxisHomeTorque")]
        public static extern int ECAT_McSetAxisHomeTorque(ushort DeviceNo, ushort AxisNo, ushort Torque);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetAxisHomeTorque")]
        public static extern int ECAT_McGetAxisHomeTorque(ushort DeviceNo, ushort AxisNo, ref ushort Torque);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_SetAiFilterParam")]
        public static extern int ECAT_SetAiFilterParam(ushort DeviceNo, ushort ChannelNo, ushort SlaveNo, ushort OffsetByte, ushort DataSize, ushort Enable);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_GetAiFilterParam")]
        public static extern int ECAT_GetAiFilterParam(ushort DeviceNo, ushort ChannelNo, ref ushort SlaveNo, ref ushort OffsetByte, ref ushort DataSize, ref ushort Enable);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_SetAiFilterEnable")]
        public static extern int ECAT_SetAiFilterEnable(ushort DeviceNo, ushort ChannelNo, ushort Enable);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_GetAiFilterEnable")]
        public static extern int ECAT_GetAiFilterEnable(ushort DeviceNo, ushort ChannelNo, ref ushort Enable);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_SetAiFilterFreq")]
        public static extern int ECAT_SetAiFilterFreq(ushort DeviceNo, ushort ChannelNo, ushort FilterType, double Frequency);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_GetAiFilterFreq")]
        public static extern int ECAT_GetAiFilterFreq(ushort DeviceNo, ushort ChannelNo, ushort FilterType, ref double Frequency);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_GetAiFilterOutput")]
        public static extern int ECAT_GetAiFilterOutput(ushort DeviceNo, ushort ChannelNo, ref int Output);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_SetPdoInToOutParam")]
        public static extern int ECAT_SetPdoInToOutParam(ushort DeviceNo, ushort ChannelNo, ushort SlaveNoIn, ushort OffsetByteIn, ushort DataSizeIn, ushort SlaveNoOut, ushort OffsetByteOut, ushort DataSizeOut);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_GetPdoInToOutParam")]
        public static extern int ECAT_GetPdoInToOutParam(ushort DeviceNo, ushort ChannelNo, ref ushort SlaveNoIn, ref ushort OffsetByteIn, ref ushort DataSizeIn, ref ushort SlaveNoOut, ref ushort OffsetByteOut, ref ushort DataSizeOut);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_SetPdoInToOutCoeff")]
        public static extern int ECAT_SetPdoInToOutCoeff(ushort DeviceNo, ushort ChannelNo, float gain, float offset);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_GetPdoInToOutCoeff")]
        public static extern int ECAT_GetPdoInToOutCoeff(ushort DeviceNo, ushort ChannelNo, ref float gain, ref float offset);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_SetPdoInToOutEnable")]
        public static extern int ECAT_SetPdoInToOutEnable(ushort DeviceNo, ushort ChannelNo, ushort Enable);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_GetPdoInToOutEnable")]
        public static extern int ECAT_GetPdoInToOutEnable(ushort DeviceNo, ushort ChannelNo, ref ushort Enable);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McStewartPlatformShaker")]
        public static extern int ECAT_McStewartPlatformShaker(ushort DeviceNo, ushort GroupNo, double[] Amp, double Freq);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McStewartPlatformShaker_Stop")]
        public static extern int ECAT_McStewartPlatformShaker_Stop(ushort DeviceNo, ushort GroupNo, int QuickStop);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McAxisMoveVelShaker")]
        public static extern int ECAT_McAxisMoveVelShaker(ushort DeviceNo, ushort AxisNo, double Amp, double Freq, uint N);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McAxisGantryGain")]
        public static extern int ECAT_McAxisGantryGain(ushort DeviceNo, ushort SlaveNo, double Kp, double Ki);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_SetSlaveAlias")]
        public static extern int ECAT_SetSlaveAlias(ushort DeviceNo, ushort SlaveNo, ushort Alias);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_GetSlaveSwAlias")]
        public static extern int ECAT_GetSlaveSwAlias(ushort DeviceNo, ushort SlaveNo, ref ushort Alias);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_SetSlaveNoType")]
        public static extern int ECAT_SetSlaveNoType(ushort DeviceNo, ushort Type);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_GetSlaveNoType")]
        public static extern int ECAT_GetSlaveNoType(ushort DeviceNo, ref ushort Type);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_GetSlavePos")]
        public static extern int ECAT_GetSlavePos(ushort DeviceNo, ushort SlaveNo, ref ushort Pos);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_GetSlaveNo")]
        public static extern int ECAT_GetSlaveNo(ushort DeviceNo, ushort Pos, ref ushort SlaveNo);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_EvSetMotionCompleteParameters_Grp")]
        public static extern int ECAT_EvSetMotionCompleteParameters_Grp(ushort DeviceNo, ushort EventID, ushort GrpNo);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McSetGroupPvtDecEnable")]
        public static extern int ECAT_McSetGroupPvtDecEnable(ushort DeviceNo, ushort GroupNo, ushort Enable);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetGroupPvtDecEnable")]
        public static extern int ECAT_McGetGroupPvtDecEnable(ushort DeviceNo, ushort GroupNo, ref ushort Enable);       

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_AbortWaitforEvent")]
        public static extern int ECAT_AbortWaitforEvent(ushort DeviceNo);       

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McSetGroupCoordinate")]
        public static extern int ECAT_McSetGroupCoordinate(ushort DeviceNo, ushort GroupNo, ushort Type);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McSetGroupCoordinateLimit")]
        public static extern int ECAT_McSetGroupCoordinateLimit(ushort DeviceNo, ushort GroupNo, ushort Type, ushort Enable, double MIN_Value, double MAX_Value);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetGroupCoordinateLimit")]
        public static extern int ECAT_McGetGroupCoordinateLimit(ushort DeviceNo, ushort GroupNo, ushort Type, ref ushort Enable, ref double MIN_Value, ref double MAX_Value);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_SetSlaveArrCmpPos")]
        public static extern int ECAT_SetSlaveArrCmpPos(ushort DeviceNo, ushort SlaveNo, ushort EncNo, byte Index, int Position);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_GetSlaveArrCmpPos")]
        public static extern int ECAT_GetSlaveArrCmpPos(ushort DeviceNo, ushort SlaveNo, ushort EncNo, byte Index, ref int Position);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_SetSlaveArrCmpEnable")]
        public static extern int ECAT_SetSlaveArrCmpEnable(ushort DeviceNo, ushort SlaveNo, ushort EncNo, byte Index, byte Enable);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_GetSlaveArrCmpEnable")]
        public static extern int ECAT_GetSlaveArrCmpEnable(ushort DeviceNo, ushort SlaveNo, ushort EncNo, byte Index, ref byte Enable);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_SetSlaveArrCmpEndIdx")]
        public static extern int ECAT_SetSlaveArrCmpEndIdx(ushort DeviceNo, ushort SlaveNo, ushort EncNo, ushort EndIndex);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_GetSlaveArrCmpEndIdx")]
        public static extern int ECAT_GetSlaveArrCmpEndIdx(ushort DeviceNo, ushort SlaveNo, ushort EncNo, ref ushort EndIndex);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_SetSlaveArrCmpTrig")]
        public static extern int ECAT_SetSlaveArrCmpTrig(ushort DeviceNo, ushort SlaveNo, ushort EncNo);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_SetSlaveSaveArrCmpData")]
        public static extern int ECAT_SetSlaveSaveArrCmpData(ushort DeviceNo, ushort SlaveNo);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McSetAxisDIActiveLevel")]
        public static extern int ECAT_McSetAxisDIActiveLevel(ushort DeviceNo, ushort AxisNo, byte POT, byte NOT, byte ORG);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetAxisDIActiveLevel")]
        public static extern int ECAT_McGetAxisDIActiveLevel(ushort DeviceNo, ushort AxisNo, ref byte POT, ref byte NOT, ref byte ORG);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetAxisDI_60FD")]
        public static extern int ECAT_McGetAxisDI_60FD(ushort DeviceNo, ushort AxisNo, ref uint DI);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McSetAxisHomeDir_hontech")]
        public static extern int ECAT_McSetAxisHomeDir_hontech(ushort DeviceNo, ushort AxisNo, int HomeDir);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetAxisHomeDir_hontech")]
        public static extern int ECAT_McGetAxisHomeDir_hontech(ushort DeviceNo, ushort AxisNo, ref int HomeDir);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McSetAxisLimitAsHome_Stepper")]
        public static extern int ECAT_McSetAxisLimitAsHome_Stepper(ushort DeviceNo, ushort AxisNo, int Value);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetAxisLimitAsHome_Stepper")]
        public static extern int ECAT_McGetAxisLimitAsHome_Stepper(ushort DeviceNo, ushort AxisNo, ref int Value);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McSetAxisHomeLogic_hontech")]
        public static extern int ECAT_McSetAxisHomeLogic_hontech(ushort DeviceNo, ushort AxisNo, byte NOT, byte POT, byte ORG);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McSetAxisHomeLogic_hontech")]
        public static extern int ECAT_McSetAxisHomeLogic_hontech(ushort DeviceNo, ushort AxisNo, ref byte NOT, ref byte POT, ref byte ORG);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_SaveSlaveEEPROM")]
        public static extern int ECAT_SaveSlaveEEPROM(ushort DeviceNo, ushort SlaveNo);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McSetAxisActualPosition")]
        public static extern int ECAT_McSetAxisActualPosition(ushort DeviceNo, ushort AxisNo, double Position);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McSetAxisCommandPosition")]
        public static extern int ECAT_McSetAxisCommandPosition(ushort DeviceNo, ushort AxisNo, double Position);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetAxisDI_hontech")]
        public static extern int ECAT_McGetAxisDI_hontech(ushort DeviceNo, ushort AxisNo, ref uint DI);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetAxisDI_hontech")]
        public static extern int ECAT_McGetAxisDI_hontech(ushort DeviceNo, ushort AxisNo, uint[] DI);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McSetAxisHomeExtDist")]
        public static extern int ECAT_McSetAxisHomeExtDist(ushort DeviceNo, ushort AxisNo, double Value);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetAxisHomeExtDist")]
        public static extern int ECAT_McGetAxisHomeExtDist(ushort DeviceNo, ushort AxisNo, ref double Value);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McSetAxisAccDecTime_Stepper")]
        public static extern int ECAT_McSetAxisAccDecTime_Stepper(ushort DeviceNo, ushort AxisNo, ushort AccTime_ms, ushort DecTime_ms);

	[DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetAxisAccDecTime_Stepper")]
        public static extern int ECAT_McGetAxisAccDecTime_Stepper(ushort DeviceNo, ushort AxisNo, ref ushort AccTime_ms, ref ushort DecTime_ms);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_GetDeviceStateEx")]
        public static extern int ECAT_GetDeviceStateEx(ushort DeviceNo, ref uint LinkUp, ref uint SlavesResp, ref uint AlStates, ref uint Wc);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_SlaveNonBlockRegErrReadRequest")]
        public static extern int ECAT_SlaveNonBlockRegErrReadRequest(ushort DeviceNo, ushort SlaveNo, ushort Type);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_SlaveNonBlockRegErrReadState")]
        public static extern int ECAT_SlaveNonBlockRegErrReadState(ushort DeviceNo, ushort SlaveNo, ushort Type, byte[] Value1, byte[] Value2);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_SlaveNonBlockRegErClrRequest")]
        public static extern int ECAT_SlaveNonBlockRegErClrRequest(ushort DeviceNo, ushort SlaveNo, ushort Type);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_SlaveNonBlockRegErrClrState")]
        public static extern int ECAT_SlaveNonBlockRegErrClrState(ushort DeviceNo, ushort SlaveNo, ushort Type);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_GetSlaveRegErr")]
        public static extern int ECAT_GetSlaveRegErr(ushort DeviceNo, ushort SlaveNo, ushort Type, byte[] Value1, byte[] Value2);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetAxisHomePos_hontech")]
        public static extern int ECAT_McGetAxisHomePos_hontech(ushort DeviceNo, ushort AxisNo, ref double Pos);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_SetSlaveEncIdxLatchBufferEnable")]
        public static extern int ECAT_SetSlaveEncIdxLatchBufferEnable(ushort DeviceNo, ushort SlaveNo, ushort EncNo, byte Enable);

	[DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_GetSlaveEncIdxLatchBufferEnable")]
        public static extern int ECAT_GetSlaveEncIdxLatchBufferEnable(ushort DeviceNo, ushort SlaveNo, ushort EncNo, ref byte Enable);

	[DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_ResetSlaveEncIdxLatchBuffer")]
        public static extern int ECAT_ResetSlaveEncIdxLatchBuffer(ushort DeviceNo, ushort SlaveNo, ushort EncNo);

	[DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_GetSlaveEncIdxLatchBuffer")]
        public static extern int ECAT_GetSlaveEncIdxLatchBuffer(ushort DeviceNo, ushort SlaveNo, ushort EncNo, int GetCount, ref int ActualGetCount, ref int Data);

	[DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McSetAxisAccUnit_Stepper")]
        public static extern int ECAT_McSetAxisAccUnit_Stepper(ushort DeviceNo, ushort AxisNo, ushort Unit, ref uint AbortCode);

	[DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetAxisAccUnit_Stepper")]
        public static extern int ECAT_McGetAxisAccUnit_Stepper(ushort DeviceNo, ushort AxisNo, ref ushort Unit, ref uint AbortCode);

	[DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McSetAxisVelAccScale")]
        public static extern int ECAT_McSetAxisVelAccScale(ushort DeviceNo, ushort AxisNo, double VelScal, double AccScal);

	[DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetAxisVelAccScale")]
        public static extern int ECAT_McGetAxisVelAccScale(ushort DeviceNo, ushort AxisNo, ref double VelScal, ref double AccScal);

	[DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McSetAxisInpSignal")]
        public static extern int ECAT_McSetAxisInpSignal(ushort DeviceNo, ushort AxisNo, ushort Offset, ushort Bit, int Enable);

	[DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetAxisInpSignal")]
        public static extern int ECAT_McGetAxisInpSignal(ushort DeviceNo, ushort AxisNo, ref ushort Offset, ref ushort Bit, ref int Enable);

	[DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McSetAxisInpCompare")]
        public static extern int ECAT_McSetAxisInpCompare(ushort DeviceNo, ushort AxisNo, uint Time_ms, double PosWindow, int Enable);

	[DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetAxisInpCompare")]
        public static extern int ECAT_McGetAxisInpCompare(ushort DeviceNo, ushort AxisNo, ref uint Time_ms, ref double PosWindow, ref int Enable);

	[DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McSetAxisInpTimeOut")]
        public static extern int ECAT_McSetAxisInpTimeOut(ushort DeviceNo, ushort AxisNo, uint Time_ms);

	[DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetAxisInpTimeOut")]
        public static extern int ECAT_McGetAxisInpTimeOut(ushort DeviceNo, ushort AxisNo, ref uint Time_ms);

	[DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McSetAxisWanErrEnable")]
        public static extern int ECAT_McSetAxisWanErrEnable(ushort DeviceNo, ushort AxisNo, uint Enable);

	[DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetAxisWanErrEnable")]
        public static extern int ECAT_McGetAxisWanErrEnable(ushort DeviceNo, ushort AxisNo, ref uint Enable);

	[DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_SetMultiSlaveDO")]
        public static extern int ECAT_SetMultiSlaveDO(ushort DeviceNo, ushort[] SlaveNo, uint[] Value, ushort SlaveCnt);

	[DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_GetMultiSlaveDO")]
        public static extern int ECAT_GetMultiSlaveDO(ushort DeviceNo, ushort[] SlaveNo, uint[] Value, ushort SlaveCnt);

	[DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McSetAxisDefaultMode")]
        public static extern int ECAT_McSetAxisDefaultMode(ushort DeviceNo, ushort AxisNo, byte Mode);

	[DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetAxisDefaultMode")]
        public static extern int ECAT_McGetAxisDefaultMode(ushort DeviceNo, ushort AxisNo, ref byte Mode);

	[DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_SetDeviceIgnoreWC")]
        public static extern int ECAT_SetDeviceIgnoreWC(ushort DeviceNo, byte Enable);

	[DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_GetDeviceIgnoreWC")]
        public static extern int ECAT_GetDeviceIgnoreWC(ushort DeviceNo, ref byte Enable);

	[DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McInit_Ex")]
        public static extern int ECAT_McInit_Ex(ushort DeviceNo, string FileName, ushort[] SlaveNo, ushort[] SubAxisNo, ref ushort AxisCount);

	[DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_SetMultiSlaveDO_AutoOff")]
        public static extern int ECAT_SetMultiSlaveDO_AutoOff(ushort DeviceNo, ushort[] SlaveNo, uint[] Value, uint[] Width, uint[] Mask, ushort SlaveCnt);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetAxisHomeOffset_hontech")]
        public static extern int ECAT_McGetAxisHomeOffset_hontech(ushort DeviceNo, ushort AxisNo, ref double Pos);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetAxisHomeOffset_hontech")]
        public static extern int ECAT_McGetAxisHomeOffset_hontech(ushort DeviceNo, ushort AxisNo, double[] Pos);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McSetAxisAccDecUnit")]
        public static extern int ECAT_McSetAxisAccDecUnit(ushort DeviceNo, ushort AxisNo, ushort Unit);

	[DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetAxisAccDecUnit")]
        public static extern int ECAT_McGetAxisAccDecUnit(ushort DeviceNo, ushort AxisNo, ref ushort Unit);

	[DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McSetAxisAccDecRate")]
        public static extern int ECAT_McSetAxisAccDecRate(ushort DeviceNo, ushort AxisNo, double Unit);

	[DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetAxisAccDecRate")]
        public static extern int ECAT_McGetAxisAccDecRate(ushort DeviceNo, ushort AxisNo, ref double Unit);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_SetStepperCompact")]
        public static extern int ECAT_SetStepperCompact(ushort DeviceNo, ushort Enable);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_GetStepperCompact")]
        public static extern int ECAT_GetStepperCompact(ushort DeviceNo, ref ushort Enable);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McSetAxisStartVelocity")]
        public static extern int ECAT_McSetAxisStartVelocity(ushort DeviceNo, ushort AxisNo, double Vel);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetAxisStartVelocity")]
        public static extern int ECAT_McGetAxisStartVelocity(ushort DeviceNo, ushort AxisNo, ref double Vel);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetAxisState_Ex")]
        public static extern int ECAT_McGetAxisState_Ex(ushort DeviceNo, ushort AxisNo, ref uint State);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetAxisState_Ex")]
        public static extern int ECAT_McGetAxisState_Ex(ushort DeviceNo, ushort AxisNo, uint[] State);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetAxisLastError_Ex")]
        public static extern int ECAT_McGetAxisLastError_Ex(ushort DeviceNo, ushort AxisNo, ref int Error);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetAxisLastError_Ex")]
        public static extern int ECAT_McGetAxisLastError_Ex(ushort DeviceNo, ushort AxisNo, int[] Error);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetAxisDriveError_Ex")]
        public static extern int ECAT_McGetAxisDriveError_Ex(ushort DeviceNo, ushort AxisNo, ref ushort Error);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetAxisDriveError_Ex")]
        public static extern int ECAT_McGetAxisDriveError_Ex(ushort DeviceNo, ushort AxisNo, ushort[] Error);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetAxisActualPos_Ex")]
        public static extern int ECAT_McGetAxisActualPos_Ex(ushort DeviceNo, ushort AxisNo, ref double Pos);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetAxisActualPos_Ex")]
        public static extern int ECAT_McGetAxisActualPos_Ex(ushort DeviceNo, ushort AxisNo, double[] Pos);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetAxisCommandPos_Ex")]
        public static extern int ECAT_McGetAxisCommandPos_Ex(ushort DeviceNo, ushort AxisNo, ref double Pos);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetAxisCommandPos_Ex")]
        public static extern int ECAT_McGetAxisCommandPos_Ex(ushort DeviceNo, ushort AxisNo, double[] Pos);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetAxisActualVel_Ex")]
        public static extern int ECAT_McGetAxisActualVel_Ex(ushort DeviceNo, ushort AxisNo, ref double Vel);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetAxisActualVel_Ex")]
        public static extern int ECAT_McGetAxisActualVel_Ex(ushort DeviceNo, ushort AxisNo, double[] Vel);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetAxisDI_Ex")]
        public static extern int ECAT_McGetAxisDI_Ex(ushort DeviceNo, ushort AxisNo, ref uint DI);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetAxisDI_Ex")]
        public static extern int ECAT_McGetAxisDI_Ex(ushort DeviceNo, ushort AxisNo, uint[] DI);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetAxisActualTorque_Ex")]
        public static extern int ECAT_McGetAxisActualTorque_Ex(ushort DeviceNo, ushort AxisNo, ref double Torque);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetAxisActualTorque_Ex")]
        public static extern int ECAT_McGetAxisActualTorque_Ex(ushort DeviceNo, ushort AxisNo, double[] Torque);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetAxisDI_hontech_Ex")]
        public static extern int ECAT_McGetAxisDI_hontech_Ex(ushort DeviceNo, ushort AxisNo, ref uint DI);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetAxisDI_hontech_Ex")]
        public static extern int ECAT_McGetAxisDI_hontech_Ex(ushort DeviceNo, ushort AxisNo, uint[] DI);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetAxisActualPos_Directly")]
        public static extern int ECAT_McGetAxisActualPos_Directly(ushort DeviceNo, ushort AxisNo, ref double Pos);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetAxisActualPos_Directly")]
        public static extern int ECAT_McGetAxisActualPos_Directly(ushort DeviceNo, ushort AxisNo, double[] Pos);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetAxisCommandPos_Directly")]
        public static extern int ECAT_McGetAxisCommandPos_Directly(ushort DeviceNo, ushort AxisNo, ref double Pos);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetAxisCommandPos_Directly")]
        public static extern int ECAT_McGetAxisCommandPos_Directly(ushort DeviceNo, ushort AxisNo, double[] Pos);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetAxisState_Directly")]
        public static extern int ECAT_McGetAxisState_Directly(ushort DeviceNo, ushort AxisNo, ref uint State);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetAxisState_Directly")]
        public static extern int ECAT_McGetAxisState_Directly(ushort DeviceNo, ushort AxisNo, uint[] State);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetAxisDI_hontech_Directly")]
        public static extern int ECAT_McGetAxisDI_hontech_Directly(ushort DeviceNo, ushort AxisNo, ref uint DI);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetAxisDI_hontech_Directly")]
        public static extern int ECAT_McGetAxisDI_hontech_Directly(ushort DeviceNo, ushort AxisNo, uint[] DI);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetAxisDI_Directly")]
        public static extern int ECAT_McGetAxisDI_Directly(ushort DeviceNo, ushort AxisNo, ref uint DI);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetAxisDI_Directly")]
        public static extern int ECAT_McGetAxisDI_Directly(ushort DeviceNo, ushort AxisNo, uint[] DI);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McEnable_Directly")]
        public static extern int ECAT_McEnable_Directly(ushort DeviceNo);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_SetSlaveDIMap")]
        public static extern int ECAT_SetSlaveDIMap(ushort DeviceNo, ushort ChannelCnt, ushort[] SlaveNo, ushort[] Dir);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_GetSlaveAiVoltData_Ex")]
        public static extern int ECAT_GetSlaveAiVoltData_Ex(ushort DeviceNo, ushort SlaveNo, ushort ChannelCnt, ref double Data);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_GetSlaveAiVoltData_Ex")]
        public static extern int ECAT_GetSlaveAiVoltData_Ex(ushort DeviceNo, ushort SlaveNo, ushort ChannelCnt, double[] Data);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_GetSlaveDI_Directly")]
        public static extern int ECAT_GetSlaveDI_Directly(ushort DeviceNo, ushort SlaveNo, ref uint Value);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_GetSlaveDIBit_Directly")]
        public static extern int ECAT_GetSlaveDIBit_Directly(ushort DeviceNo, ushort SlaveNo, ushort BitNo, ref uint Value);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_GetSlaveDO_Directly")]
        public static extern int ECAT_GetSlaveDO_Directly(ushort DeviceNo, ushort SlaveNo, ref uint Value);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_GetSlaveDOBit_Directly")]
        public static extern int ECAT_GetSlaveDOBit_Directly(ushort DeviceNo, ushort SlaveNo, ushort BitNo, ref uint Value);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McSetBuffetAmp")]
        public static extern int ECAT_McSetBuffetAmp(ushort DeviceNo, ushort BeffetNo, double Value);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McSetBuffetFreq")]
        public static extern int ECAT_McSetBuffetFreq(ushort DeviceNo, ushort BeffetNo, double Freq);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McSetBuffetGain")]
        public static extern int ECAT_McSetBuffetGain(ushort DeviceNo, ushort BeffetNo, ushort AxisNo, double Gain);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McSetImpactGain")]
        public static extern int ECAT_McSetImpactGain(ushort DeviceNo, ushort ImpactNo, ushort AxisNo, double Gain);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McSetImpactFadeTime")]
        public static extern int ECAT_McSetImpactFadeTime(ushort DeviceNo, ushort ImpactNo, ushort AxisNo, double FadeTime_s);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McSetImpactFreq")]
        public static extern int ECAT_McSetImpactFreq(ushort DeviceNo, ushort ImpactNo, ushort AxisNo, double Freq);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McSetImpactDamp")]
        public static extern int ECAT_McSetImpactDamp(ushort DeviceNo, ushort ImpactNo, ushort AxisNo, double Damp);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McSetImpact")]
        public static extern int ECAT_McSetImpact(ushort DeviceNo, ushort ImpactNo);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McAxisHome_Servotronix")]
        public static extern int ECAT_McAxisHome_Servotronix(ushort DeviceNo, ushort MasterNo, ushort DiffenceNo, ushort Settings);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McSetAxisActualPos_Servotronix")]
        public static extern int ECAT_McSetAxisActualPos_Servotronix(ushort DeviceNo, ushort MasterNo, ushort DiffenceNo, double Position);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McAxisGantryOut")]
        public static extern int ECAT_McAxisGantryOut(ushort DeviceNo, ushort AxisNo);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_SetSlaveState")]
        public static extern int ECAT_SetSlaveState(ushort DeviceNo, ushort SlaveNo, ushort State);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_SetDeviceCmpDisable")]
        public static extern int ECAT_SetDeviceCmpDisable(ushort DeviceNo, ushort CmpNo);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McAxisTangentOut")]
        public static extern int ECAT_McAxisTangentOut(ushort DeviceNo, ushort AxisNo, ushort GroupNo);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McAxisMoveVelEx")]
        public static extern int ECAT_McAxisMoveVelEx(ushort DeviceNo, ushort AxisNo, double Vel);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McAxisMoveTorEx")]
        public static extern int ECAT_McAxisMoveTorEx(ushort DeviceNo, ushort AxisNo, double Torque);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McAxisGearInByPos")]
        public static extern int ECAT_McAxisGearInByPos(ushort DeviceNo, ushort MasterNo, ushort SlaveNo, int RatioNum, uint RationDen, ushort SyncSource, double MasterSynPos, double SlaveSynPos, double GearOutPos, double MaterialLength, double ReturnVel, ushort ReturnAcctime);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_GetSlaveTxPdoData_Ex")]
        public static extern int ECAT_GetSlaveTxPdoData_Ex(ushort DeviceNo, ushort SlaveNo, ushort OffsetByte, ushort DataSize, ref byte Data);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_GetSlaveTxPdoData_Ex")]
        public static extern int ECAT_GetSlaveTxPdoData_Ex(ushort DeviceNo, ushort SlaveNo, ushort OffsetByte, ushort DataSize, byte[] Data);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_GetSlaveRxPdoData_Ex")]
        public static extern int ECAT_GetSlaveRxPdoData_Ex(ushort DeviceNo, ushort SlaveNo, ushort OffsetByte, ushort DataSize, ref byte Data);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_GetSlaveRxPdoData_Ex")]
        public static extern int ECAT_GetSlaveRxPdoData_Ex(ushort DeviceNo, ushort SlaveNo, ushort OffsetByte, ushort DataSize, byte[] Data);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_Get_2074A")]
        public static extern int ECAT_Get_2074A(ushort DeviceNo, ushort SlaveNo, ushort ChannelNo, ref byte Status, ref byte InputCycleCounter, ref uint MultiTurn, ref int SingleTurn);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McSetAxisActualPositionBy35")]
        public static extern int ECAT_McSetAxisActualPositionBy35(ushort DeviceNo, ushort AxisNo, double Position);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetGroupPauseState")]
        public static extern int ECAT_McGetGroupPauseState(ushort DeviceNo, ushort GroupNo, ref ushort State);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGroupMoveLineAbs_Ex")]
        public static extern int ECAT_McGroupMoveLineAbs_Ex(ushort DeviceNo, ushort GroupNo, double[] Pos, double Vel);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGroupMoveLineRel_Ex")]
        public static extern int ECAT_McGroupMoveLineRel_Ex(ushort DeviceNo, ushort GroupNo, double[] Pos, double Vel);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGroupMoveLineAbsAdv_Ex")]
        public static extern int ECAT_McGroupMoveLineAbsAdv_Ex(ushort DeviceNo, ushort GroupNo, double[] EndPos, double StartVel, double ReqVel, double FinalVel, double Accel, double Decel, byte AccDecMode);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGroupMoveLineRelAdv_Ex")]
        public static extern int ECAT_McGroupMoveLineRelAdv_Ex(ushort DeviceNo, ushort GroupNo, double[] EndPos, double StartVel, double ReqVel, double FinalVel, double Accel, double Decel, byte AccDecMode);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McSetAxisHomeStable")]
        public static extern int ECAT_McSetAxisHomeStable(ushort DeviceNo, ushort AxisNo, double Time_s, double TimeOut_s, double PosRange);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetAxisHomeStable")]
        public static extern int ECAT_McGetAxisHomeStable(ushort DeviceNo, ushort AxisNo, ref double Time_s, ref double TimeOut_s, ref double PosRange);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McAxisMoveAbsAdv_Ex")]
        public static extern int ECAT_McAxisMoveAbsAdv_Ex(ushort DeviceNo, ushort AxisNo, double EndPos, double StartVel, double ReqVel, double FinalVel, double Accel, double Decel, byte AccDecMode);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McAxisMoveRelAdv_Ex")]
        public static extern int ECAT_McAxisMoveRelAdv_Ex(ushort DeviceNo, ushort AxisNo, double EndPos, double StartVel, double ReqVel, double FinalVel, double Accel, double Decel, byte AccDecMode);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_GetSlaveDI_Directly_16bit")]
        public static extern int ECAT_GetSlaveDI_Directly_16bit(ushort DeviceNo, ref uint Value);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_SetSlaveDIMap_16bit")]
        public static extern int ECAT_SetSlaveDIMap_16bit(ushort DeviceNo, ushort ChannelCnt, ushort[] SlaveNo, ushort[] Offset, ushort[] Dir);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_do_cfg_save")]
        public static extern int ECAT_do_cfg_save(ushort DeviceNo, ushort[] SlaveNo, ushort[] Offset, ushort[] Value, ushort SlaveCnt);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_do_cfg_load")]
        public static extern int ECAT_do_cfg_load(ushort DeviceNo);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_ClearDoQueue")]
        public static extern int ECAT_ClearDoQueue(ushort DeviceNo);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_PreSetSlaveDO")]
        public static extern int ECAT_PreSetSlaveDO(ushort DeviceNo, ushort SlaveNo, ushort Offset, ushort Value);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_SetSlaveRxPdoData_Ex")]
        public static extern int ECAT_SetSlaveRxPdoData_Ex(ushort DeviceNo, ushort SlaveNo, ushort OffsetByte, ushort DataSize, ref byte Data);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_SetSlaveRxPdoData_Ex")]
        public static extern int ECAT_SetSlaveRxPdoData_Ex(ushort DeviceNo, ushort SlaveNo, ushort OffsetByte, ushort DataSize, byte[] Data);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McAddAxisToGroup_Ex")]
        public static extern int ECAT_McAddAxisToGroup_Ex(ushort DeviceNo, ushort GroupNo, ushort AxisNo);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McRemoveAxisFromGroup_Ex")]
        public static extern int ECAT_McRemoveAxisFromGroup_Ex(ushort DeviceNo, ushort GroupNo, ushort AxisNo);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McUngroupAllAxes_Ex")]
        public static extern int ECAT_McUngroupAllAxes_Ex(ushort DeviceNo, ushort GroupNo);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McSetGroupCmdMode_Ex")]
        public static extern int ECAT_McSetGroupCmdMode_Ex(ushort DeviceNo, ushort GroupNo, ushort CmdMode);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McSetGroupAccDecType_Ex")]
        public static extern int ECAT_McSetGroupAccDecType_Ex(ushort DeviceNo, ushort GroupNo, ushort Type);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McSetGroupAccTime_Ex")]
        public static extern int ECAT_McSetGroupAccTime_Ex(ushort DeviceNo, ushort GroupNo, ushort Time_ms);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGroupMoveProfileCSV_Ex")]
        public static extern int ECAT_McGroupMoveProfileCSV_Ex(ushort DeviceNo, ushort GroupNo, ushort ProfileNo);
                
        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGroupMoveDwell_Ex")]
        public static extern int ECAT_McGroupMoveDwell_Ex(ushort DeviceNo, ushort GroupNo, uint Cnt);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGroupMoveBlendingSync_Ex")]
        public static extern int ECAT_McGroupMoveBlendingSync_Ex(ushort DeviceNo, ushort GroupNo);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetAxisActualPosVel_Ex")]
        public static extern int ECAT_McGetAxisActualPosVel_Ex(ushort DeviceNo, ushort AxisNo, ref float Pos, ref float Vel);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetAxisActualPosVel_Ex")]
        public static extern int ECAT_McGetAxisActualPosVel_Ex(ushort DeviceNo, ushort AxisNo, float[] Pos, float[] Vel);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McSetGroupVelLimitStatus_Ex")]
        public static extern int ECAT_McSetGroupVelLimitStatus_Ex(ushort DeviceNo, ushort GroupNo, ushort Status);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McSetGroupVelLimitValue_Ex")]
        public static extern int ECAT_McSetGroupVelLimitValue_Ex(ushort DeviceNo, ushort GroupNo, double Value);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetMotionRecordValue_Ex")]
        public static extern int ECAT_McGetMotionRecordValue_Ex(ushort DeviceNo, uint CountNo, ushort AxisNo, float[] Value1, float[] Value2);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetMotionRecordValue_Ex")]
        public static extern int ECAT_McGetMotionRecordValue_Ex(ushort DeviceNo, uint CountNo, ushort AxisNo, ref float Value1, ref float Value2);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McSetGroupHold_Ex")]
        public static extern int ECAT_McSetGroupHold_Ex(ushort DeviceNo, ushort GroupNo, ushort Status);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McSetGroupCmdModeEx_Ex")]
        public static extern int ECAT_McSetGroupCmdModeEx_Ex(ushort DeviceNo, ushort GroupNo, ushort CmdMode);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McSetGroupBlendingPercent_Ex")]
        public static extern int ECAT_McSetGroupBlendingPercent_Ex(ushort DeviceNo, ushort GroupNo, ushort Value);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetMotionRecordValueEx_Ex")]
        public static extern int ECAT_McGetMotionRecordValueEx_Ex(ushort DeviceNo, uint CountNo, ushort Count, ushort AxisNo, ref float Value1, ref float Value2, ref ushort ActualCount);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetMotionRecordValueEx_Ex")]
        public static extern int ECAT_McGetMotionRecordValueEx_Ex(ushort DeviceNo, uint CountNo, ushort Count, ushort AxisNo, float[] Value1, float[] Value2, ref ushort ActualCount);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McSetGroupBlendingPercentEx_Ex")]
        public static extern int ECAT_McSetGroupBlendingPercentEx_Ex(ushort DeviceNo, ushort GroupNo, ushort Value);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McSetGroupPause_Ex")]
        public static extern int ECAT_McSetGroupPause_Ex(ushort DeviceNo, ushort GroupNo, ushort Status);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_SetCheckSlaveCnt")]
        public static extern int ECAT_SetCheckSlaveCnt(ushort DeviceNo, int Enable);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGroupMoveShaker_Ex")]
        public static extern int ECAT_McGroupMoveShaker_Ex(ushort DeviceNo, ushort GroupNo, double Amp, double[] phase, double Freq, double Time);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McSetGroupPvtDecEnable_Ex")]
        public static extern int ECAT_McSetGroupPvtDecEnable_Ex(ushort DeviceNo, ushort GroupNo, ushort Enable);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McSetGroupCoordinate_Ex")]
        public static extern int ECAT_McSetGroupCoordinate_Ex(ushort DeviceNo, ushort GroupNo, ushort Type);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McSetGroupCoordinateLimit_Ex")]
        public static extern int ECAT_McSetGroupCoordinateLimit_Ex(ushort DeviceNo, ushort GroupNo, ushort Type, ushort Enable, double MIN_Value, double MAX_Value);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGetGroupCoordinateLimit_Ex")]
        public static extern int ECAT_McGetGroupCoordinateLimit_Ex(ushort DeviceNo, ushort GroupNo, ushort Type, ref ushort Enable, ref double MIN_Value, ref double MAX_Value);

	[DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_SetMultiSlaveDO_Ex")]
        public static extern int ECAT_SetMultiSlaveDO_Ex(ushort DeviceNo, ushort[] SlaveNo, uint[] Value, ushort SlaveCnt);

	[DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_GetMultiSlaveDO_Ex")]
        public static extern int ECAT_GetMultiSlaveDO_Ex(ushort DeviceNo, ushort[] SlaveNo, uint[] Value, ushort SlaveCnt);

	[DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_SetMultiSlaveDO_AutoOff_Ex")]
        public static extern int ECAT_SetMultiSlaveDO_AutoOff_Ex(ushort DeviceNo, ushort[] SlaveNo, uint[] Value, uint[] Width, uint[] Mask, ushort SlaveCnt);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGroupMoveCircularAbs_CP_Angle_Ex")]
        public static extern int ECAT_McGroupMoveCircularAbs_CP_Angle_Ex(ushort DeviceNo, ushort GroupNo, double Vel, double Angle, double[] AuxPos);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGroupMoveCircularAbs_CP_EP_Ex")]
        public static extern int ECAT_McGroupMoveCircularAbs_CP_EP_Ex(ushort DeviceNo, ushort GroupNo, double Vel, byte Dir, double[] AuxPos, double[] EndPos);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGroupMoveCircularAbs_BP_EP_Ex")]
        public static extern int ECAT_McGroupMoveCircularAbs_BP_EP_Ex(ushort DeviceNo, ushort GroupNo, double Vel, byte Dir, double[] AuxPos, double[] EndPos);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGroupMove3DCircularAbs_CP_Angle_Ex")]
        public static extern int ECAT_McGroupMove3DCircularAbs_CP_Angle_Ex(ushort DeviceNo, ushort GroupNo, double Vel, double Angle, double[] AuxPos, double[] NV);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGroupMove3DCircularAbs_CP_EP_Ex")]
        public static extern int ECAT_McGroupMove3DCircularAbs_CP_EP_Ex(ushort DeviceNo, ushort GroupNo, double Vel, byte Dir, double[] AuxPos, double[] EndPos);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGroupMove3DCircularAbs_BP_EP_Ex")]
        public static extern int ECAT_McGroupMove3DCircularAbs_BP_EP_Ex(ushort DeviceNo, ushort GroupNo, double Vel, byte Dir, double[] AuxPos, double[] EndPos);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGroupMoveCircularRel_Ex")]
        public static extern int ECAT_McGroupMoveCircularRel_Ex(ushort DeviceNo, ushort GroupNo, double Angle, double[] AuxPos, double Vel);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGroupMoveCircularRel_CP_Angle_Ex")]
        public static extern int ECAT_McGroupMoveCircularRel_CP_Angle_Ex(ushort DeviceNo, ushort GroupNo, double Vel, double Angle, double[] AuxPos);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGroupMoveCircularRel_CP_EP_Ex")]
        public static extern int ECAT_McGroupMoveCircularRel_CP_EP_Ex(ushort DeviceNo, ushort GroupNo, double Vel, byte Dir, double[] AuxPos, double[] EndPos);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGroupMoveCircularRel_BP_EP_Ex")]
        public static extern int ECAT_McGroupMoveCircularRel_BP_EP_Ex(ushort DeviceNo, ushort GroupNo, double Vel, byte Dir, double[] AuxPos, double[] EndPos);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGroupMove3DCircularRel_CP_Angle_Ex")]
        public static extern int ECAT_McGroupMove3DCircularRel_CP_Angle_Ex(ushort DeviceNo, ushort GroupNo, double Vel, double Angle, double[] AuxPos, double[] NV);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGroupMove3DCircularRel_CP_EP_Ex")]
        public static extern int ECAT_McGroupMove3DCircularRel_CP_EP_Ex(ushort DeviceNo, ushort GroupNo, double Vel, byte Dir, double[] AuxPos, double[] EndPos);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGroupMove3DCircularRel_BP_EP_Ex")]
        public static extern int ECAT_McGroupMove3DCircularRel_BP_EP_Ex(ushort DeviceNo, ushort GroupNo, double Vel, byte Dir, double[] AuxPos, double[] EndPos);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGroupMoveHelicalAbs_Ex")]
        public static extern int ECAT_McGroupMoveHelicalAbs_Ex(ushort DeviceNo, ushort GroupNo, double Angle, double[] AuxPos, double Pitch, double Vel);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGroupMove3DHelicalAbs_CP_Angle_Ex")]
        public static extern int ECAT_McGroupMove3DHelicalAbs_CP_Angle_Ex(ushort DeviceNo, ushort GroupNo, double Vel, double Angle, double Pitch, double[] AuxPos, double[] NV);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGroupMoveHelicalRel_Ex")]
        public static extern int ECAT_McGroupMoveHelicalRel_Ex(ushort DeviceNo, ushort GroupNo, double Angle, double[] AuxPos, double Pitch, double Vel);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGroupMove3DHelicalRel_CP_Angle_Ex")]
        public static extern int ECAT_McGroupMove3DHelicalRel_CP_Angle_Ex(ushort DeviceNo, ushort GroupNo, double Vel, double Angle, double Pitch, double[] AuxPos, double[] NV);
        
        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGroupMoveConicalHelixAbs_Ex")]
        public static extern int ECAT_McGroupMoveConicalHelixAbs_Ex(ushort DeviceNo, ushort GroupNo, double Angle, double[] AuxPos, double Pitch, double Vel, double EndRadius);
        
        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGroupMove3DConicalHelixAbs_CP_Angle_Ex")]
        public static extern int ECAT_McGroupMove3DConicalHelixAbs_CP_Angle_Ex(ushort DeviceNo, ushort GroupNo, double Vel, double Angle, double Pitch, double[] AuxPos, double[] NV, double EndRadius);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGroupMoveConicalHelixRel_Ex")]
        public static extern int ECAT_McGroupMoveConicalHelixRel_Ex(ushort DeviceNo, ushort GroupNo, double Angle, double[] AuxPos, double Pitch, double Vel, double EndRadius);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGroupMove3DConicalHelixRel_CP_Angle_Ex")]
        public static extern int ECAT_McGroupMove3DConicalHelixRel_CP_Angle_Ex(ushort DeviceNo, ushort GroupNo, double Vel, double Angle, double Pitch, double[] AuxPos, double[] NV, double EndRadius);
                
        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGroupMoveProfile_Ex")]
        public static extern int ECAT_McGroupMoveProfile_Ex(ushort DeviceNo, ushort GroupNo, ushort[] ProfileNo, ushort TotalStep);        

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGroupMoveLineAbs_PT_Ex")]
        public static extern int ECAT_McGroupMoveLineAbs_PT_Ex(ushort DeviceNo, ushort GroupNo, double[] Pos, double Time);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McGroupMoveLineRel_PT_Ex")]
        public static extern int ECAT_McGroupMoveLineRel_PT_Ex(ushort DeviceNo, ushort GroupNo, double[] Pos, double Time);

        [DllImport("libecatdevice.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "ECAT_McEnable_Directly_Ex")]
        public static extern int ECAT_McEnable_Directly_Ex(ushort DeviceNo);

    }
}
